<?php
/*************************************************
Author: JoomClan.com
Creation Date: 2009-11-25
Author Email: joomclan@gmail.com
Url: http://www.joomclan.com
Copyright: 2009-2010
License: GNU
Component Version: 2.1.7
Software License: All of our PHP and HTML source code is released under the GNU General Public License (GPL) to ensure it is 100% compatible with Joomla!. 
The GPL is the world's most popular Free (as in Freedom) and Open Source Software license.
Some javascript and other media (images, css, ajax scripts, flv players, mp3 players etc …) may be released under different licenses. Please see the details with the individual products.
**************************************************/

defined('_JEXEC') or die('Restricted access');

class pvgNode{
	var $_id;
	var $_value;
	var	$_text;
	var $_hasChild = false;
	var $_level=0;
	var $_children;
	var $_selected;
	
	function __construct($id = 0, $value='', $text='', $selected = false){
		$this->_id = (int)$id;
		$this->_value = $value;
		$this->_text = $text;
		$this->_selected = $selected;
		$this->_children = array();
	}
	
	function appendChild($child){
		$this->_hasChild = true;
		$this->_children[] = $child;
	}
	
	function getChildren(){
		return $this->_children;
	}
	
	function getId(){
		return $this->_id;
	}
	
	function setLevel($level){
		$this->_level = $level;
	}
	
	function getLevel(){
		return $this->_level;
	}
	
	function hasChild(){
		return $this->_hasChild;
	}
	
	function renderNode(){
		$level = "";
		for($i=0; $i< $this->_level;$i++){
			$level .=" &raquo; ";
		}
		if($this->_selected){
			$text = "<option value='".$this->_value."' selected='selected'>". $level . $this->_text."</option>";
		}else{
			$text = "<option value='".$this->_value."'>". $level . $this->_text."</option>";
		}
		return $text;
	}
	
	
	function getPrepend(){
		return '';
	}
	
	function getAppend(){
		
	}
	
}

class pvgTree{
	var $_root;
	
	function __construct($root){
		$this->_root = $root;
	}
	
	function findNode($id){
		$notFound = false;
		$queue = array();
		array_push($queue, $this->_root);
		while(count($queue)> 0){
			$p = array_shift($queue);
			if($p->getId() == $id){
				return $p;
			}else{
				$notFound = true;
				$children = $p->getChildren();
				if(count($children) > 0){
					foreach($children as $c){
						array_push($queue, $c);
					}
				}
			}
		}
		if($notFound){
			return $this->_root;
		}
	}
	
	function appendChild($id, $child){
		$node = $this->findNode((int)$id);
		$level = $node->getLevel();
		$child->setLevel(++$level);
		$node->appendChild($child);
	}
	
	function renderTree($name = 'category', $multiple = false, $topLevel = 'All Level', $required = false, $full = true){
		$text = array();
		$level = 0;
		$pre_level = 0;
		$stack = array();
		$first = true;
		$ret = null;
		$children = $this->_root->getChildren();
		if(count($children)> 0){
			$children = array_reverse($children);
			foreach($children as $c){
				array_push($stack, $c);
			}
		}
		while(count($stack)> 0){
			$p = array_pop($stack);
			$level = $p->getLevel();
			$text[] = $p->renderNode();
			$children = $p->getChildren();
			if(count($children)> 0){
				$children = array_reverse($children);
				foreach($children as $c){
					array_push($stack, $c);
				}
			}
		}
		if($full){
			if($multiple){
				$ret = "<select name='".$name."[]' multiple = 'multiple' size='10' id='".$name."'>";
			}else{
				if($required){
					$ret = "<select name='".$name."' id='".$name."' class='required validate-category'>";
				}
				else{
					$ret = "<select name='".$name."' id='".$name."'>";
				}
			}
		}
		$ret .="<option value=''>".JText::_($topLevel)."</option>";
		$ret .= implode("", $text);
		if($full){
			$ret .="</select>";
		}
		return $ret;
	}
	
	function getAllChildAndGrand($id){
		$ret = array();
		$stack = array();
		$node = $this->findNode($id);
		$children = $node->getChildren();
		if(count($children)> 0){
			$children = array_reverse($children);
			foreach($children as $c){
				array_push($stack, $c);
				array_push($ret, $c);
			}
		}
		while(count($stack)> 0){
			$p = array_pop($stack);
			$children = $p->getChildren();
			if(count($children)> 0){
				$children = array_reverse($children);
				foreach($children as $c){
					array_push($stack, $c);
					array_push($ret, $c);
				}
			}
		}
		return $ret;
	}
	
}

class pvgNode2 extends pvgNode{
	
	var $_cat_id;
	var $_cat_title;
	var $_link;
	var $_parent_id;
	var $_adcount;
	var $_section_id;
	
	function __construct($id = 0, $cat_id='', $cat_title='', $parent_id='', $link = '', $adcount = '', $section_id = ''){
		$this->_id = (int)$id;
		$this->_cat_id = $cat_id;
		$this->_section_id = $section_id;
		$this->_cat_title = $cat_title;
		$this->_parent_id = $parent_id;
		$this->_link = $link;
		$this->_adcount = $adcount;
		$this->_children = array();
	}
	
	function renderNode(){
		$text = '';
		if($this->getLevel() == 1){
			$text .= '<div class="ctitle">'."\n";
			$text .= '<a href="'.$this->_link.'">'.$this->_cat_title.'</a>'."\n";
			$text .= '</div>'."\n";
		}else{
			$level_text = '';
			for($i=0; $i< $this->getLevel()-1;$i++){
				$level_text .=" &raquo; ";
			}
			$text .= '<div>'."\n";
			$text .= '<a href="'.$this->_link.'">'. $level_text .$this->_cat_title.'</a>'."\n";
			$text .= '</div>'."\n";
		}
//		if(!$this->hasChild() && $this->getLevel() > 1){
//			$text .= '</div>'."\n";
//		}
		return $text;
	}
	
	function getPrepend($break = false){
		$text = '';
		if($break){
			$text .= '<div style="clear:both"></div>';
		}
		if($this->getLevel() == 1){
			$text .= '<div class="floatitem">'."\n";
		}
		return $text;
	}

	function getPrepend2($break = false){
		$text = '';
		if($break){
			$text .= '<div style="clear:both"></div>';
		}
		return $text;
	}
	
	function getAppend(){
		$text = '';
		if($this->getLevel() == 1 && !$this->hasChild()){
			$text .= '</div>'."\n";
		}
		
		return $text;
	}
	
	function getAppend2(){
		$text = '';
		if($this->getLevel() == 1 && !$this->hasChild()){
			//$text .= '</div>'."\n";
		}
		
		return $text;
	}
	
	function renderNode2($showLink = true, $showCounter = true){
		$text = '';
		$level_text = '';
		for($i=0; $i< $this->getLevel()-1;$i++){
			$level_text .=" &raquo; ";
		}
		if($showLink){
			$text .= '<a style="display:block;" href="'.$this->_link.'">'. $level_text .$this->_cat_title;
			if($showCounter){
				$text .="(".$this->_adcount.")";
			}
			$text .= '</a>'."\n";			
		}else{
			$text .= '<a style="display:block;">'. $level_text .$this->_cat_title;
			if($showCounter){
				$text .="(".$this->_adcount.")";
			}
			$text .= '</a>'."\n";
		}
		return $text;
	}
	
	function getSectionId(){
		return $this->_section_id;
	}
}


class pvgTree2 extends pvgTree{
	
	function renderTree(){
		$text = "";
		$level = 0;
		$pre_level = 0;
		$stack = array();
		$first = true;
		$count = 0;
		$children = $this->_root->getChildren();
		if(count($children)> 0){
			$children = array_reverse($children);
			foreach($children as $c){
				array_push($stack, $c);
			}
		}
		
		while(count($stack)> 0){
			$p = array_pop($stack);
			$level = $p->getLevel();
			if($level == 1 && !$first && $pre_level > 1){
				$text .= "</div>\n";
			}
			if($level == 1){
				$count++;
			}
			if($count == 4){
				$text .= $p->getPrepend(true);
				$count = 0;
			}
			else{
				$text .= $p->getPrepend();
			}
			$text .= $p->renderNode();
			$text .= $p->getAppend();
			$children = $p->getChildren();
			if(count($children)> 0){
				$children = array_reverse($children);
				foreach($children as $c){
					array_push($stack, $c);
				}
			}
			if(count($stack) == 0){
				while(--$level >= 1){
					$text .="</div>\n";
				}
			}
			$pre_level = $level;
			$first = false;
		}
		return $text;
	}
	
	function renderTree2($rid, $showLink = true, $showCounter = true){
		$text = "";
		$level = 0;
		$pre_level = 0;
		$stack = array();
		$first = true;
		$children = $this->_root->getChildren();
		if(count($children)> 0){
			$children = array_reverse($children);
			foreach($children as $c){
				array_push($stack, $c);
			}
		}
		
		while(count($stack)> 0){
			$p = array_pop($stack);
			$level = $p->getLevel();
			if($level == 1 && !$first && $pre_level > 1){
				//$text .= "</div>\n";
			}
			$text .= $p->getPrepend2();
			$text .= $p->renderNode2($showLink, $showCounter);
			$text .= $p->getAppend2();
			$children = $p->getChildren();
			if(count($children)> 0){
				$children = array_reverse($children);
				foreach($children as $c){
					array_push($stack, $c);
				}
			}
			if(count($stack) == 0){
				while(--$level >= 1){
					//$text .="</div>\n";
				}
			}
			$pre_level = $level;
			$first = false;
		}
		return "<div class='list' id='sub-cat-".$rid."' >".$text."</div>";
	}
	
	function renderTree22($rid, $showLink = true, $showCounter = true){
		$text = "";
		$level = 0;
		$pre_level = 0;
		$stack = array();
		$first = true;
		$node = $this->findNode($rid);
		$children = $node->getChildren();
		if(count($children)> 0){
			$children = array_reverse($children);
			foreach($children as $c){
				array_push($stack, $c);
			}
		}
		
		while(count($stack)> 0){
			$p = array_pop($stack);
			$level = $p->getLevel();
			if($level == 1 && !$first && $pre_level > 1){
				//$text .= "</div>\n";
			}
			$text .= $p->getPrepend2();
			$text .= $p->renderNode2($showLink, $showCounter);
			$text .= $p->getAppend2();
			$children = $p->getChildren();
			if(count($children)> 0){
				$children = array_reverse($children);
				foreach($children as $c){
					array_push($stack, $c);
				}
			}
			if(count($stack) == 0){
				while(--$level >= 1){
					//$text .="</div>\n";
				}
			}
			$pre_level = $level;
			$first = false;
		}
		return "<div class='list' id='sub-cat-".$rid."' >".$text."</div>";
	}
	
	function getRootChildren(){
		return $this->_root->getChildren();
	}
	
}