<?php
/*************************************************
Author: JoomClan.com
Creation Date: 2009-11-25
Author Email: joomclan@gmail.com
Url: http://www.joomclan.com
Copyright: 2009-2010
License: GNU
Component Version: 2.1.7
Software License: All of our PHP and HTML source code is released under the GNU General Public License (GPL) to ensure it is 100% compatible with Joomla!. 
The GPL is the world's most popular Free (as in Freedom) and Open Source Software license.
Some javascript and other media (images, css, ajax scripts, flv players, mp3 players etc …) may be released under different licenses. Please see the details with the individual products.
**************************************************/

defined('_JEXEC') or die('Restricted access');


switch($task){
	case 'add':
		editCategory(false,$option);
		break;
	case 'edit':
		editCategory(true,$option);
		break;
	case 'publish':
		publishCategory($task,$option);
		break;
	case 'unpublish':
		publishCategory($task,$option);
		break;
	case 'apply':
	case 'save':
		saveCategory($option,$task);
		break;
	case 'remove':
		removeCategory($option);
		break;
	case 'orderup' :
		orderCategory(-1,$option);
		break;
	case 'orderdown' :
		orderCategory(1,$option);
		break;
	case 'saveorder':
		saveCategoryOrder( $cid,$option );
		break;
	default:
		listCategories($option,$module);
}

/**
 * Edit Category
 *
 * @param boolean $edit
 * @param string $option
 */
function editCategory($edit,$option)
{
	global $mainframe;

	$db =& JFactory::getDBO();
	$cid			= JRequest::getVar( 'cid', array(0), '', 'array' );
	JArrayHelper::toInteger($cid, array(0));
	$id				= JRequest::getVar( 'id', $cid[0], '', 'int' );
	$option			= JRequest::getCmd( 'option' );
	$row = &JTable::getInstance('joomcategories','Table');
	$appendQuery = "";
	$lists = array();
	if($edit){
		//$appendQuery = " WHERE c.id != $id";
		$row->load($id);
		$query = "SELECT * FROM #__jlcategories AS c WHERE c.parent_id = $row->parent_id";
		$db->setQuery( $query );
		$cat = $db->loadObject();
		$cats[] = JHTML::_('select.option', $cat->parent_id, $cat->title, 'value', 'text');
		$lists['categories'] = JHTML::_('select.genericlist', $cats, 'parent_id', 'class="inputbox" size="1" disabled="disabled"', 'value', 'text', $row->parent_id );
	}
	else{
		$cats[] = JHTML::_('select.option', '0', JText::_('Select category'), 'value', 'text');
		$lists['categories'] = JHTML::_('select.genericlist', $cats, 'parent_id', 'class="inputbox" size="1" disabled="disabled"', 'value', 'text', $row->parent_id );
	}
	$query = "SELECT title as text, id as value from #__jlsections";
	$db->setQuery( $query );
	$sections2 = $db->loadObjectList();
	$sections1[] = JHTML::_('select.option', '0', JText::_('Select Section'), 'value', 'text');
	$sections = array_merge($sections1, $sections2);
	$lists['sections'] = JHTML::_('select.genericlist',   $sections, 'section_id', 'class="inputbox" size="1"', 'value', 'text', $row->section_id );
	$lists['published']=JHTML::_('select.booleanlist', 'published', 'class="inputbox"', $row->published);
	$lists['enable_twitter']=JHTML::_('select.booleanlist', 'enable_twitter', 'class="inputbox"', $row->enable_twitter);
	$lists['hideef']=JHTML::_('select.booleanlist','hideef','class="inputbox"',$row->hideef);
	HTML_categories::editCategory($row,$lists,$option);
}
/**
 * Lists Category
 *
 * @param unknown_type $option
 * @param unknown_type $module
 * @return unknown
 */

function listCategories($option,$module)
{
	global $mainframe;
	JToolBarHelper::title(JText::_('Categories'),'categories.png');
	$limit=JRequest::getVar('limit',$mainframe->getCfg('list_limit'));
	$limitstart=JRequest::getVar('limitstart',0);

	$filter_order		= $mainframe->getUserStateFromRequest( $option.$module.'filter_order', 		'filter_order', 	'c.ordering',	'cmd' );
	$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.$module.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );

	$orderby 	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', c.ordering';

	$db=& JFactory::getDBO();
	$query="SELECT count(*) from #__jlcategories";
	$db->setQuery($query);
	$total=$db->loadResult();
	$query ="SELECT c.*, ifnull(c2.title, 'Top Level') as parent, ifnull(c3.title,'No Section') as section,
			(SELECT COUNT(*) FROM #__joomlistings WHERE catid=c.id) as listcounts FROM #__jlcategories as c 
			LEFT JOIN #__jlcategories as c2 on c.parent_id=c2.id left join #__jlsections as c3 on c.section_id=c3.id ". $orderby;
	$db->setQuery($query,$limitstart,$limit);
	$rows=$db->loadObjectList();
	if($db->getErrorNum())
	{
		echo $db->stderr();
		return false;
	}
	jimport('joomla.html.pagination');
	$pagenav=new JPagination($total,$limitstart,$limit);
	$lists=array();
	$lists['order_Dir']	= $filter_order_Dir;
	$lists['order']		= $filter_order;
	HTML_Categories::listCategories($rows,$pagenav,$lists,$option);

}
/**
 * Publishes Category
 *
 * @param unknown_type $task
 * @param unknown_type $option
 */
function publishCategory($task,$option)
{
	global $mainframe;
	$cid=JRequest::getVar('cid',array(),'','array');
	if($task=='publish')
	{
		$publish='1';
		$msg="Category/Categories Published Successfully";
	}
	else
	{
		$publish='0';
		$msg="Category/Categories Unpublished Successfully";
	}
	$catTable=& JTable::getInstance('joomcategories','Table');
	JRequest::setVar( 'hidemainmenu', 1 );
	$editor=&JFactory::getEditor();
	$catTable->publish($cid,$publish);
	$mainframe->redirect("index.php?option=$option&module=categories",$msg);

}
/**
 * Save Category
 *
 * @param unknown_type $option
 * @param unknown_type $task
 */
function saveCategory($option,$task)
{
	global $mainframe;
	$row = JTable::getInstance('joomcategories','Table');
	if(!$row->bind(JRequest::get('post')))
	{
		echo "<script> alert('".$row->getError()."');
		window.history.go(-1); </script>";
		exit();
	}
	if (!$row->id) {
		$row->ordering = $row->getNextOrder( );
	}
//	var_dump($row);die();
	if(!$row->store())
	{
		echo "<script> alert('".$row->getError()."');
		window.history.go(-1); </script>";
		exit();
	}

	switch($task)
	{
		case 'apply':
			$msg="Changes to Category Saved";
			$link="index.php?option=$option&module=categories&task=edit&cid[]=".$row->id;
			break;
		case 'save':
			$msg="Category Successfully Saved";
			$link="index.php?option=$option&module=categories";
			break;
	}
	$mainframe->redirect($link,JText::_($msg));
}
/**
 * Remove Category
 *
 * @param unknown_type $option
 */
function removeCategory($option){
	global $mainframe;
	$cid = JRequest::getVar('cid',array(),'','array');
	$db =& JFactory::getDBO();
	if(count($cid)){
		$cids = implode(',',$cid);
		$query = "SELECT parent_id, title, count(*) AS num_childs FROM #__jlcategories WHERE parent_id IN ($cids) GROUP BY parent_id";
		$db->setQuery($query);
		$objs = $db->loadObjectList();
		if(count($objs)<1){
			$query = "DELETE from #__jlcategories where id in ($cids)";
			$db->setQuery($query);
			if(!$db->query())
			{
				echo "<script> alert('".$db->getErrorMsg()."');
				window.history.go(-1); </script>\n";
			}
			$mainframe->redirect("index.php?option=com_joomlistings&module=categories", JText::_('Category/Categories deleted successfully'));
		}
		else{
			$title = array();
			foreach($objs as $obj){
				$title[] = $obj->title;
			}
			JError::raiseWarning( 100, "Can not delete the category: ". implode(", ", $title). ". It have child category");
			$mainframe->redirect("index.php?option=com_joomlistings&module=categories");
		}
	}
}
/**
 * Order Category
 *
 * @param unknown_type $direction
 */

function orderCategory($direction,$option)
{
	global $mainframe;


	// Initialize variables
	$db		= & JFactory::getDBO();

	$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );

	if (isset( $cid[0] ))
	{
		$row = & JTable::getInstance('joomcategories','Table');
		$row->load( (int) $cid[0] );
		$row->move($direction, '' );
	}

	$mainframe->redirect("index.php?option=$option&module=categories");
}
/**
 * saveCategoryOrder
 *
 * @param unknown_type $cid
 */
function saveCategoryOrder( &$cid,$option )
{
	global $mainframe;


	// Initialize variables
	$db			=& JFactory::getDBO();
	$total		= count( $cid );
	$order 		= JRequest::getVar( 'order', array(0), 'post', 'array' );
	JArrayHelper::toInteger($order, array(0));

	$row =& JTable::getInstance('joomcategories', 'Table');
	$groupings = array();

	// update ordering values
	for( $i=0; $i < $total; $i++ ) {
		$row->load( (int) $cid[$i] );
		// track categories

		if ($row->ordering != $order[$i]) {
			$row->ordering = $order[$i];
			if (!$row->store()) {
				JError::raiseError(500, $db->getErrorMsg() );
			}
		}
	}

	$msg 	= 'New ordering saved';
	$mainframe->redirect( "index.php?option=$option&module=categories", $msg );
}
/*----------------------------------------------*/

?>