<?php
/*************************************************
Author: JoomClan.com
Creation Date: 2009-11-25
Author Email: joomclan@gmail.com
Url: http://www.joomclan.com
Copyright: 2009-2010
License: GNU
Component Version: 2.1.7
Software License: All of our PHP and HTML source code is released under the GNU General Public License (GPL) to ensure it is 100% compatible with Joomla!. 
The GPL is the world's most popular Free (as in Freedom) and Open Source Software license.
Some javascript and other media (images, css, ajax scripts, flv players, mp3 players etc …) may be released under different licenses. Please see the details with the individual products.
**************************************************/

defined('_JEXEC') or die('Restricted Access');

switch($task)
{
	case 'add':
		edit(false,$option);
		break;
	case 'edit':
		edit(true,$option);
		break;
	case 'publish':
		publish($task,$option);
		break;
	case 'unpublish':
		publish($task,$option);
		break;
	case 'apply':
	case 'save':
		save($option,$task);
		break;
	case 'remove':
		remove($option);
		break;
	case 'orderup' :
		order(-1,$option);
		break;
	case 'orderdown' :
		order(1,$option);
		break;
	case 'saveorder':
		saveOrder( $cid,$option );
		break;
	default:
		listAll($option,$module);
		break;

}

define('AD_VIEW',1);
define('AD_POST',2);
define('AD_EDIT',3);
define('AD_FEATURED',4);
define('AD_EXPIRED',5);
define('AD_ABOUTTOEXPIRE',6);
define('AD_SUSPENDED',7);
define('AD_RESUMED',8);
define('COMMENT_POST',9);
define('COMMENT_VIEW',10);
define('MSG_SEND',11);
define('MSG_READ',12);
define('PACKAGE_BUY',13);
define('PACKAGE_EXPIRE',14);
define('PACKAGE_ABOUTTOEXPIRE',15);
define('PAYMENT_RECEIVED',16);
define('PAYMENT_NOTRECEIVED',17);

/*-------------------group FUNCTIONS--------------------------------------*/
/**
 * Edit
 *
 * @param boolean $edit
 * @param string $option
 */
function edit($edit,$option)
{
	global $mainframe;


	$db=JFactory::getDBO();

	$cid			= JRequest::getVar( 'cid', array(0), '', 'array' );
	JArrayHelper::toInteger($cid, array(0));
	$id				= JRequest::getVar( 'id', $cid[0], '', 'int' );
	$option			= JRequest::getCmd( 'option' );

	$row=&JTable::getInstance('email','Table');

	if($edit)
	{
		$row->load($id);
	}
	$lists=array();

	$events=array();
	$events[] = JHTML::_('select.option', 'adview', JText::_( 'Ad Viewed' ), 'id', 'title');
	$events[] = JHTML::_('select.option', 'adpost', JText::_( 'Ad Posted' ), 'id', 'title');
	$events[] = JHTML::_('select.option', 'adedit', JText::_( 'Ad Edited' ), 'id', 'title');
	$events[] = JHTML::_('select.option', 'adpublished', JText::_( 'Ad Published' ), 'id', 'title');
	$events[] = JHTML::_('select.option', 'adfeatured', JText::_( 'Ad Featured' ), 'id', 'title');
	$events[] = JHTML::_('select.option', 'adcolored', JText::_( 'Ad Colored' ), 'id', 'title');
	$events[] = JHTML::_('select.option', 'adexpired', JText::_( 'Ad Expired' ), 'id', 'title');
	$events[] = JHTML::_('select.option', 'adabouttoexpire', JText::_( 'Ad About To Expire' ), 'id', 'title');
	$events[] = JHTML::_('select.option', 'adsuspend', JText::_( 'Ad Suspended' ), 'id', 'title');
	$events[] = JHTML::_('select.option', 'adresumed', JText::_( 'Ad Resumed' ), 'id', 'title');

	$events[] = JHTML::_('select.option', 'msgsend', JText::_( 'Message Sent' ), 'id', 'title');
	$events[] = JHTML::_('select.option', 'msgreply', JText::_( 'Message Reply' ), 'id', 'title');
	$events[] = JHTML::_('select.option', 'msgread', JText::_( 'Message Read' ), 'id', 'title');
	$events[] = JHTML::_('select.option', 'packagebuy', JText::_( 'Package Bought' ), 'id', 'title');
	$events[] = JHTML::_('select.option', 'packageexpire', JText::_( 'Package Expired' ), 'id', 'title');
	$events[] = JHTML::_('select.option', 'packageabouttoexpire', JText::_( 'Package About To Expire' ), 'id', 'title');
	$events[] = JHTML::_('select.option', 'paymentreceived', JText::_( 'Payment Received' ), 'id', 'title');
	$events[] = JHTML::_('select.option', 'paymentnotreceived', JText::_( 'Payment Not Received' ), 'id', 'title');
	$events[] = JHTML::_('select.option', 'cleanup', JText::_( 'Clean Up --Admin Only' ), 'id', 'title');
	$events[] = JHTML::_('select.option', 'error', JText::_( 'Error Reporting --Admin Only' ), 'id', 'title');

	

	$options=array();
	$options[] = JHTML::_('select.option', 0, JText::_( 'To User' ), 'id', 'title');
	$options[] = JHTML::_('select.option', 1, JText::_( 'To Admin' ), 'id', 'title');
	
	$lists['events'] = JHTML::_('select.genericlist',  $events, 'event', 'class="inputbox" size="1"', 'id', 'title', $row->event);
	$lists['mailto'] = JHTML::_('select.radiolist',  $options, 'mailto', 'class="inputbox"', 'id', 'title', intval($row->mailto));
	$lists['published']=JHTML::_('select.booleanlist','published','class="inputbox"',$row->published);
	
	HTML_generic::edit($row,$lists,$option);
}
/**
 * Lists
 *
 * @param unknown_type $option
 * @param unknown_type $module
 * @return unknown
 */

function listAll($option,$module)
{
	global $mainframe;
	$limit=JRequest::getVar('limit',$mainframe->getCfg('list_limit'));
	$limitstart=JRequest::getVar('limitstart',0);

	$filter_order		= $mainframe->getUserStateFromRequest( $option.$module.'filter_order', 		'filter_order', 	'c.ordering',	'cmd' );
	$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.$module.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );
	$search				= $mainframe->getUserStateFromRequest( $option.$module.'search',			'search',			'',	'string' );


	$orderby 	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', c.ordering';

	$searchx="";

	if(!empty($search))
	{
		$searchx=" Where c.title like '%$search%'";
	}

	$db=& JFactory::getDBO();
	$query="SELECT count(*) from #__jlmailformats $searchx";
	$db->setQuery($query);
	$total=$db->loadResult();



	$query ="SELECT c.* from #__jlmailformats as c $searchx ". $orderby;
	$db->setQuery($query,$limitstart,$limit);
	$rows=$db->loadObjectList();
	if($db->getErrorNum())
	{
		echo $db->stderr();
		return false;
	}
	jimport('joomla.html.pagination');
	$pagenav=new JPagination($total,$limitstart,$limit);
	$lists=array();
	$lists['order_Dir']	= $filter_order_Dir;
	$lists['order']		= $filter_order;
	$lists['search'] = $search;
	HTML_generic::listAll($rows,$pagenav,$lists,$option);

}
/**
 * Publishes Category
 *
 * @param unknown_type $task
 * @param unknown_type $option
 */
function publish($task,$option)
{
	global $mainframe;
	$cid=JRequest::getVar('cid',array(),'','array');
	if($task=='publish')
	{
		$publish='1';
		$msg="Email Template(s) Published Successfully";
	}
	else
	{
		$publish='0';
		$msg="Email Template(s) Unpublished Successfully";
	}
	$catTable=& JTable::getInstance('email','Table');
	JRequest::setVar( 'hidemainmenu', 1 );
	$editor=&JFactory::getEditor();
	$catTable->publish($cid,$publish);
	$mainframe->redirect("index.php?option=$option&module=email",$msg);

}
/**
 * Save
 *
 * @param unknown_type $option
 * @param unknown_type $task
 */
function save($option,$task)
{
	global $mainframe;
	$row=JTable::getInstance('email','Table');
	if(!$row->bind(JRequest::get('post')))
	{
		echo "<script> alert('".$row->getError()."');
		window.history.go(-1); </script>";
		exit();
	}
	if (!$row->id) {
		$row->ordering = $row->getNextOrder( );
	}

	$row->body = JRequest::getVar( 'body', '', 'post', 'string', JREQUEST_ALLOWRAW );

	if(!$row->store())
	{
		echo $row->getError();
		echo "<script> alert('".$row->getError()."');
		window.history.go(-1); </script>";
		exit();
	}

	switch($task)
	{
		case 'apply':
			$msg="Changes to Email Template Saved";
			$link="index.php?option=$option&module=email&task=edit&cid[]=".$row->id;
			break;
		case 'save':
			$msg="Email Template Saved";
			$link="index.php?option=$option&module=email";
			break;
	}
	$mainframe->redirect($link,JText::_($msg));
}
/**
 * Remove
 *
 * @param unknown_type $option
 */
function remove($option)
{
	global $mainframe;
	$cid=JRequest::getVar('cid',array(),'','array');
	$db=JFactory::getDBO();
	if(count($cid))
	{
		$cids=implode(',',$cid);
		$query="DELETE from #__jlmailformats where id in ($cids)";
		$db->setQuery($query);
		if(!$db->query())
		{
			echo "<script> alert('".$db->getErrorMsg()."');
			window.history.go(-1); </script>\n";
		}
		$mainframe->redirect("index.php?option=$option&module=email",JText::_('Email Template(s) deleted successfully'));
	}
}
/**
 * Order
 *
 * @param unknown_type $direction
 */

function order($direction,$option)
{
	global $mainframe;


	// Initialize variables
	$db		= & JFactory::getDBO();

	$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );

	if (isset( $cid[0] ))
	{
		$row = & JTable::getInstance('email','Table');
		$row->load( (int) $cid[0] );
		$row->move($direction, '' );
	}

	$mainframe->redirect("index.php?option=$option&module=email");
}
/**
 * saveCategoryOrder
 *
 * @param unknown_type $cid
 */
function saveOrder( &$cid,$option )
{
	global $mainframe;


	// Initialize variables
	$db			=& JFactory::getDBO();
	$total		= count( $cid );
	$order 		= JRequest::getVar( 'order', array(0), 'post', 'array' );
	JArrayHelper::toInteger($order, array(0));

	$row =& JTable::getInstance('email', 'Table');
	$groupings = array();

	// update ordering values
	for( $i=0; $i < $total; $i++ ) {
		$row->load( (int) $cid[$i] );
		// track group

		if ($row->ordering != $order[$i]) {
			$row->ordering = $order[$i];
			if (!$row->store()) {
				JError::raiseError(500, $db->getErrorMsg() );
			}
		}
	}

	$msg 	= 'New ordering saved';
	$mainframe->redirect( "index.php?option=$option&module=email", $msg );
}
/*----------------------------------------------*/
?>