<?php
/*************************************************
Author: JoomClan.com
Creation Date: 2009-11-25
Author Email: joomclan@gmail.com
Url: http://www.joomclan.com
Copyright: 2009-2010
License: GNU
Component Version: 2.1.7
Software License: All of our PHP and HTML source code is released under the GNU General Public License (GPL) to ensure it is 100% compatible with Joomla!. 
The GPL is the world's most popular Free (as in Freedom) and Open Source Software license.
Some javascript and other media (images, css, ajax scripts, flv players, mp3 players etc …) may be released under different licenses. Please see the details with the individual products.
**************************************************/

defined("_JEXEC") or die("Restricted Access");

switch($task)
{
	case 'add':
		editField(false,$option);
		break;
	case 'edit':
		editField(true,$option);
		break;
	case 'apply':
	case 'save':
		saveField($option,$task);
		break;
	case 'publish':
		publishField($task,$option);
		break;
	case 'unpublish':
		publishField($task,$option);
		break;
	case 'remove':
		removeField($option);
		break;
	case 'orderup' :
		orderField(-1);
		break;
	case 'orderdown' :
		orderField(1);
		break;
	case 'saveorder':
		saveFieldOrder( $cid ,$option);
		break;
	default:
		listExtraFields($option,$module);
		break;
}


/*-------------------FIELDS FUNCTIONS--------------------------------------*/
/**
 * Field Functions
 *
 * @param unknown_type $edit
 * @param unknown_type $option
 */
function editField($edit,$option)
{
	global $mainframe;

	$db=JFactory::getDBO();

	$cid			= JRequest::getVar( 'cid', array(0), '', 'array' );
	JArrayHelper::toInteger($cid, array(0));
	$id				= JRequest::getVar( 'id', $cid[0], '', 'int' );
	$option			= JRequest::getCmd( 'option' );

	$row=&JTable::getInstance('extrafield','Table');

	if($edit)
	{
		$row->load($id);
	}
	$lists=array();

	$query = "SELECT * FROM #__jlcategories as c ORDER BY c.parent_id ASC"; // order by c.id is very important
	$db->setQuery($query);
	$categories = $db->loadObjectList();
	$tree = new pvgTree(new pvgNode(0));
	foreach($categories as $cat){
		if($edit && $cat->id == $cat->parent_id){
			$node = new pvgNode($cat->id, $cat->id, $cat->title, true);
		}else{
			$node = new pvgNode($cat->id, $cat->id, $cat->title);
		}
		$tree->appendChild($cat->parent_id, $node);
	}
	$lists['catid'] = $tree->renderTree('catid', false, 'Select');

	$type[] = JHTML::_('select.option', 'text', JText::_('Text'), 'value', 'text');
	$type[] = JHTML::_('select.option', 'select', JText::_('Select'), 'value', 'text');
	$type[] = JHTML::_('select.option', 'radio', JText::_('Radio'), 'value', 'text');
	$type[] = JHTML::_('select.option', 'checkbox', JText::_('Checkbox'), 'value', 'text');
	$type[] = JHTML::_('select.option', 'textarea', JText::_('Textarea'), 'value', 'text');
	$type[] = JHTML::_('select.option', 'country', JText::_('Country list'), 'value', 'text');

	$lists['types'] = JHTML::_('select.genericlist',   $type, 'fieldtype', 'class="inputbox" size="1"', 'value', 'text', $row->fieldtype );

	$lists['published']=JHTML::_('select.booleanlist','published','class="inputbox"',$row->published);
	$lists['required']=JHTML::_('select.booleanlist','required','class="inputbox"',$row->required);
	$lists['common']=JHTML::_('select.booleanlist','common','class="inputbox"',$row->common);
	HTML_Fields::editField($row,$lists,$option);
}

function listExtraFields($option,$module)
{

	global $mainframe;
	$limit=JRequest::getVar('limit',$mainframe->getCfg('list_limit'));
	$limitstart=JRequest::getVar('limitstart',0);

	$filter_order		= $mainframe->getUserStateFromRequest( $option.$module.'filter_order', 		'filter_order', 	'f.ordering',	'cmd' );
	$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.$module.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );
	$db=& JFactory::getDBO();
	$query="SELECT count(*) from #__jlextrafields";
	$db->setQuery($query);
	$total=$db->loadResult();
	$orderby 	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', f.ordering';
	$query ="SELECT f.*,ifnull(c.title,'No Category') as category  from #__jlextrafields as f left join #__jlcategories as c on f.catid=c.id".$orderby;

	$db->setQuery($query,$limitstart,$limit);
	$rows=$db->loadObjectList();
	if($db->getErrorNum())
	{
		echo $db->stderr();
		return false;
	}
	jimport('joomla.html.pagination');
	$lists=array();
	$lists['order_Dir']	= $filter_order_Dir;
	$lists['order']		= $filter_order;
	$pagenav=new JPagination($total,$limitstart,$limit);
	HTML_Fields::listExtraFields($rows,$pagenav,$lists,$option);

}

function publishField($task,$option)
{
	global $mainframe;
	$cid=JRequest::getVar('cid',array(),'','array');
	if($task=='publish')
	{
		$publish='1';
		$msg="Field(s) Published Successfully";
	}
	else
	{
		$publish='0';
		$msg="Field(s) Unpublished Successfully";
	}
	$catTable=& JTable::getInstance('extrafield','Table');
	JRequest::setVar( 'hidemainmenu', 1 );
	$editor=&JFactory::getEditor();
	$catTable->publish($cid,$publish);
	$mainframe->redirect("index.php?option=$option&module=field",$msg);

}

function saveField($option,$task)
{
	global $mainframe;
	$row=JTable::getInstance('extrafield','Table');
	if(!$row->bind(JRequest::get('post')))
	{
		echo "<script> alert('".$row->getError()."');
		window.history.go(-1); </script>";
		exit();
	}
	if (!$row->id) {
		$row->ordering = $row->getNextOrder( );
	}
	if(!$row->store())
	{
		echo "<script> alert('".$row->getError()."');
		window.history.go(-1); </script>";
		exit();
	}

	switch($task)
	{
		case 'apply':
			$msg="Changes to Field Saved";
			$link="index.php?option=$option&module=field&task=edit&cid[]=".$row->id;
			break;
		case 'save':
			$msg="Field Successfully Saved";
			$link="index.php?option=$option&module=field";
			break;
	}
	$mainframe->redirect($link,JText::_($msg));
}

function removeField($option)
{
	global $mainframe;
	$cid=JRequest::getVar('cid',array(),'','array');
	$db=JFactory::getDBO();
	if(count($cid))
	{
		$cids=implode(',',$cid);
		$query="DELETE from #__jlextrafields where id in ($cids)";
		$db->setQuery($query);
		if(!$db->query())
		{
			echo "<script> alert('".$db->getErrorMsg()."');
			window.history.go(-1); </script>\n";
		}
		$mainframe->redirect("index.php?option=com_joomlistings&module=field",JText::_('Field(s) deleted successfully'));
	}
}

function orderField($direction)
{
	global $mainframe,$option;


	// Initialize variables
	$db		= & JFactory::getDBO();

	$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );

	if (isset( $cid[0] ))
	{
		$row = & JTable::getInstance('extrafield','Table');
		$row->load( (int) $cid[0] );
		$row->move($direction, '' );
	}

	$mainframe->redirect("index.php?option=$option&module=field");
}

function saveFieldOrder( &$cid,$option )
{
	global $mainframe;


	// Initialize variables
	$db			=& JFactory::getDBO();
	$total		= count( $cid );
	$order 		= JRequest::getVar( 'order', array(0), 'post', 'array' );
	JArrayHelper::toInteger($order, array(0));

	$row =& JTable::getInstance('extrafield', 'Table');
	$groupings = array();

	// update ordering values
	for( $i=0; $i < $total; $i++ ) {
		$row->load( (int) $cid[$i] );
		// track categories

		if ($row->ordering != $order[$i]) {
			$row->ordering = $order[$i];
			if (!$row->store()) {
				JError::raiseError(500, $db->getErrorMsg() );
			}
		}
	}

	$msg 	= 'New ordering saved';

	$mainframe->redirect( "index.php?option=$option&module=field", $msg );
}
?>