<?php
/*************************************************
Author: JoomClan.com
Creation Date: 2009-11-25
Author Email: joomclan@gmail.com
Url: http://www.joomclan.com
Copyright: 2009-2010
License: GNU
Component Version: 2.1.7
Software License: All of our PHP and HTML source code is released under the GNU General Public License (GPL) to ensure it is 100% compatible with Joomla!. 
The GPL is the world's most popular Free (as in Freedom) and Open Source Software license.
Some javascript and other media (images, css, ajax scripts, flv players, mp3 players etc …) may be released under different licenses. Please see the details with the individual products.
**************************************************/

defined("_JEXEC") or die("Restricted Access");

switch($task)
{
	case 'add':
		edit(false,$option);
		break;
	case 'edit':
		edit(true,$option);
		break;
	case 'apply':
	case 'save':
		save($option,$task);
		break;
	case 'publish':
		publish($task,$option);
		break;
	case 'unpublish':
		publish($task,$option);
		break;
	case 'remove':
		remove($option);
		break;
	case 'orderup' :
		order(-1,$option);
		break;
	case 'orderdown' :
		order(1,$option);
		break;
	case 'saveorder':
		saveOrder( $cid,$option );
		break;
	default:
		listAll($option,$module);
		break;
}

/*-------------------GOOGLE ADS FUNCTIONS--------------------------------------*/

function edit($edit,$option)
{
	global $mainframe;


	$db=JFactory::getDBO();

	$cid			= JRequest::getVar( 'cid', array(0), '', 'array' );
	JArrayHelper::toInteger($cid, array(0));
	$id				= JRequest::getVar( 'id', $cid[0], '', 'int' );
	$option			= JRequest::getCmd( 'option' );

	$row=&JTable::getInstance('googlead','Table');

	if($edit)
	{
		$row->load($id);
	}
	
	$query="SELECT id as value, title as text from #__jlgooglezones";
	$db->setQuery($query);
	$zones2=$db->loadObjectList();
	
	$zones1[] = JHTML::_('select.option', '0', JText::_('Select Zone'), 'value', 'text');
	$zones=array_merge($zones1,$zones2);
	
	$lists=array();
	
	$lists['zones'] = JHTML::_('select.genericlist',   $zones, 'zoneid', 'class="inputbox" size="1"', 'value', 'text', $row->zoneid );
	
	$lists['published']=JHTML::_('select.booleanlist','published','class="inputbox"',$row->published);

	HTML_GoogleAd::edit($row,$lists,$option);
}

function listAll($option,$module)
{
	global $mainframe;
	JToolBarHelper::title(JText::_('Google Ads'),'generic.png');
	$limit=JRequest::getVar('limit',$mainframe->getCfg('list_limit'));
	$limitstart=JRequest::getVar('limitstart',0);

	$filter_order		= $mainframe->getUserStateFromRequest( $option.$module.'filter_order', 		'filter_order', 	'c.ordering',	'cmd' );
	$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.$module.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );

	$orderby 	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', c.ordering';

	$db=& JFactory::getDBO();
	$query="SELECT count(*) from #__googleads";
	$db->setQuery($query);
	$total=$db->loadResult();


	$query ="SELECT c.*,z.title as zone from #__jlgoogleads as c
	  left join #__jlgooglezones as z on c.zoneid=z.id  ". $orderby;
	$db->setQuery($query,$limitstart,$limit);
	$rows=$db->loadObjectList();
	if($db->getErrorNum())
	{
		echo $db->stderr();
		return false;
	}
	jimport('joomla.html.pagination');
	$pagenav=new JPagination($total,$limitstart,$limit);
	$lists=array();
	$lists['order_Dir']	= $filter_order_Dir;
	$lists['order']		= $filter_order;
	HTML_GoogleAd::listAll($rows,$pagenav,$lists,$option);

}
/**
 * Publishes
 *
 * @param unknown_type $task
 * @param unknown_type $option
 */
function publish($task,$option)
{
	global $mainframe;
	$cid=JRequest::getVar('cid',array(),'','array');
	if($task=='publish')
	{
		$publish='1';
		$msg="Ad(s) Published Successfully";
	}
	else
	{
		$publish='0';
		$msg="Ad(s) Unpublished Successfully";
	}
	$catTable=& JTable::getInstance('googlead','Table');
	JRequest::setVar( 'hidemainmenu', 1 );
	$editor=&JFactory::getEditor();
	$catTable->publish($cid,$publish);
	$mainframe->redirect("index.php?option=$option&module=googleads",$msg);

}
/**
 * Save
 *
 * @param unknown_type $option
 * @param unknown_type $task
 */
function save($option,$task)
{
	global $mainframe;
	$row=JTable::getInstance('googlead','Table');
	if(!$row->bind(JRequest::get('post')))
	{
		echo "<script> alert('".$row->getError()."');
		window.history.go(-1); </script>";
		exit();
	}
	
	$row->bannercode=JRequest::getVar('bannercode','','post','string',JREQUEST_ALLOWRAW);
	if (!$row->id) {
		$row->ordering = $row->getNextOrder( );
	}

	if(!$row->store())
	{
		echo "<script> alert('".$row->getError()."');
		window.history.go(-1); </script>";
		exit();
	}

	switch($task)
	{
		case 'apply':
			$msg="Changes to Ad Saved";
			$link="index.php?option=$option&module=googleads&task=edit&cid[]=".$row->id;
			break;
		case 'save':
			$msg=" Ad Successfully Saved";
			$link="index.php?option=$option&module=googleads";
			break;
	}
	$mainframe->redirect($link,JText::_($msg));
}
/**
 * Remove
 *
 * @param unknown_type $option
 */
function remove($option)
{
global $mainframe;
	$cid=JRequest::getVar('cid',array(),'','array');
	$db=JFactory::getDBO();
	if(count($cid))
	{
		$cids=implode(',',$cid);
		$query="DELETE from #__jlgoogleads where id in ($cids)";
		$db->setQuery($query);
		if(!$db->query())
		{
			echo "<script> alert('".$db->getErrorMsg()."');
			window.history.go(-1); </script>\n";
		}
		$mainframe->redirect("index.php?option=$option&module=googleads",JText::_('Ad(s) deleted successfully'));
	}
}
/**
 * Order
 *
 * @param unknown_type $direction
 */

function order($direction,$option)
{
	global $mainframe;


	// Initialize variables
	$db		= & JFactory::getDBO();

	$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );

	if (isset( $cid[0] ))
	{
		$row = & JTable::getInstance('googlead','Table');
		$row->load( (int) $cid[0] );
		$row->move($direction, '' );
	}

	$mainframe->redirect("index.php?option=$option&module=googleads");
}
/**
 * saveOrder
 *
 * @param unknown_type $cid
 */
function saveOrder( &$cid,$option )
{
	global $mainframe;


	// Initialize variables
	$db			=& JFactory::getDBO();
	$total		= count( $cid );
	$order 		= JRequest::getVar( 'order', array(0), 'post', 'array' );
	JArrayHelper::toInteger($order, array(0));

	$row =& JTable::getInstance('googlead', 'Table');
	$groupings = array();

	// update ordering values
	for( $i=0; $i < $total; $i++ ) {
		$row->load( (int) $cid[$i] );
		// track categories

		if ($row->ordering != $order[$i]) {
			$row->ordering = $order[$i];
			if (!$row->store()) {
				JError::raiseError(500, $db->getErrorMsg() );
			}
		}
	}

	$msg 	= 'New ordering saved';
	$mainframe->redirect( "index.php?option=$option&module=googleads", $msg );
}
?>