<?php
/*************************************************
Author: JoomClan.com
Creation Date: 2009-11-25
Author Email: joomclan@gmail.com
Url: http://www.joomclan.com
Copyright: 2009-2010
License: GNU
Component Version: 2.1.7
Software License: All of our PHP and HTML source code is released under the GNU General Public License (GPL) to ensure it is 100% compatible with Joomla!. 
The GPL is the world's most popular Free (as in Freedom) and Open Source Software license.
Some javascript and other media (images, css, ajax scripts, flv players, mp3 players etc …) may be released under different licenses. Please see the details with the individual products.
**************************************************/

defined("_JEXEC") or die("Restricted Access");

switch($task)
{
	case 'add':
		editOption(false,$option);
		break;
	case 'edit':
		editOption(true,$option);
		break;
	case 'apply':
	case 'save':
		saveOption($option,$task);
		break;
	case 'publish':
		publishOption($task,$option);
		break;
	case 'unpublish':
		publishOption($task,$option);
		break;
	case 'remove':
		removeOption($option);
		break;
	case 'orderup' :
		orderOption(-1,$option);
		break;
	case 'orderdown' :
		orderOption(1,$option);
		break;
	case 'saveorder':
		saveOptionOrder( $cid,$option );
		break;
	default:
		listOptions($option,$module);
		break;
}


/*-------------------OPTIONS FUNCTIONS--------------------------------------*/

function editOption($edit,$option)
{
	global $mainframe;

	$db=JFactory::getDBO();

	$cid			= JRequest::getVar( 'cid', array(0), '', 'array' );
	JArrayHelper::toInteger($cid, array(0));
	$id				= JRequest::getVar( 'id', $cid[0], '', 'int' );
	$option			= JRequest::getCmd( 'option' );

	$row=&JTable::getInstance('option','Table');

	if($edit)
	{
		$row->load($id);
	}
	$lists=array();

	$query="SELECT keyfield as text,id as value from #__jlextrafields where fieldtype!='text' order by keyfield";
	$db->setQuery( $query );
	$fields = $db->loadObjectList();
	$lists['fields'] = JHTML::_('select.genericlist',   $fields, 'fieldid', 'class="inputbox" size="1"', 'value', 'text', $row->fieldid );

	$lists['published']=JHTML::_('select.booleanlist','published','class="inputbox"',$row->published);
	HTML_Options::editOption($row,$lists,$option);
}

function listOptions($option,$module)
{
	
	global $mainframe;
	$limit=JRequest::getVar('limit',$mainframe->getCfg('list_limit'));
	$limitstart=JRequest::getVar('limitstart',0);

	$filter_order		= $mainframe->getUserStateFromRequest( $option.$module.'filter_order', 		'filter_order', 	'o.ordering',	'cmd' );
	$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.$module.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );
	$db=& JFactory::getDBO();
	$query="SELECT count(*) from #__jltypeoptions";
	$db->setQuery($query);
	$total=$db->loadResult();
	$orderby 	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', o.ordering';
	$query ="SELECT o.*,ifnull(f.keyfield,'No Field') as field  from #__jltypeoptions as o left join #__jlextrafields as f on o.fieldid=f.id".$orderby;

	$db->setQuery($query,$limitstart,$limit);
	$rows=$db->loadObjectList();
	if($db->getErrorNum())
	{
		echo $db->stderr();
		return false;
	}
	jimport('joomla.html.pagination');
	$lists=array();
	$lists['order_Dir']	= $filter_order_Dir;
	$lists['order']		= $filter_order;
	$pagenav=new JPagination($total,$limitstart,$limit);
	HTML_Options::listOptions($rows,$pagenav,$lists,$option);

}

function publishOption($task,$option)
{
	global $mainframe;
	$cid=JRequest::getVar('cid',array(),'','array');
	if($task=='publish')
	{
		$publish='1';
		$msg="Option(s) Published Successfully";
	}
	else
	{
		$publish='0';
		$msg="Option(s) Unpublished Successfully";
	}
	$catTable=& JTable::getInstance('option','Table');
	JRequest::setVar( 'hidemainmenu', 1 );
	$editor=&JFactory::getEditor();
	$catTable->publish($cid,$publish);
	$mainframe->redirect("index.php?option=$option&module=option",$msg);

}

function saveOption($option,$task)
{
	global $mainframe;
	$row=JTable::getInstance('option','Table');
	if(!$row->bind(JRequest::get('post')))
	{
		echo "<script> alert('".$row->getError()."');
		window.history.go(-1); </script>";
		exit();
	}
	if (!$row->id) {
		$row->ordering = $row->getNextOrder( );
	}
	if(!$row->store())
	{
		echo "<script> alert('".$row->getError()."');
		window.history.go(-1); </script>";
		exit();
	}

	switch($task)
	{
		case 'apply':
			$msg="Changes to Option Saved";
			$link="index.php?option=$option&module=option&task=edit&cid[]=".$row->id;
			break;
		case 'save':
			$msg="Option Successfully Saved";
			$link="index.php?option=$option&module=option";
			break;
	}
	$mainframe->redirect($link,JText::_($msg));
}

function removeOption($option)
{
	global $mainframe;
	$cid=JRequest::getVar('cid',array(),'','array');
	$db=JFactory::getDBO();
	if(count($cid))
	{
		$cids=implode(',',$cid);
		$query="DELETE from #__jltypeoptions where id in ($cids)";
		$db->setQuery($query);
		if(!$db->query())
		{
			echo "<script> alert('".$db->getErrorMsg()."');
			window.history.go(-1); </script>\n";
		}
		$mainframe->redirect("index.php?option=$option&module=option",JText::_('Option(s) deleted successfully'));
	}
}

function orderOption($direction,$option)
{
	global $mainframe;


	// Initialize variables
	$db		= & JFactory::getDBO();

	$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );

	if (isset( $cid[0] ))
	{
		$row = & JTable::getInstance('option','Table');
		$row->load( (int) $cid[0] );
		$row->move($direction, '' );
	}

	$mainframe->redirect("index.php?option=$option&module=option");
}

function saveOptionOrder( &$cid,$option )
{
	global $mainframe;


	// Initialize variables
	$db			=& JFactory::getDBO();
	$total		= count( $cid );
	$order 		= JRequest::getVar( 'order', array(0), 'post', 'array' );
	JArrayHelper::toInteger($order, array(0));

	$row =& JTable::getInstance('option', 'Table');
	$groupings = array();

	// update ordering values
	for( $i=0; $i < $total; $i++ ) {
		$row->load( (int) $cid[$i] );
		// track categories

		if ($row->ordering != $order[$i]) {
			$row->ordering = $order[$i];
			if (!$row->store()) {
				JError::raiseError(500, $db->getErrorMsg() );
			}
		}
	}

	$msg 	= 'New ordering saved';
	$mainframe->redirect( "index.php?option=$option&module=option", $msg );
}

?>