<?php
/*************************************************
Author: JoomClan.com
Creation Date: 2009-11-25
Author Email: joomclan@gmail.com
Url: http://www.joomclan.com
Copyright: 2009-2010
License: GNU
Component Version: 2.1.7
Software License: All of our PHP and HTML source code is released under the GNU General Public License (GPL) to ensure it is 100% compatible with Joomla!. 
The GPL is the world's most popular Free (as in Freedom) and Open Source Software license.
Some javascript and other media (images, css, ajax scripts, flv players, mp3 players etc …) may be released under different licenses. Please see the details with the individual products.
**************************************************/

defined("_JEXEC") or die("Restricted Access");
jimport( 'joomla.installer.installer' );
jimport('joomla.installer.helper');
defined('_JEXEC') or die('Restricted Access');

switch($task)
{
	case 'add':
		edit(false,$option);
		break;
	case 'edit':
		edit(true,$option);
		break;
	case 'publish':
		publish($task,$option);
		break;
	case 'unpublish':
		publish($task,$option);
		break;
	case 'apply':
	case 'save':
		save($option,$task);
		break;
	case 'remove':
		remove($option);
		break;
	case 'orderup' :
		order(-1,$option);
		break;
	case 'orderdown' :
		order(1,$option);
		break;
	case 'saveorder':
		saveOrder( $cid,$option );
		break;
	case 'subscriber':
		listSubscriber($option);
		break;
	case 'cancelsubscriber':
		cancelSubscriber($option);
		break;
	default:
		listAll($option, $module);
		break;

}


/*-------------------CATEGORIES FUNCTIONS--------------------------------------*/
/**
 * Edit
 *
 * @param boolean $edit
 * @param string $option
 */
function edit($edit,$option)
{
	global $mainframe;

	$db=JFactory::getDBO();

	$cid			= JRequest::getVar( 'cid', array(0), '', 'array' );
	JArrayHelper::toInteger($cid, array(0));
	$id				= JRequest::getVar( 'id', $cid[0], '', 'int' );
	$option			= JRequest::getCmd( 'option' );

	$row=&JTable::getInstance('jlplugin','Table');

	if($edit)
	{
		$row->load($id);
	}
	$lists['params'] = new JParameter( $row->params, JPATH_ADMINISTRATOR.DS."components".DS.$option.DS."plugins".DS.$row->pgroup.DS.$row->folder.DS.$row->element.".xml" );

	$lists['published']=JHTML::_('select.booleanlist','published','class="inputbox"',$row->published);
	HTML_Generic::edit($row,$lists,$option);
}
/**
 * Lists
 *
 * @param unknown_type $option
 * @param unknown_type $module
 * @return unknown
 */

function listAll($option,$module)
{
	global $mainframe;
	JToolBarHelper::title(JText::_('Plugins'),'plugin.png');
	$limit=JRequest::getVar('limit',$mainframe->getCfg('list_limit'));
	$limitstart=JRequest::getVar('limitstart',0);

	$filter_order		= $mainframe->getUserStateFromRequest( $option.$module.'filter_order', 		'filter_order', 	'c.ordering',	'cmd' );
	$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.$module.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );

	$orderby 	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', c.ordering';

	$db=& JFactory::getDBO();
	$query="SELECT count(*) from #__jlplugins";
	$db->setQuery($query);
	$total=$db->loadResult();


	$query ="SELECT c.*
	  from #__jlplugins as c 
	  
	  ". $orderby;
	$db->setQuery($query,$limitstart,$limit);
	$rows=$db->loadObjectList();
	if($db->getErrorNum())
	{
		echo $db->stderr();
		return false;
	}
	jimport('joomla.html.pagination');
	$pagenav=new JPagination($total,$limitstart,$limit);
	$lists=array();
	$lists['order_Dir']	= $filter_order_Dir;
	$lists['order']		= $filter_order;
	HTML_Generic::listAll($rows,$pagenav,$lists,$option);

}
/**
 * Publishes
 *
 * @param unknown_type $task
 * @param unknown_type $option
 */
function publish($task,$option)
{
	global $mainframe;
	$cid=JRequest::getVar('cid',array(),'','array');
	if($task=='publish')
	{
		$publish='1';
		$msg="Plugin(s) Published Successfully";
	}
	else
	{
		$publish='0';
		$msg="Plugin(s) Unpublished Successfully";
	}
	$catTable=& JTable::getInstance('jlplugin','Table');
	JRequest::setVar( 'hidemainmenu', 1 );
	$editor=&JFactory::getEditor();
	$catTable->publish($cid,$publish);
	$mainframe->redirect("index.php?option=$option&module=plugins",$msg);

}


/**
 * Save
 *
 * @param unknown_type $option
 * @param unknown_type $task
 */
function save($option,$task)
{
	global $mainframe;
	$row=JTable::getInstance('jlplugin','Table');
	if(!$row->bind(JRequest::get('post')))
	{
		echo "<script> alert('".$row->getError()."');
		window.history.go(-1); </script>";
		exit();
	}
	if (!$row->id) {
		$row->ordering = $row->getNextOrder( );
	}

	if(!$row->store())
	{
		echo "<script> alert('".$row->getError()."');
		window.history.go(-1); </script>";
		exit();
	}

	switch($task)
	{
		case 'apply':
			$msg="Changes to  Saved";
			$link="index.php?option=$option&module=plugins&task=edit&cid[]=".$row->id;
			break;
		case 'save':
			$msg=" Successfully Saved";
			$link="index.php?option=$option&module=plugins";
			break;
	}
	$mainframe->redirect($link,JText::_($msg));
}
/**
 * Remove
 *
 * @param unknown_type $option
 */
function remove($option)
{
	global $mainframe;
	$cid=JRequest::getVar('cid',array(),'','array');
	$db=JFactory::getDBO();
	if(count($cid))
	{
		$installer =& JInstaller::getInstance();
		$adaptherPath=JPATH_ADMINISTRATOR.DS."components".DS.$option.DS."includes".DS."adapters".DS."payment.php";
		require_once($adaptherPath);
		$adapterobj=new JInstallerPayment($installer);
	
		
		$installer->setAdapter('payment',$adapterobj);

		foreach($cid as $c)
		{
	
			 $installer->uninstall('payment', $c, 0 );
		}
		$cids=implode(',',$cid);
		$query="DELETE from #__jlplugins where id in ($cids)";
		$db->setQuery($query);
		if(!$db->query())
		{
			echo "<script> alert('".$db->getErrorMsg()."');
			window.history.go(-1); </script>\n";
		}
		$mainframe->redirect("index.php?option=$option&module=plugins",JText::_('Plugin(s) deleted successfully'));
	}
}
/**
 * Order
 *
 * @param unknown_type $direction
 */

function order($direction,$option)
{
	global $mainframe;


	// Initialize variables
	$db		= & JFactory::getDBO();

	$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );

	if (isset( $cid[0] ))
	{
		$row = & JTable::getInstance('jlplugin','Table');
		$row->load( (int) $cid[0] );
		$row->move($direction, '' );
	}

	$mainframe->redirect("index.php?option=$option&module=plugins");
}
/**
 * saveOrder
 *
 * @param unknown_type $cid
 */
function saveOrder( &$cid,$option )
{
	global $mainframe;


	// Initialize variables
	$db			=& JFactory::getDBO();
	$total		= count( $cid );
	$order 		= JRequest::getVar( 'order', array(0), 'post', 'array' );
	JArrayHelper::toInteger($order, array(0));

	$row =& JTable::getInstance('jlplugin', 'Table');
	$groupings = array();

	// update ordering values
	for( $i=0; $i < $total; $i++ ) {
		$row->load( (int) $cid[$i] );
		// track categories

		if ($row->ordering != $order[$i]) {
			$row->ordering = $order[$i];
			if (!$row->store()) {
				JError::raiseError(500, $db->getErrorMsg() );
			}
		}
	}

	$msg 	= 'New ordering saved';
	$mainframe->redirect( "index.php?option=$option&module=plugins", $msg );
}

function listSubscriber($option)
{
	global $mainframe;
	JToolBarHelper::title(JText::_('Plugins'),'plugin.png');
	$limit=JRequest::getVar('limit',$mainframe->getCfg('list_limit'));
	$limitstart=JRequest::getVar('limitstart',0);
	
//	$filter_order		= $mainframe->getUserStateFromRequest( $option.$module.'filter_order', 		'filter_order', 	'c.ordering',	'cmd' );
//	$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.$module.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );
//	$orderby 	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', c.ordering';

	$db =& JFactory::getDBO();
	$query = "SELECT count(*) from #__jluser_subscribes";
	$db->setQuery($query);
	$total=$db->loadResult();

	$query ="SELECT sc.*, u.name, u.email FROM #__jluser_subscribes as sc INNER JOIN #__users as u ON sc.user_id = u.id";
	$db->setQuery($query,$limitstart,$limit);
	$rows = $db->loadObjectList();
	if($db->getErrorNum())
	{
		echo $db->stderr();
		return false;
	}
	jimport('joomla.html.pagination');
	$pagenav=new JPagination($total,$limitstart,$limit);
	$lists=array();
//	$lists['order_Dir']	= $filter_order_Dir;
//	$lists['order']		= $filter_order;
	HTML_Generic::listSubscriber($rows, $pagenav, $lists, $option);

}

/**
 * Cancel an subscriber
 *
 * @param unknown_type $task
 * @param unknown_type $option
 */
function cancelSubscriber($option)
{
	global $mainframe;
	$cid = JRequest::getVar('cid',array(),'','array');
	$db =& JFactory::getDBO();
	$today = date('Y-m-d H:i:s');
	$query = "UPDATE #__jluser_subscribes SET cancelled = 1, cancel_date = '$today' WHERE id='".$cid[0]."'";
	$db->setQuery($query);
	$msg = "";
	if($db->query()){
		$msg = JText::_('The subscriber be cancelled');
	}else{
		$msg = $db->getErrorMsg();
	}
	$mainframe->redirect("index.php?option=$option&module=plugins&task=subscriber",$msg);

}



/*----------------------------------------------*/
?>