<?php
/*************************************************
Author: JoomClan.com
Creation Date: 2009-11-25
Author Email: joomclan@gmail.com
Url: http://www.joomclan.com
Copyright: 2009-2010
License: GNU
Component Version: 2.1.7
Software License: All of our PHP and HTML source code is released under the GNU General Public License (GPL) to ensure it is 100% compatible with Joomla!. 
The GPL is the world's most popular Free (as in Freedom) and Open Source Software license.
Some javascript and other media (images, css, ajax scripts, flv players, mp3 players etc …) may be released under different licenses. Please see the details with the individual products.
**************************************************/

defined('_JEXEC') or die('Restricted access');
	switch($task)
		{
			case 'add':
				editReason(false, $option);
				break;
			case 'edit':
				editReason(true, $option);
				break;
			case 'publish':
				publishReason($task, $option);
				break;
			case 'unpublish':
				publishReason($task, $option);
				break;
			case 'apply':
			case 'save':
				saveReason($option, $task);
				break;
			case 'remove':
				removeReason($option);
				break;
			case 'orderup' :
				orderReason(-1, $option);
				break;
			case 'orderdown' :
				orderReason(1, $option);
				break;
			case 'saveorder':
				saveReasonOrder( $cid, $option );
				break;
			default:
				listReasons($option, $module);
				break;

		}

/**
 * Edit reason
 *
 * @param boolean $edit
 * @param string $option
 */
function editReason($edit,$option)
{
	global $mainframe;
	$db =& JFactory::getDBO();
	$cid			= JRequest::getVar( 'cid', array(0), '', 'array' );
	JArrayHelper::toInteger($cid, array(0));
	$id				= JRequest::getVar( 'id', $cid[0], '', 'int' );
	$option			= JRequest::getCmd( 'option' );
	$row =& JTable::getInstance('reason','Table');
	if($edit)
	{
		$row->load($id);
	}
	$lists=array();
	$lists['published']=JHTML::_('select.booleanlist','published','class="inputbox"',$row->published);
	HTML_reasons::editReason($row,$lists,$option);
}
/**
 * Lists Category
 *
 * @param unknown_type $option
 * @param unknown_type $module
 * @return unknown
 */

function listReasons($option, $module)
{
	global $mainframe;
	JToolBarHelper::title(JText::_('Report reasons'),'categories.png');
	$limit = JRequest::getVar('limit',$mainframe->getCfg('list_limit'));
	$limitstart = JRequest::getVar('limitstart',0);
	$filter_order		= $mainframe->getUserStateFromRequest( $option.$module.'filter_order', 		'filter_order', 	'r.ordering',	'cmd' );
	$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.$module.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );

	$orderby 	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', r.ordering';
	
	$db=& JFactory::getDBO();
	$query="SELECT count(*) from #__jlreport_reasons";
	$db->setQuery($query);
	$total=$db->loadResult();

	$query ="SELECT r.* FROM #__jlreport_reasons AS r ". $orderby;
	$db->setQuery($query,$limitstart,$limit);
	$rows=$db->loadObjectList();
	if($db->getErrorNum())
	{
		echo $db->stderr();
		return false;
	}
	jimport('joomla.html.pagination');
	$pagenav=new JPagination($total, $limitstart, $limit);
	$lists=array();
	$lists['order_Dir']	= $filter_order_Dir;
	$lists['order']		= $filter_order;
	HTML_Reasons::listReasons($rows, $pagenav, $lists, $option);

}
/**
 * Publishes Category
 *
 * @param unknown_type $task
 * @param unknown_type $option
 */
function publishReason($task,$option)
{
	global $mainframe;
	$cid = JRequest::getVar('cid',array(),'','array');
	if($task == 'publish')
	{
		$publish='1';
		$msg = "Reason Published Successfully";
	}
	else
	{
		$publish='0';
		$msg="Reason Unpublished Successfully";
	}
	$rTable =& JTable::getInstance('reason','Table');
	JRequest::setVar( 'hidemainmenu', 1 );
	$rTable->publish($cid, $publish);
	$mainframe->redirect("index.php?option=$option&module=reasons",$msg);

}
/**
 * Save Reason
 *
 * @param unknown_type $option
 * @param unknown_type $task
 */
function saveReason($option,$task)
{
	global $mainframe;
	$row = JTable::getInstance('reason','Table');
	if(!$row->bind(JRequest::get('post')))
	{
		echo "<script> alert('".$row->getError()."');
		window.history.go(-1); </script>";
		exit();
	}
	if (!$row->id) {
		$row->ordering = $row->getNextOrder( );
	}

	if(!$row->store())
	{
		echo "<script> alert('".$row->getError()."');
		window.history.go(-1); </script>";
		exit();
	}

	switch($task)
	{
		case 'apply':
			$msg="Changes to Reason Saved";
			$link="index.php?option=$option&module=reasons&task=edit&cid[]=".$row->id;
			break;
		case 'save':
			$msg="Reason Successfully Saved";
			$link="index.php?option=$option&module=reasons";
			break;
	}
	$mainframe->redirect($link,JText::_($msg));
}
/**
 * Remove Category
 *
 * @param unknown_type $option
 */
function removeReason($option)
{
	global $mainframe;
	$cid=JRequest::getVar('cid',array(),'','array');
	$db=JFactory::getDBO();
	if(count($cid))
	{
		$cids=implode(',',$cid);
		$query="DELETE from #__jlreport_reasons where id in ($cids)";
		$db->setQuery($query);
		if(!$db->query())
		{
			echo "<script> alert('".$db->getErrorMsg()."');
			window.history.go(-1); </script>\n";
		}
		$mainframe->redirect("index.php?option=com_joomlistings&module=reasons", JText::_('Reason deleted successfully'));
	}
}
/**
 * Order Category
 *
 * @param unknown_type $direction
 */

function orderReason($direction,$option)
{
	global $mainframe;
	$db		= & JFactory::getDBO();
	$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
	if (isset( $cid[0] ))
	{
		$row = & JTable::getInstance('reason','Table');
		$row->load( (int) $cid[0] );
		$row->move($direction, '' );
	}
	$mainframe->redirect("index.php?option=$option&module=reasons");
}
/**
 * saveCategoryOrder
 *
 * @param unknown_type $cid
 */
function saveReasonOrder( &$cid,$option )
{
	global $mainframe;
	$db			=& JFactory::getDBO();
	$total		= count( $cid );
	$order 		= JRequest::getVar( 'order', array(0), 'post', 'array' );
	JArrayHelper::toInteger($order, array(0));
	$row =& JTable::getInstance('reason', 'Table');
	$groupings = array();
	for( $i=0; $i < $total; $i++ ) {
		$row->load( (int) $cid[$i] );
		if ($row->ordering != $order[$i]) {
			$row->ordering = $order[$i];
			if (!$row->store()) {
				JError::raiseError(500, $db->getErrorMsg() );
			}
		}
	}
	$msg 	= 'New ordering saved';
	$mainframe->redirect( "index.php?option=$option&module=reasons", $msg );
}
/*----------------------------------------------*/
?>