<?php
/*************************************************
Author: JoomClan.com
Creation Date: 2009-11-25
Author Email: joomclan@gmail.com
Url: http://www.joomclan.com
Copyright: 2009-2010
License: GNU
Component Version: 2.1.7
Software License: All of our PHP and HTML source code is released under the GNU General Public License (GPL) to ensure it is 100% compatible with Joomla!. 
The GPL is the world's most popular Free (as in Freedom) and Open Source Software license.
Some javascript and other media (images, css, ajax scripts, flv players, mp3 players etc …) may be released under different licenses. Please see the details with the individual products.
**************************************************/

defined("_JEXEC") or die("Restricted Access");
/**
 * Section Module
 *
 */


switch($task)
{
	case 'add':
		editSection(false,$option);
		break;
	case 'edit':
		editSection(true,$option);
		break;
	case 'apply':
	case 'save':
		saveSection($option,$task);
		break;
	case 'publish':
		publishSection($task,$option);
		break;
	case 'unpublish':
		publishSection($task,$option);
		break;
	case 'remove':
		removeSection($option);
		break;
	case 'orderup' :
		orderSection(-1,$option);
		break;
	case 'orderdown' :
		orderSection(1,$option);
		break;
	case 'saveorder':
		saveSectionOrder( $cid,$option );
		break;
	default:
		listSections($option,$module);
		break;
}

/*-------------------Section FUNCTIONS--------------------------------------*/
/**
 * Edit 
 *
 * @param boolean $edit
 * @param string $option
 */
function editSection($edit,$option)
{
	global $mainframe;

	$db=JFactory::getDBO();

	$cid			= JRequest::getVar( 'cid', array(0), '', 'array' );
	JArrayHelper::toInteger($cid, array(0));
	$id				= JRequest::getVar( 'id', $cid[0], '', 'int' );
	$option			= JRequest::getCmd( 'option' );

	$row=&JTable::getInstance('joomsection','Table');

	if($edit)
	{
		$row->load($id);
	}
	$lists=array();

	$lists['published']=JHTML::_('select.booleanlist','published','class="inputbox"',$row->published);
	$lists['default']=JHTML::_('select.booleanlist','default_section','class="inputbox"',$row->default_section);
	HTML_Sections::edit($row,$lists,$option);
}
/**
 * Lists Category
 *
 * @param unknown_type $option
 * @param unknown_type $module
 * @return unknown
 */

function listSections($option,$module)
{
	global $mainframe;
	JToolBarHelper::title(JText::_('Sections'),'categories.png');
	$limit=JRequest::getVar('limit',$mainframe->getCfg('list_limit'));
	$limitstart=JRequest::getVar('limitstart',0);

	$filter_order		= $mainframe->getUserStateFromRequest( $option.$module.'filter_order', 		'filter_order', 	'c.ordering',	'cmd' );
	$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.$module.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );

	$orderby 	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', c.ordering';

	$db=& JFactory::getDBO();
	$query="SELECT count(*) from #__jlsections";
	$db->setQuery($query);
	$total=$db->loadResult();


	$query ="SELECT c.*,(select count(*) from #__joomlistings where sectionid=c.id) as listcounts from #__jlsections as c ". $orderby;
	$db->setQuery($query,$limitstart,$limit);
	$rows=$db->loadObjectList();
	if($db->getErrorNum())
	{
		echo $db->stderr();
		return false;
	}
	jimport('joomla.html.pagination');
	$pagenav=new JPagination($total,$limitstart,$limit);
	$lists=array();
	$lists['order_Dir']	= $filter_order_Dir;
	$lists['order']		= $filter_order;
	HTML_Sections::listSections($rows,$pagenav,$lists,$option);

}
/**
 * Publishes Category
 *
 * @param unknown_type $task
 * @param unknown_type $option
 */
function publishSection($task,$option)
{
	global $mainframe;
	$cid=JRequest::getVar('cid',array(),'','array');
	if($task=='publish')
	{
		$publish='1';
		$msg="Section(s) Published Successfully";
	}
	else
	{
		$publish='0';
		$msg="Section(s) Unpublished Successfully";
	}
	$catTable=& JTable::getInstance('joomsection','Table');
	JRequest::setVar( 'hidemainmenu', 1 );
	$editor=&JFactory::getEditor();
	$catTable->publish($cid,$publish);
	$mainframe->redirect("index.php?option=$option&module=sections",$msg);

}
/**
 * Save Category
 *
 * @param unknown_type $option
 * @param unknown_type $task
 */
function saveSection($option,$task)
{
	global $mainframe;
	$row=JTable::getInstance('joomsection','Table');
	
	//HieuNC upload images
	if (($_FILES["image_of_section"]["type"] == "image/jpeg") || ($_FILES["image_of_section"]["type"] == "image/png") || ($_FILES["image_of_section"]["type"] == "image/gif") 
	&& ($_FILES["image_of_section"]["size"] < 2048000))
	{
		if ($_FILES["image_of_section"]["error"] > 0)
		{
			die($_FILES["image_of_section"]["error"]);
		}
		else
		{
			move_uploaded_file($_FILES["image_of_section"]["tmp_name"], "../components/com_joomlistings/images/images-of-sections/" . $_FILES["image_of_section"]["name"]);
		}
	}
	
	$image		= $_FILES["image_of_section"]["name"];
	
	if($image != NUll)
		JRequest::setVar('image_of_section', $image);
	
	if(!$row->bind(JRequest::get('post')))
	{
		echo "<script> alert('".$row->getError()."');
		window.history.go(-1); </script>";
		exit();
	}
	if (!$row->id) {
		$row->ordering = $row->getNextOrder( );
	}
	
	if(!$row->store())
	{
		echo "<script> alert('".$row->getError()."');
		window.history.go(-1); </script>";
		exit();
	}

	switch($task)
	{
		case 'apply':
			$msg="Changes to Section Saved";
			$link="index.php?option=$option&module=sections&task=edit&cid[]=".$row->id;
			break;
		case 'save':
			$msg="Section Successfully Saved";
			$link="index.php?option=$option&module=sections";
			break;
	}
	$mainframe->redirect($link,JText::_($msg));
}
/**
 * Remove Category
 *
 * @param unknown_type $option
 */
function removeSection($option)
{
	global $mainframe;
	$cid=JRequest::getVar('cid',array(),'','array');
	$db=JFactory::getDBO();
	if(count($cid))
	{
		$cids=implode(',',$cid);
		$query="DELETE from #__jlsections where id in ($cids)";
		$db->setQuery($query);
		if(!$db->query())
		{
			echo "<script> alert('".$db->getErrorMsg()."');
			window.history.go(-1); </script>\n";
		}
		$mainframe->redirect("index.php?option=com_joomlistings&module=sections",JText::_('Section(s) deleted successfully'));
	}
}
/**
 * Order Category
 *
 * @param unknown_type $direction
 */

function orderSection($direction,$option)
{
	global $mainframe;


	// Initialize variables
	$db		= & JFactory::getDBO();

	$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );

	if (isset( $cid[0] ))
	{
		$row = & JTable::getInstance('joomsection','Table');
		$row->load( (int) $cid[0] );
		$row->move($direction, '' );
	}

	$mainframe->redirect("index.php?option=$option&module=sections");
}
/**
 * saveCategoryOrder
 *
 * @param unknown_type $cid
 */
function saveSectionOrder( &$cid,$option )
{
	global $mainframe;


	// Initialize variables
	$db			=& JFactory::getDBO();
	$total		= count( $cid );
	$order 		= JRequest::getVar( 'order', array(0), 'post', 'array' );
	JArrayHelper::toInteger($order, array(0));

	$row =& JTable::getInstance('joomsection', 'Table');
	$groupings = array();

	// update ordering values
	for( $i=0; $i < $total; $i++ ) {
		$row->load( (int) $cid[$i] );
		// track categories

		if ($row->ordering != $order[$i]) {
			$row->ordering = $order[$i];
			if (!$row->store()) {
				JError::raiseError(500, $db->getErrorMsg() );
			}
		}
	}

	$msg 	= 'New ordering saved';
	$mainframe->redirect( "index.php?option=$option&module=sections", $msg );
}
/*----------------------------------------------*/

?>