<?php
/*************************************************
Author: JoomClan.com
Creation Date: 2009-11-25
Author Email: joomclan@gmail.com
Url: http://www.joomclan.com
Copyright: 2009-2010
License: GNU
Component Version: 2.1.7
Software License: All of our PHP and HTML source code is released under the GNU General Public License (GPL) to ensure it is 100% compatible with Joomla!. 
The GPL is the world's most popular Free (as in Freedom) and Open Source Software license.
Some javascript and other media (images, css, ajax scripts, flv players, mp3 players etc …) may be released under different licenses. Please see the details with the individual products.
**************************************************/

defined("_JEXEC") or die("Restricted Access");
switch($task)
{
	case 'edit':
		editUser(true,$option);
		break;
	case 'unpublish':
	case 'publish':
		publishUser($task,$option);
		break;
	case 'apply':
	case 'save':
		saveUser($option,$task);
		break;
	case 'remove':
		removeUser($option);
		break;
	default:
		listUsers($option,$module);
		break;

}

	
/**
 * User Management Codes
 */


/**
 * Edit User
 *
 * @param boolean $edit
 * @param string $option
 */
function editUser($edit,$option)
{
	global $mainframe;

	$db=JFactory::getDBO();

	$cid			= JRequest::getVar( 'cid', array(0), '', 'array' );
	JArrayHelper::toInteger($cid, array(0));
	$id				= JRequest::getVar( 'id', $cid[0], '', 'int' );
	$option			= JRequest::getCmd( 'option' );

	$row=&JTable::getInstance('joomcategories','Table');

	if($edit)
	{
		$row->load($id);
	}
	$lists=array();

	$query="SELECT title as text,id as value from #__jlcategories where parent_id='0'";
	$db->setQuery( $query );
	$categories2 = $db->loadObjectList();
	$categories1[] = JHTML::_('select.option', '0', JText::_('Root Category'), 'value', 'text');
	$categories=array_merge($categories1,$categories2);
	$lists['categories'] = JHTML::_('select.genericlist',   $categories, 'parent_id', 'class="inputbox" size="1"', 'value', 'text', $row->parent_id );

	$lists['published']=JHTML::_('select.booleanlist','published','class="inputbox"',$row->published);
	HTML_categories::editCategory($row,$lists,$option);
}
/**
 * Lists User
 *
 * @param unknown_type $option
 * @param unknown_type $module
 * @return unknown
 */

function listUsers($option,$module)
{
	global $mainframe;
	$limit=JRequest::getVar('limit',$mainframe->getCfg('list_limit'));
	$limitstart=JRequest::getVar('limitstart',0);

	$filter_order		= $mainframe->getUserStateFromRequest( $option.$module.'filter_order', 		'filter_order', 	'c.ordering',	'cmd' );
	$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.$module.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );

	$orderby 	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', c.ordering';

	$db=& JFactory::getDBO();
	$query="SELECT count(*) from #__jlcategories";
	$db->setQuery($query);
	$total=$db->loadResult();


	$query ="SELECT c.*,ifnull(c2.title,'Root') as parent  from #__jlcategories as c left join #__jlcategories as c2 on c.parent_id=c2.id". $orderby;
	$db->setQuery($query,$limitstart,$limit);
	$rows=$db->loadObjectList();
	if($db->getErrorNum())
	{
		echo $db->stderr();
		return false;
	}
	jimport('joomla.html.pagination');
	$pagenav=new JPagination($total,$limitstart,$limit);
	$lists=array();
	$lists['order_Dir']	= $filter_order_Dir;
	$lists['order']		= $filter_order;
	HTML_Categories::listCategories($rows,$pagenav,$lists,$option);

}
/**
 * Publishes User
 *
 * @param unknown_type $task
 * @param unknown_type $option
 */
function publishUser($task,$option)
{
	global $mainframe;
	$cid=JRequest::getVar('cid',array(),'','array');
	if($task=='publish')
	{
		$publish='1';
		$msg="Category/Categories Published Successfully";
	}
	else
	{
		$publish='0';
		$msg="Category/Categories Unpublished Successfully";
	}
	$catTable=& JTable::getInstance('joomcategories','Table');
	JRequest::setVar( 'hidemainmenu', 1 );
	$editor=&JFactory::getEditor();
	$catTable->publish($cid,$publish);
	$mainframe->redirect("index.php?option=$option&module=categories",$msg);

}
/**
 * Save User
 *
 * @param unknown_type $option
 * @param unknown_type $task
 */
function saveUser($option,$task)
{
	global $mainframe;
	$row=JTable::getInstance('joomcategories','Table');
	if(!$row->bind(JRequest::get('post')))
	{
		echo "<script> alert('".$row->getError()."');
		window.history.go(-1); </script>";
		exit();
	}
	if (!$row->id) {
		$row->ordering = $row->getNextOrder( );
	}

	if(!$row->store())
	{
		echo "<script> alert('".$row->getError()."');
		window.history.go(-1); </script>";
		exit();
	}

	switch($task)
	{
		case 'apply':
			$msg="Changes to Category Saved";
			$link="index.php?option=$option&module=categories&task=edit&cid[]=".$row->id;
			break;
		case 'save':
			$msg="Category Successfully Saved";
			$link="index.php?option=$option&module=categories";
			break;
	}
	$mainframe->redirect($link,JText::_($msg));
}
/**
 * Remove User
 *
 * @param unknown_type $option
 */
function removeUser($option)
{
	global $mainframe;
	$cid=JRequest::getVar('cid',array(),'','array');
	$db=JFactory::getDBO();
	if(count($cid))
	{
		$cids=implode(',',$cid);
		$query="DELETE from #__jlcategories where id in ($cids)";
		$db->setQuery($query);
		if(!$db->query())
		{
			echo "<script> alert('".$db->getErrorMsg()."');
			window.history.go(-1); </script>\n";
		}
		$mainframe->redirect("index.php?option=com_joomlistings&module=categories",JText::_('Category/Categories deleted successfully'));
	}
}
/**
 * Order Category
 *
 * @param unknown_type $direction
 */

/*----------------------------------------------*/


?>