<?php
/*************************************************
Author: JoomClan.com
Creation Date: 2009-11-25
Author Email: joomclan@gmail.com
Url: http://www.joomclan.com
Copyright: 2009-2010
License: GNU
Component Version: 2.1.7
Software License: All of our PHP and HTML source code is released under the GNU General Public License (GPL) to ensure it is 100% compatible with Joomla!. 
The GPL is the world's most popular Free (as in Freedom) and Open Source Software license.
Some javascript and other media (images, css, ajax scripts, flv players, mp3 players etc …) may be released under different licenses. Please see the details with the individual products.
**************************************************/

defined("_JEXEC") or die("Restricted Access");
class PaymentPlugin
{
	var $name				=	"";
	var $id					=	null;
	var $parameter			=	null;
	var $invoice			=	null;
	var $folder				=	null;
	var $group				=	null;
	var $element			=	null;
	var $returnurl			=	null;
	var $notifyurl			=	null;
	var $cancelurl			=	null;
	var $params				=	null;
	var $data				=	null;
	var $transactiontable	=	null;
	var $inurl				=	null;
	var $redir				=	null;
	var $custom				= 	null;
	
	function __construct(){

	}

	function setTransactionTable(&$t){
		$this->transactiontable=$t;
	}
	
	function filldata(&$row){
		$this->folder		=	$row->folder;
		$this->name			=	$row->title;
		$this->group		=	$row->pgroup;
		$this->element		=	$row->element;
		$this->params		=	$row->params;
		$this->id			=	$row->id;

	}

	function getInstance($entity, $prefix="PaymentPlugin"){
		global $option;
		// use a static array to store controller instances
		static $instances;
		if (!$instances)
		{
			$instances = array();
		}
		// determine subclass name
		$class = $prefix.ucfirst($entity);

		// check if we already instantiated this controller
		if (!isset($instances[$class]))
		{
			// check if we need to find the controller class
			if (!class_exists( $class ))
			{
				jimport('joomla.filesystem.file');
				$path = JPATH_ADMINISTRATOR.DS."components".DS.$option.DS.'plugins'.DS."payment".DS.strtolower($entity).DS.strtolower($entity).'.php';
				// search for the file in the controllers path
				if (JFile::exists($path))
				{
					// include the class file
					require_once $path;
					if (!class_exists( $class ))
					{
						// class file does not include the class
						return JError::raiseWarning('SOME_ERROR',
						JText::_('Invalid controller'));
					}
				}
				else
				{
					// class file not found
					return JError::raiseWarning('SOME_ERROR',
					JText::_('Unknown controller'));
				}
			}
			// create controller instance
			$instances[$class] = new $class();
		}
		// return a reference to the controller
		return $instances[$class];
	}

	function setReturnUrl($url){
		$uri =& JURI::getInstance();
		$baseUrl = $uri->_scheme . "://" . $uri->_host;
		if($uri->_port){
			$baseUrl = $baseUrl . ":" . $uri->_port;
		}
		$baseUrl = $uri->toString( array('scheme', 'host', 'port'));
		$this->returnurl = $baseUrl.JRoute::_($url."&plugin=".$this->id);
	}

	function setNotifyUrl($url){
		$uri =& JURI::getInstance();
		$baseUrl = $uri->_scheme . "://" . $uri->_host;
		if($uri->_port){
			$baseUrl = $baseUrl . ":" . $uri->_port;
		}
		$baseUrl = $uri->toString( array('scheme', 'host', 'port'));
		$this->notifyurl = $baseUrl.JRoute::_($url."&plugin=".$this->id);

	}

	function setCancelUrl($url){
		$uri =& JURI::getInstance();
		$baseUrl = $uri->_scheme . "://" . $uri->_host;
		if($uri->_port){
			$baseUrl = $baseUrl . ":" . $uri->_port;
		}
		$baseUrl = $uri->toString( array('scheme', 'host', 'port'));
		$this->cancelurl = $baseUrl.JRoute::_($url."&plugin=".$this->id);
	}

	function setInurl($url){
		$this->inurl = $url;
	}
	
	function input(){

	}

	function init(){

	}

	function preprocess($data=array()){
		global $option;
		?>
		<form name="frmPayment" action="<?php echo JRoute::_("index.php");?>" method="post">
		<input type="hidden" name="c" value="payment"/>
		<input type="hidden" name="task" value="pay"/>
		<input type="hidden" name="option" value="<?php echo $option;?>"/>
		<input type="hidden" name="plugin" value="<?php echo $this->id;?>"/>
		<input type="hidden" name="firstname" value="<?php echo $data['firstname'];?>"/>
		<input type="hidden" name="middlename" value="<?php echo $data['middlename'];?>"/>
		<input type="hidden" name="lastname" value="<?php echo $data['lastname'];?>"/>
		<input type="hidden" name="cardtype" value="<?php echo $data['cardtype'];?>"/>
		<input type="hidden" name="cardnumber" value="<?php echo $data['cardnumber'];?>"/>
		<input type="hidden" name="month" value="<?php echo $data['month'];?>"/>
		<input type="hidden" name="year" value="<?php echo $data['year'];?>"/>
		<input type="hidden" name="cvv" value="<?php echo $data['cvv'];?>"/>
		<input type="hidden" name="address1" value="<?php echo $data['address1'];?>"/>
		<input type="hidden" name="address2" value="<?php echo $data['address2'];?>"/>
		<input type="hidden" name="city" value="<?php echo $data['city'];?>"/>
		<input type="hidden" name="state" value="<?php echo $data['state'];?>"/>
		<input type="hidden" name="zipcode" value="<?php echo $data['zipcode'];?>"/>
		<input type="hidden" name="country" value="<?php echo $data['country'];?>"/>
		<input type="hidden" name="inurl" value="<?php echo $data['inurl'];?>"/>
		<input type="hidden" name="amount" value="<?php echo $data['amount'];?>"/>
		<input type="hidden" name="currency" value="<?php echo $data['currency'];?>"/>
		<input type="hidden" name="description" value="<?php echo $data['description'];?>"/>
		<input type="hidden" name="invoice" value="<?php echo $data['invoice'];?>"/>
		<input type="hidden" name="orderid" value="<?php echo $data['orderid'];?>"/>
			<input type="submit" value="<?php echo JText::_('CONFIRM');?>" />
		</form>

		<?php
	}
	function process(){


	}

	function getResult(){

	}

	function pay(){

	}

	function setInvoice(&$invoice){
		$this->invoice = $invoice;
	}

	function setParameter(&$parameter){
		$this->parameter = $parameter;
	}

	function cancel(){

	}

	function notify(){

	}

	function success(){

	}

	function getConfig()
	{
		return array();
	}

	function initScript()
	{
		global $option;
		?>
		<script>
		window.addEvent('domready',function(){
			
			$('plugin<?php echo $this->folder;?>_head').addEvent('click',function(e){

				frm=document.adminForm;
			
				frm.action="<?php echo JRoute::_( "index.php?option=$option" ); ?>";
				
				});
			});
		</script>
		<?php
	}

	function showCreditCardFields(){
		$db=JFactory::getDBO();
		$query="SELECT title as text, code as value from #__joomcountries order by title";
		$db->setQuery($query);
		$countries=$db->loadObjectList();
		$countrieslist = JHTML::_('select.genericlist',  $countries, 'country', ' class="inputbox" size="1"', 'value', 'text', $this->bill->billing->country);
		$u=$this->invoice->user;
		?>

<div>
<table width="100%" cellspacing="0" cellpadding="5" border="0">
	<tbody>
		<tr>

			<td class="main" width="35%">First Name on Credit Card:</td>
			<td class="main"><input type="text" name="firstname" class="inputbox"
				value="<?php echo $u->name; ?>" /></td>
		</tr>
		<tr>
			<td class="main">Middle Name on Credit Card:</td>
			<td class="main"><input type="text" name="middlename"
				class="inputbox" value="" /></td>
		</tr>
		<tr>
			<td class="main">Last Name on Credit Card:</td>
			<td class="main"><input type="text" name="lastname" class="inputbox"
				value="<?php echo $u->lastname; ?>" /></td>
		</tr>
		<tr>
			<td class="main">Credit Card Type:</td>
			<td class="main"><select name="cardtype" class="inputbox">
				<option value="Visa">Visa</option>
				<option value="MasterCard">MasterCard</option>
				<option value="Discover">Discover</option>
				<option value="Amex">American Express</option>
			</select></td>
		</tr>
		<tr>
			<td class="main">Credit Card Number:</td>
			<td class="main"><input type="text" name="cardnumber"
				class="inputbox" /></td>
		</tr>
		<tr>
			<td class="main">Credit Card Expiry Date:</td>
			<td class="main"><select name="month" class="inputbox">
				<option value="01">1 - January</option>
				<option value="02">2 - February</option>
				<option value="03">3 - March</option>
				<option value="04">4 - April</option>
				<option value="05">5 - May</option>
				<option value="06">6 - June</option>
				<option value="07">7 - July</option>
				<option value="08">8 - August</option>
				<option value="09">9 - September</option>
				<option value="10">10 - October</option>
				<option value="11">11 - November</option>
				<option value="12">12 - December</option>
			</select> <select name="year" class="inputbox">
			<?php
			$year=date("Y");
			$valyear=date("y");
			for($i=0;$i<10;$i++)
			{
				?>
				<option value="<?=($year+$i)?>"><?=($year+$i)?></option>
				<?php
			}
			?>
			</select></td>
		</tr>
		<tr>
			<td class="main">Credit Card Security Code:</td>
			<td class="main"><input type="text" maxlength="4" size="4" name="cvv"
				class="inputbox" /></td>
		</tr>
	</tbody>
</table>
</div>
<div>
<h3>Address</h3>

<table width="100%" cellpadding="5" cellspacing="0" border="0">
	<tr>
		<td width="35%">Address 1</td>
		<td><input type="text" name="address1" class="inputbox"
			value="<?php echo $this->bill->billing->address1; ?>" /></td>
	</tr>
	<tr>
		<td>Address 2</td>
		<td><input type="text" name="address2" class="inputbox"
			value="<?php echo $this->bill->billing->address2; ?>" /></td>

	</tr>
	<tr>
		<td>City</td>
		<td><input type="text" name="city" class="inputbox"
			value="<?php echo $this->bill->billing->city; ?>" /></td>

	</tr>
	<tr>
		<td>State</td>
		<td><input type="text" name="state" class="inputbox"
			value="<?php echo $this->bill->billing->state; ?>" /></td>

	</tr>
	<tr>
		<td>Zipcode</td>
		<td><input type="text" name="zipcode" class="inputbox"
			value="<?php echo $this->bill->billing->zipcode; ?>" /></td>

	</tr>
	<tr>
		<td>Country</td>
		<td><?php echo $countrieslist;?></td>

	</tr>
</table>
</div>
			<?php
	}

	function setCustom($custom){
		$this->custom = $custom;
	}
}
?>