<?php
// no direct access
defined('_JEXEC') or die('Restricted access');

include_once(JPATH_ROOT . DS . 'components' . DS . 'com_joomlistings' . DS . 'includes' . DS . 'jlfactory.php');
class plgJoomlistingsSendemail extends JPlugin {
	
	var $_jlsettings = null;
	var $_sender = null;
	var $_jomsocial = false;
	var $_cb = false;
	var $_db = null;
	var $_cron = false;
	
	function plgJoomlistingsSendemail(&$subject, $config){
		parent::__construct( $subject, $config );
		$this->_jlsettings = JoomListingsFactory::getSettings();
		if($this->_jlsettings->jomsocial_integration == 1){
			$this->_jomsocial = true;
		}
		if($this->_jlsettings->cb_integration == 1){
			$this->_cb = true;
		}
		$this->_sender = JFactory::getUser($this->params->get('sender_id', 62));
		$this->_db =& JFactory::getDBO();
	}
	
	function onAdView($row, $user, $transaction = null, $message = null) {
		$this->_prepareAndSend('adview',$row, $user, $transaction , $message);
	}

	function onAdPost($row, $user, $transaction = null, $message = null) {
		$this->_prepareAndSend('adpost',$row, $user, $transaction , $message);
	}

	function onAdEdit($row, $user, $transaction = null, $message = null) {
		$this->_prepareAndSend('adedit',$row, $user, $transaction , $message);
	}

	function onAdPublished($row, $user, $transaction = null, $message = null) {
		$this->_prepareAndSend('adpublished',$row, $user, $transaction , $message);
	}

	function onAdFeatured($row, $user, $transaction = null, $message = null) {
		$this->_prepareAndSend('adfeatured',$row, $user, $transaction , $message);
	}

	function onAdColored($row, $user, $transaction = null, $message = null) {
		$this->_prepareAndSend('adcolored',$row, $user, $transaction , $message);
	}

	function onAdExpired($row, $user, $transaction = null, $message = null) {
		$this->_prepareAndSend('adexpired',$row, $user, $transaction , $message);
	}

	function onAdAboutToExpire($row, $user, $transaction = null, $message = null) {
		$this->_prepareAndSend('adabouttoexpire',$row, $user, $transaction , $message);
	}

	function onAdSuspend($row, $user, $transaction = null, $message = null) {
		$this->_prepareAndSend('adsuspend',$row, $user, $transaction , $message);
	}

	function onAdResumed($row, $user, $transaction = null, $message = null) {
		$this->_prepareAndSend('adresumed',$row, $user, $transaction , $message);
	}

	function onPMPost($row, $user, $transaction = null, $message = null) {
		$this->_prepareAndSend('msgsend',$row, $user, $transaction , $message, true);
	}
	
	function onPMPostReply($row, $user, $transaction = null, $message = null) {
		$this->_prepareAndSendReply('msgreply',$row, $user, $transaction , $message);
	}

	function onPMRead($row, $user, $transaction = null, $message = null) {
		$this->_prepareAndSend('msgread',$row, $user, $transaction , $message, true);
	}

	function onPackageExpire($row, $user, $transaction = null, $message = null) {
		$this->_prepareAndSendPackage('packageexpire',$row, $user, $transaction , $message);
	}
	function onPackageBuy($row, $user, $transaction = null, $message = null) {
		$this->_prepareAndSendPackage('packagebuy',$row, $user, $transaction , $message);
	}

	function onPackageAboutToExpire($row, $user, $transaction = null, $message = null) {
		$this->_cron = true;
		$this->_prepareAndSendPackage('packageabouttoexpire',$row, $user, $transaction , $message);
	}

	function onPaymentReceived($row, $user) {
		$this->_prepareAndSendTransaction('paymentreceived',$row, $user);
	}

	function onPaymentNotReceived($row, $user, $transaction = null, $message = null) {
		$this->_prepareAndSend('onpaymentnotreceived',$row, $user, $transaction , $message);
	}

	function onCleanUp($row, $user, $transaction = null, $message = null) {
		$this->_prepareAndSend('cleanup',$row, $user, $transaction , $message);
	}

	function onError($error,$user)
	{
		$this->_prepareAndSendError('error',$error, $user);
	}

	function _getData($row, $user, $transaction = null, $message = null) {
		global $mainframe;
		$recuser = JFactory::getUser($row->userid);
		$filter = array();
		$filter['sender']			= $user->get('username');
		$filter['receiver']			= $recuser->get('username');
		$filter['senderemail']		= $user->get('email');
		$filter['receivermail']		= $recuser->get('email');
		$filter['adtitle']			= $row->title;
		$filter['adlink']			= '<a href="'. JRoute::_(JURI::base()."index.php?option=com_joomlistings&c=ad&task=view&adid=".$row->id) .'">'.JRoute::_(JURI::base()."index.php?option=com_joomlistings&amp;c=ad&amp;task=view&amp;adid=".$row->id).'</a>' ;
		$filter['date']				= JHTML::_('date', date("Y-m-d G:i:s"));
		$filter['description']		= $row->description;
		if(is_object($transaction)){
			$filter['transactiondate']	= $transaction->tdate;
			$filter['amount']			= $transaction->amount;
			$filter['currency']			= $transaction->currency;
			$filter['amountwc']			= $transaction->currency." ".$transaction->amount;
			$filter['transactionid']	= $transaction->etransactionid;
			$filter['transactiondesc']	= $transaction->description;
		}
		$filter['sitename']			= $mainframe->getCfg('sitename');
		if(is_object($message)){
			$filter['subject']			= $message->subject;
			$filter['message']			= $message->message;
			$filter['messagedate']		= $message->postdate;
			$filter['messagefrom']		= $message->frommsg;
		}
		$object = new stdClass();
		$object->filter = $filter;
		$object->receiver = $recuser;
		$object->currentuser = $user;
		$object->listingid = $row->id;
		$object->sender = $this->_sender;
		return $object;
	}


	function _getDataForPayment($row, $user) {
		global $mainframe;
		$recuser = $user;
		$filter = array();
		$filter['sender']			= $this->_sender->get('username');
		$filter['receiver']			= $recuser->get('username');
		$filter['senderemail']		= $this->_sender->get('email');
		$filter['receivermail']		= $recuser->get('Email');
		$filter['transactionid']	= $row->etransactionid;
		$filter['tdate']			= $row->tdate;
		$filter['currency']			= $row->currency;
		$filter['amount']			= $row->amount;
		$filter['link']				= '<a href="'.JRoute::_(JURI::base()."index.php?option=com_joomlistings&view=transaction").'">'.JRoute::_(JURI::base()."index.php?option=com_joomlistings&view=transaction").'</a>';
		$filter['date']				= JHTML::_('date', date("Y-m-d G:i:s"));
		$filter['description']		= $row->description;
		$filter['sitename']			= $mainframe->getCfg('sitename');

		$object = new stdClass();
		$object->filter = $filter;
		$object->receiver = $recuser;
		$object->currentuser = $user;
		$object->listingid = $row->id;
		$object->sender = $this->_sender;
		return $object;


	}

	function _getDataForPackage($row, $user, $transaction = null, $message = null) {
		global $mainframe;
		$recuser = $user;
		$filter = array();
		$filter['sender']			= $this->_sender->get('username');
		$filter['receiver']			= $recuser->get('username');
		$filter['senderemail']		= $this->_sender->get('email');
		$filter['receivermail']		= $recuser->get('Email');
		$filter['title']			= $row->title;
		$filter['link']				= '<a href="'.JRoute::_(JURI::base()."index.php?option=com_joomlistings&view=mypackage").'">'.JRoute::_(JURI::base()."index.php?option=com_joomlistings&view=mypackage").'</a>';
		$filter['date']				= JHTML::_('date', date("Y-m-d G:i:s"));
		$filter['description']		= $row->description;
		$filter['sitename']			= $mainframe->getCfg('sitename');
		$filter['amount']			= $row->price . $row->currency;
		$filter['remain_expiry']	= $row->remain_expiry;
		
		$object = new stdClass();
		$object->filter = $filter;
		$object->receiver = $recuser;
		$object->currentuser = $user;
		$object->listingid = $row->id;
		$object->sender = $this->_sender;
		return $object;
	}

	function _getDataForAdmin($row, $user, $transaction = null, $message = null) {
		global $mainframe;
		$recuser = $this->_sender;
		$filter = array();
		$filter['sender']			= $user->get('username');
		$filter['receiver']			= $recuser->get('username');
		$filter['senderemail']		= $user->get('email');
		$filter['receivermail']		= $recuser->get('Email');
		$filter['adtitle']			= $row->title;
		$filter['adlink']			= '<a href="'. JRoute::_(JURI::base()."index.php?option=com_joomlistings&c=ad&task=view&adid=".$row->id) .'">'.JRoute::_(JURI::base()."index.php?option=com_joomlistings&amp;c=ad&amp;task=view&amp;adid=".$row->id).'</a>' ;
		$filter['date']				= JHTML::_('date', date("Y-m-d G:i:s"));
		$filter['description']		= $row->description;
		if(is_object($transaction)){
			$filter['transactiondate']	= $transaction->tdate;
			$filter['amount']			= $transaction->amount;
			$filter['currency']			= $transaction->currency;
			$filter['amountwc']			= $transaction->currency." ".$transaction->amount;
			$filter['transactionid']	= $transaction->etransactionid;
			$filter['transactiondesc']	= $transaction->description;
		}
		$filter['sitename']			= $mainframe->getCfg('sitename');
		if(is_object($message)){
			$filter['subject']			= $message->subject;
			$filter['message']			= $message->message;
			$filter['messagedate']		= $message->postdate;
			$filter['messagefrom']		= $message->frommsg;
		}
		$object = new stdClass();
		$object->filter = $filter;
		$object->receiver = $recuser;
		$object->currentuser = $user;
		$object->listingid = $row->id;
		$object->sender = $this->_sender;
		return $object;
	}


	function _getDataForError($error, $user) {
		global $mainframe;
		$recuser = $this->_sender;
		$filter = array();
		$filter['sender'] = $user->get('username');
		$filter['receiver'] = $recuser->get('username');
		$filter['senderemail'] = $user->get('email');
		$filter['receivermail'] = $recuser->get('Email');
		$filter['errortitle'] = $error->title;
		$filter['date'] = JHTML::_('date', date("Y-m-d G:i:s"));
		$filter['description'] = $error->message;

		$object = new stdClass();
		$object->filter = $filter;
		$object->receiver = $recuser;
		$object->currentuser = $user;
		$object->sender = $this->_sender;
		return $object;


	}

	function _prepareAndSend($event,$row, $user, $transaction = null, $message = null, $pm = false)
	{
		$object = $this->_getData($row, $user, $transaction, $message);
		$this->_sendToUser($event, $object, $pm);
		$object = $this->_getDataForAdmin($row, $user, $transaction,$message);
		$this->_sendToAdmin($event, $object, $pm);
		
	}

	
	function _prepareAndSendTransaction($event,$row, $user)
	{
		$object = $this->_getDataForPayment($row, $user);
		$this->_sendToUser($event, $object);
		$this->_sendToAdmin($event, $object);
	}
	
	function _prepareAndSendPackage($event,$row, $user, $transaction = null, $message = null)
	{
		$object = $this->_getDataForPackage($row, $user, $transaction, $message);
		$this->_sendToUser($event, $object);
	}


	function _prepareAndSendError($event,$error, $user)
	{
		$object = $this->_getDataForError($error, $user);
		$this->_sendToAdmin($event, $object);
	}

	

	function sendEmail($object, $pm = false) {
		$mailclasspath = JPATH_ROOT.DS."components".DS."com_joomlistings".DS."includes".DS."mail.class.php";
		require_once ($mailclasspath);
		$mail = new Xmail();
		$mail->setSubject($object->subject);
		$user = $object->receiver;
		$mail->setRecepients(array($user->get('email')));
		if ($object->filter['sender'] == "guest"){
			$mail->setReplyTo(array($object->filter['senderemail']));
		}
		$mail->setSender(array($object->sender->get('email'), $object->sender->get('name')));
		$transform = $this->_prepareTransformArray($object->filter);
		$mail->setBody($object->body);
		$mail->setTransform($transform);
		$mail->init();
		//fopen( JOOMLISTINGS_COMPONENT_PATH . DS .'cron_log'.date("ymd").'.txt', 'a+');
		//file_put_contents(JOOMLISTINGS_COMPONENT_PATH . DS .'cron_log'.date("ymd").'.txt', "\r\nCron Edit:". serialize($mail->cooked_body), FILE_APPEND);
		$object->sendfrom = $object->sender->get('name');
		if(!$pm) {
			$this->_saveToPMS($object, $mail);
		}
		
		if($this->_jomsocial && !$this->_cron){
			return $this->_saveToJomsocialPMS($object, $mail);
		}elseif($this->_cb && !$this->_cron){
			return $this->_saveToCbPMS($object, $mail);
		}else{
			return $mail->send();
		}
	}

	function _saveToPMS($object, $mail) {
		$pmstable = JTable::getInstance('joommessage', 'Table');
		$pmstable->subject = $mail->cooked_subject;
		$pmstable->message = $mail->cooked_body;
		$pmstable->fromid = $object->sender->get('id');
		$pmstable->frommsg = $object->sendfrom;
		$pmstable->email = $object->sender->get('email');
		$pmstable->tomsg = $object->receiver->get('id');
		$pmstable->msgtype = 2;
		$pmstable->postdate = date("Y-m-d H:i:s");
		$pmstable->status = 1;
		$pmstable->adid = $object->listingid;
		if ($pmstable->store()) {
			return true;
		} else {
			return false;
		}
	}

	function _saveToJomsocialPMS($object, $mail) {
		$pmstable = JTable::getInstance('community_msg', 'Table');
		$lastid = $pmstable->getLastID();
		$lastid = $lastid + 1;
		$pmstable->from = $object->sender->get('id');
		$pmstable->parent = $lastid;
		$pmstable->deleted = 0;
		$pmstable->from_name = $object->sender->get('username');
		$pmstable->posted_on = date("Y-m-d H:i:s");
		$pmstable->subject = $mail->cooked_subject;
		$pmstable->body = $mail->cooked_body;

		if (!$pmstable->store()) {
			return false;
		}
		$lastid = $pmstable->getLastID();
		$query="INSERT INTO #__community_msg_recepient"
		." (msg_id, msg_parent, msg_from, `to`)"
		." VALUES ({$lastid}, {$lastid}, {$object->sender->get('id')}, {$object->receiver->get('id')})";
		$this->_db->setQuery($query);
		$this->_db->query();

	    if ($this->_db->getErrorNum()) {
	        JError::raiseError(500, $this->_db->stderr());
	    }

	}
	
	function _getDataPmReply($row, $user, $transaction = null, $message = null) {
		$reply_from = JFactory::getUser($row->filter['fromid']);
		$filter = array();
		$filter['subject'] = $message->get('subject');
		$filter['message'] = $message->get('message');
		$filter['messagedate'] = $message->get('postdate');
		$filter['messagefrom'] = $reply_from->get('username');
		$object = new stdClass();
		$object->filter = $filter;
		$object->receiver = $message;
		$object->currentuser = $user;
		$object->listingid = $row->id;
		$object->sender = $this->_sender;
		return $object;
	}
	
	function _prepareAndSendReply($event,$row, $user, $transaction = null, $message = null)
	{
		$object = $this->_getDataPmReply($row, $user, $transaction, $message);
		$this->_sendToUser($event, $object, true);
		$this->_sendToAdmin($event, $object, true);
	}
	
	function _prepareTransformArray($filter){
		$transform = array();
		if (count($filter) > 0) {
			foreach ($filter as $key=>$f) {
				$transform['/{'.$key.'}/i'] = $f;
			}
		}
		return $transform;
	}
	
	function _sendToUser($event, $object){
		$query = "SELECT * from #__jlmailformats where event='$event' and published='1' and mailto='0'";
		$this->_db->setQuery($query);
		$rows = $this->_db->loadObjectList();
		if (count($rows) > 0) {
			foreach ($rows as $r) {
				$object->body = $r->body;
				$object->subject = $r->subject;
				$this->sendEmail($object);
			}
		}
	}
	
	function _sendToAdmin($event, $object, $pm = false){
		$query = "SELECT * from #__jlmailformats where event='$event' and published='1' and mailto='1'";
		$this->_db->setQuery($query);
		$rows = $this->_db->loadObjectList();
		if (count($rows) > 0) {
			foreach ($rows as $r) {
				$object->body = $r->body;
				$object->subject = $r->subject;
				$this->sendEmail($object, $pm);
			}
		}
	}
	
	function _saveToCbPMS($object, $mail) {
		$toid = $object->receiver->get('id');
		$fromid = $object->sender->get('id');
		$subject= $mail->cooked_subject;
		$message = $mail->cooked_body;
		include_once JPATH_ADMINISTRATOR . '/components/com_comprofiler/plugin.class.php';
		cbimport('cb.tables');
		global $_PLUGINS;
		$_PLUGINS->loadPluginGroup('user');
		$loadedPlugins = $_PLUGINS->getLoadedPluginGroup('user');
		$id = '';
		foreach($loadedPlugins as $lp){
			if($lp->folder == 'plug_pms_mypmspro'){
				$id = $lp->id;
				break;
			}
		}
		if($id){
			//$_PLUGINS->_loadParams($id);
			//$pmPluginObj = $_PLUGINS->getInstanceOfPluginClass('getmypmsproTab');
			//$pmPluginObj->_loadParams($id);
			//$pmPluginObj->sendUserPMS($toid, $fromid, $subject, $message);
			$args = array($toid, $fromid, $subject, $message);
			$_PLUGINS->call($id, 'sendUserPMS', 'getmypmsproTab', $args);
		}
		
		

	}

}
