<?php
/*************************************************
Author: JoomClan.com
Creation Date: 2009-11-25
Author Email: joomclan@gmail.com
Url: http://www.joomclan.com
Copyright: 2009-2010
License: GNU
Component Version: 2.1.7
Software License: All of our PHP and HTML source code is released under the GNU General Public License (GPL) to ensure it is 100% compatible with Joomla!. 
The GPL is the world's most popular Free (as in Freedom) and Open Source Software license.
Some javascript and other media (images, css, ajax scripts, flv players, mp3 players etc …) may be released under different licenses. Please see the details with the individual products.
**************************************************/

defined('_JEXEC') or die('Restricted access');

jimport("joomla.application.component.controller");

class JoomlistingsController extends JController
{
		/**
		 * Gets a reference to a subclass of the controller.
		 *
		 * @static
		 * @param string entity name
		 * @param string controller prefix
		 * @return JoomlistingsController extension controller
		 */
	
	function getInstance($entity,$prefix="JoomlistingsController")
	{
			// use a static array to store controller instances
			static $instances;
			if (!$instances)
			{
				$instances = array();
			}
			// determine subclass name
			$class = $prefix.ucfirst($entity);

			// check if we already instantiated this controller
			if (!isset($instances[$class]))
			{
				// check if we need to find the controller class
				if (!class_exists( $class ))
				{
					jimport('joomla.filesystem.file');
					$path = JPATH_COMPONENT.DS.'controllers'.DS.strtolower($entity).'.php';
					// search for the file in the controllers path
					if (JFile::exists($path))
					{
						// include the class file
						require_once $path;
						if (!class_exists( $class ))
						{
							// class file does not include the class
							return JError::raiseWarning('SOME_ERROR',
							JText::_('Invalid controller'));
						}
					}
					else
					{
						// class file not found
						return JError::raiseWarning('SOME_ERROR',
						JText::_('Unknown controller'));
					}
				}
				// create controller instance
				$instances[$class] = new $class();
			}
			// return a reference to the controller
			return $instances[$class];
	
	}
}
?>