<?php
/*************************************************
Author: JoomClan.com
Creation Date: 2009-11-25
Author Email: joomclan@gmail.com
Url: http://www.joomclan.com
Copyright: 2009-2010
License: GNU
Component Version: 2.1.7
Software License: All of our PHP and HTML source code is released under the GNU General Public License (GPL) to ensure it is 100% compatible with Joomla!.
The GPL is the world's most popular Free (as in Freedom) and Open Source Software license.
Some javascript and other media (images, css, ajax scripts, flv players, mp3 players etc …) may be released under different licenses. Please see the details with the individual products.
**************************************************/
defined('_JEXEC') or die('Restricted access');

jimport("joomla.application.component.controller");

require_once (JPATH_ROOT.DS."components".DS.'com_joomlistings'.DS."includes".DS."bill.class.php");
class JoomlistingsControllerAd extends JController
{
	function __construct(){
		parent::__construct();
		$this->registerTask('view'			, 'view');
		$this->registerTask('print_ad'		, 'printAd');
		$this->registerTask('send_email'	, 'sendEmail');
		$this->registerTask('send'			, 'send');
		$this->registerTask('ef'			, 'extraField');
		$this->registerTask('efa'			, 'efa');
		$this->registerTask('save'			, 'save');
		$this->registerTask('edit'			, 'edit');
		$this->registerTask('del'			, 'del');
		$this->registerTask('msg'			, 'sendMessage');
		$this->registerTask('contact'		, 'contact');
		$this->registerTask('adw'			, 'addWishlist');
		$this->registerTask('rw'			, 'removeWishlist');
		$this->registerTask('pay'			, 'pay');
		$this->registerTask('paynpublish'	, 'paynpublish');
		$this->registerTask('paid'			, 'paid');
		$this->registerTask('myads'			, 'listMyAds');
		$this->registerTask('report'		, 'report');
		$this->registerTask('relist'		, 'relist');
		$this->registerTask('catpacksec'	, 'listCategoryByPackageAndSection');
		$this->registerTask('listu'			, 'listByPostedUser');
	}	
	
	function display() {
		parent::display();
	}

	function view() {
		global $mainframe;
		$Itemid = JLHelper::getBaseItemid();
		JPluginHelper::importPlugin('joomlistings');
		$user =& JFactory::getUser();
		$userid = $user->get('id');
		$rmodel = $this->getModel("region");
		$sess = $rmodel->getRegion();
		if (!$user) {
			if (!$sess->rid) {
				$mainframe->redirect(JRoute::_("index.php?option=com_joomlistings&view=directory&Itemid=$Itemid", false), JText::_('SELECT_REGION'));
			}
		}
		$view =& $this->getView('ad', 'html');
		$view->setLayout('_detail');
		$package = $this->getModel("packages");
		$view->setModel($package, true);
		$pmodel = $this->getModel('profile');
		$view->setModel($pmodel, true);
		$cmodel = $this->getModel('category');
		$view->setModel($cmodel, true);
		$view->setModel($rmodel, true);
		//$view->modDisplay();
		$view->detail();
	}


	function printAd(){
		global $mainframe;
		$Itemid = JLHelper::getBaseItemid();
		JPluginHelper::importPlugin('joomlistings');
		$user =& JFactory::getUser();
		$userid = $user->get('id');
		$cmodel = $this->getModel('category');
		$settings = JoomListingsFactory::getSettings();
		$view = $this->getView('ad', 'html');
		$view->setLayout('_print');
		$package = $this->getModel("packages");
		$rmodel = $this->getModel("region");
		$sess = $rmodel->getRegion();
		if (!$user) {
			if (!$sess->rid) {
				$mainframe->redirect(JRoute::_("index.php?option=com_joomlistings&view=directory&Itemid=$Itemid", false), JText::_('SELECT_REGION'));
			}
		}
		
		$adid = JRequest::getVar('adid', $adid);
		$row = JTable::getInstance('listings', 'Table');
		
		if ($settings->enable_guest_contact_info == 1) {
			$showdetail = true;
		}else{
			$showdetail = false;
		}
		
		$category = $row->getAdCategory($adid);
		$row->loadForView($adid);
		
		$pmodel = $this->getModel('profile');
		$profile = $pmodel->getProfile($row->userid);
		$view->assignRef('ad', $row);
		$view->assignRef('user', $user);
		$view->assignRef('category', $category);
		$view->assignRef('settings', $settings);
		$view->assignRef('profile', $profile);
		$view->assignRef('showdetail', $showdetail);
		
		$sectiondetail = $cmodel->getSectionDetail($row->sectionid);

		$pathway = &$mainframe->getPathway();
		if ($settings->enable_regions) {
			$pathway->addItem($sess->region.",  ".$sess->location, JRoute::_("index.php?option=com_joomlistings&c=directory&task=change", false));
		}

		$pathway->addItem(JText::_('CATEGORIES'), JRoute::_("index.php?option=com_joomlistings&view=directory", false));


		if ($settings->enable_sections) {
			$slink = JRoute::_("index.php?option=com_joomlistings&c=directory&task=cat&sid=$row->sectionid", false);
			$pathway->addItem($sectiondetail->title, $slink);
		}
		$pathway->addItem($category->title, JRoute::_("index.php?option=com_joomlistings&c=listing&cid=".$category->id, false));
		$pathway->addItem($row->title, '');
		$mainframe->triggerEvent('onAdView', array($row, $user));
		
		$view->modDisplay();
	}



	function sendEmail() {
		global $mainframe;
		$Itemid = JLHelper::getBaseItemid();
		JPluginHelper::importPlugin('joomlistings');
		$user =& JFactory::getUser();
		$userid = $user->get('id');
		$cmodel = $this->getModel('category');
		$settings = JoomListingsFactory::getSettings();
		$view = $this->getView('ad', 'html');
		$view->setLayout('_send_email');
		$package = $this->getModel("packages");
		$rmodel = $this->getModel("region");
		$sess = $rmodel->getRegion();
		if (!$user) {
			if (!$sess->rid) {
				$mainframe->redirect(JRoute::_("index.php?option=com_joomlistings&view=directory&Itemid=$Itemid", false), JText::_('SELECT_REGION'));
			}
		}
		
		$adid = JRequest::getVar('adid', $adid);
		$row = JTable::getInstance('listings', 'Table');
		
		if ($settings->enable_guest_contact_info == 1) {
				$showdetail = true;
		}else{
			$showdetail = false;
		}

		$category = $row->getAdCategory($adid);
		$row->loadForView($adid);
		$pmodel = $this->getModel('profile');
		$profile = $pmodel->getProfile($row->userid);
		$view->assignRef('ad', $row);

		$view->assignRef('user', $user);
		$view->assignRef('category', $category);
		$view->assignRef('settings', $settings);
		$view->assignRef('profile', $profile);
		$view->assignRef('showdetail', $showdetail);

		$sectiondetail = $cmodel->getSectionDetail($row->sectionid);

		$pathway = &$mainframe->getPathway();
		if ($settings->enable_regions) {
			$pathway->addItem($sess->region.",  ".$sess->location, JRoute::_("index.php?option=com_joomlistings&c=directory&task=change", false));
		}

		$pathway->addItem(JText::_('CATEGORIES'), JRoute::_("index.php?option=com_joomlistings&view=directory", false));


		if ($settings->enable_sections) {
			$slink = JRoute::_("index.php?option=com_joomlistings&c=directory&task=cat&sid=$row->sectionid", false);
			$pathway->addItem($sectiondetail->title, $slink);
		}
		$pathway->addItem($category->title, JRoute::_("index.php?option=com_joomlistings&c=listing&cid=".$category->id, false));
		$pathway->addItem($row->title, '');

		$mainframe->triggerEvent('onAdView', array($row, $user));

		$view->modDisplay();
	}

	function send(){
		global $mainframe;
		$user = JFactory::getUser();
		$to 		= JRequest::getVar('main_email');
		$bcc 		= JRequest::getVar('bcc_email');
		$bcc 		= explode(',', $bcc);
		$message 	= JRequest::getVar('message');
		$adid 		= JRequest::getVar('adid');
		$my_name		= JRequest::getVar('my_name');
		$my_email		= JRequest::getVar('my_email');
		$friend_name	= JRequest::getVar('friend_name');
		$listing_link 	= JURI::base() . "index.php?option=com_joomlistings&c=ad&task=view&adid=" . $adid;
		$listing_link 	= JRoute::_($listing_link);
		$body_message = "Hello ".$friend_name . "<br/>";
		$message .= "<br/>";
		$message .= $listing_link;
		$body_message .= $message . "<br/>";
		$body_message .= $my_name . "<br/>";
		$mailer =& JFactory::getMailer();
		$mode = true;
		$mailer->setSender($user->email, $my_name);
		$mailer->setSubject('Please check a listing');
		$mailer->setBody($body_message);
		$mailer->IsHTML($mode);
		if ( is_array($bcc) ) {
			foreach ($bcc as $email) {
				$mailer->addBCC(trim($email));
			}
			$mailer->addRecipient($to);
		}
		$rs	= $mailer->Send();
		$msg = "";
		if ( JError::isError($rs) ) {
			$msg	= $rs->getMessage();
		} else {
			$msg = $rs ? 'You send mail successfully' : JText::_('The mail could not be sent');
		}
		echo '<div align="center" style="font-weight: bold; color: #038ad2; font-style: italic; font-size: 20px; padding-top: 120px;">'.$msg.'</div>';
		die();
	}

	function isValidEmail($email){
		return eregi("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$", $email);
	}


	function extraField(){
		$cid = JRequest::getVar('cid', 0);
		$adid = JRequest::getVar('adid', 0);
		$efmodel = $this->getModel('category');
		$efs = $efmodel->getExtraFields($cid, $adid);
		$view = $this->getView('ad', 'html');
		$view->setLayout('_extrafield');
		$view->assignRef('extrafields', $efs);
		$view->modDisplay();
	}

	function efa(){
		$cid = JRequest::getVar('cid', 0);
		$adid = JRequest::getVar('adid', 0);

		$efmodel = $this->getModel('category');
		$efs = $efmodel->getExtraFields($cid, $adid);

		$view = $this->getView('ad', 'html');
		$view->setLayout('_extrafielda');
		$view->assignRef('extrafields', $efs);
		$view->modDisplay();
	}

	function save(){
		global $mainframe;
		JPluginHelper::importPlugin('joomlistings');
		$user =& JFactory::getUser();
		$userid = $user->get('id');
		if ($userid) {
			$settings = JoomListingsFactory::getSettings();
			$model = $this->getModel('listing');
			$data = JRequest::get('post');
			$files = JRequest::get('files');
			if($settings->enable_anti_spam == 1){
				$this->_checkCaptcha();
			}
			try{
				$pid = JRequest::getVar('pid', '');
				$toFeature = JRequest::getInt('featured', 0);
				$toColor = JRequest::getInt('listingtype', 0);
				$catid = JRequest::getInt('catid', 0);
				$edit = $adid = JRequest::getVar('adid', 0);
				if($adid){
					$data['id'] = $adid;
					$clisting = JTable::getInstance('listings', 'Table');
					$clisting->load($adid);
					$pid = $clisting->pid;
				}
				$adinfo = $this->_prepareAdinfo($adid, $model, $toFeature, $toColor);
				$checkCanPostExpired = $this->_checkCanPostAndExpired($userid, $adid, $pid);
				if ($checkCanPostExpired['canPost']) {
					if (!$checkCanPostExpired['expired']) {
						$adid = '';
						$pmodel = $this->getModel('profile');
						$userinfo = $pmodel->getPackageInfo($userid, $pid);
						
						$pay = $model->hasTopay($userinfo, $adinfo);
						$ret = $this->_preparePayMessage($pay);
						$data = array_merge($data, $ret['data']);
						if($pay){
							$adid = $this->_storeData($data, $edit, $userinfo);
							$redir = JRoute::_("index.php?option=com_joomlistings&c=ad&task=pay&ad=$pay->pay_for_ad&f=$pay->pay_for_featured&color=$pay->pay_for_color&pid=$pid&adid=$adid", false);
							$msg = $ret['msg'];
						}
						else{
							$data['featured'] = isset($data['featured']) ? $data['featured'] : 0;
							$adid = $this->_storeData($data, $edit, $userinfo);
							$msg = "Your Ad has been posted Successfully" . $ret['msg'];
							$redir = html_entity_decode(JRoute::_("index.php?option=com_joomlistings&view=myads", false));
						}
						$this->_moveUploadedFile($adid, $data['jlhash'], $userid);
					}
					else{
						$linkx = JRoute::_("index.php?option=com_joomlistings&view=mypackage");
						$msg = JText::_("YOUR_PACKAGE_EXPIRED");
						$mainframe->redirect($linkx, $msg);
					}
				}
				else{
					$msg = "You have used your all ads. You cannot post this ad";
					$redir = html_entity_decode(JRoute::_("index.php?option=com_joomlistings&view=myads", false));
				}
				$mainframe->redirect($redir, $msg);
			}
			catch(Exception $e) {
				$redir = html_entity_decode(JRoute::_("index.php?option=com_joomlistings&view=ad&layout=post", false));
				$error=new stdClass();
				$error->title=$e->getMessage();
				$error->description=$e->getTraceAsString();
				$mainframe->triggerEvent('error', array($error, $user));
				$mainframe->redirect($redir, $e->getMessage());

			}
		}
		else {
			$link = base64_encode(JRoute::_("index.php?option=com_joomlistings&view=ad&layout=post", false));
			$rlink = JRoute::_("index.php?option=com_user&view=login&return=$link", false);
			$msg = JText::_("LOGIN_TO_ACCESS");
			$mainframe->redirect($rlink, $msg);
		}
	}

	function edit() {
		global $mainframe;
		$user =& JFactory::getUser();
		$userid = $user->get('id');
		if ($userid){
			$view = $this->getView('ad', 'html');
			$view->setLayout('_edit');
			$cmodel = $this->getModel('category');
			$view->setModel($cmodel, true);
			$rmodel = $this->getModel("Region");
			$view->setModel($rmodel, true);
			$view->editAd();
			
		} else {
			$link2 = JRoute::_("index.php?option=com_joomlistings&c=ad&task=edit&cid[]=$adid", false);
			$return = base64_encode($link);
			$link = JRoute::_("index.php?option=com_user&view=login&return=$return", false);
			$msg = JText::_("LOGIN_TO_ACCESS");
			$mainframe->redirect($link, $msg);
		}
	}

	function del() {
		global $mainframe;
		$adid = JRequest::getVar('cid');
		$model = $this->getModel('listing');
		$model->delete(array($adid));
		$redir = html_entity_decode(JRoute::_("index.php?option=com_joomlistings&view=myads", false));
		$mainframe->redirect($redir, "Your Ad has been deleted Successfully");
	}

	function sendMessage() {
		global $mainframe;
		JPluginHelper::importPlugin('joomlistings');
		$settings = JoomListingsFactory::getSettings();
		try {
			$user = JFactory::getUser();
			$userid = $user->get('id');
			$adid = JRequest::getVar('adid');
			if($settings->enable_anti_spam == 1)
			{
				// reCaptcha
				require_once (JPATH_SITE.DS.'components'.DS.'com_joomlistings'.DS.'includes'.DS.'recaptchalib.php');
				$privatekey = $settings->captcha_private_key;

				// the response from reCAPTCHA
				$resp = null;
				// the error code from reCAPTCHA, if any
				$error = null;

				// was there a reCAPTCHA response?
				$recaptcha_response_field = JRequest::getVar('recaptcha_response_field', '', 'post', 'string');
				if ( $recaptcha_response_field !='' ) {
						$resp = recaptcha_check_answer ($privatekey,
														$_SERVER["REMOTE_ADDR"],
														$_POST["recaptcha_challenge_field"],
														$recaptcha_response_field);

						if (!$resp->is_valid) {
							// set the error code so that we can display it
							$error = $resp->error;
							JError::raiseWarning(0, JText::_($error) );
							//$this->register(JRequest::get('post'));
							$this->contact(JRequest::get('post'));

							return false;
						}
				} else {
						JError::raiseWarning(0, JText::_('ARG_YOU_MUST_ENTER_THE_VERIFICATION_CODE') );
						//$this->register(JRequest::get('post'));
						$this->contact(JRequest::get('post'));
						return false;
				}

			}

			if ($settings->enable_guest_contact == 1 || ($settings->enable_guest_contact == 0 && $userid != 0)) {
				$model = $this->getModel('message');

				$link = JRoute::_("index.php?option=com_joomlistings&view=message", false);
				$data = JRequest::get('post');

				if($userid != 0){
					$data['fromid'] = $userid;
					$data['frommsg'] = $user->get('username');
					$data['email'] = $user->get('email');
				}else{
					$user->name = $data['frommsg'];
					$user->username = 'guest';
					$user->email =  $data['email'];
				}

				$data['msgtype'] = '1';

				$msgid= $model->save($data);

				$row = JTable::getInstance('listings', 'Table');
				$row->load($adid);
				$message = JTable::getInstance('joommessage', 'Table');
				$message->load($msgid);

				$mainframe->triggerEvent('onPMPost', array($row, $user, null, $message));

				$msg = JText::_('MSG_SUCCESSFUL');

			} else {
				$xlink = base64_encode(JRoute::_("index.php?option=com_joomlistings&c=ad&task=view&adid=$adid", false));
				$link = JRoute::_("index.php?option=com_user&view=login&return=$xlink", false);
				$msg = JText::_("LOGIN_TO_ACCESS");
				$mainframe->redirect($link, $msg);
			}

		}

		catch(Exception $e) {
			$msg = $e->getMessage();
		}

		$link = JRoute::_("index.php?option=com_joomlistings&c=ad&task=view&adid=$adid", false);
		$mainframe->redirect($link, $msg);

	}

	function contact(){
		global $mainframe;
		$adid = JRequest::getVar('adid');
		$row = JTable::getInstance('listings', 'Table');
		$row->loadForView($adid);
		$view = $this->getView('_contact', 'html');
		$view->assignRef('ad', $row);
		$user = JFactory::getUser();
		$view->assignRef('user', $user);
		$userid = $user->get('id');
		$view->display();
	}

	function addWishlist() {
		global $mainframe;
		JPluginHelper::importPlugin('joomlistings');
		$adid = JRequest::getVar('adid', 0);
		$user = JFactory::getUser();
		$link = "";
		if ($user->get('id')) {
			$row = JTable::getInstance('Wishlist', 'Table');
			$row->adid = $adid;
			$row->userid = $user->get('id');
			$row->postdate = date("Y-m-d G:i:s");
			try {
				$row->store();
				$link = $_SERVER['HTTP_REFERER'];
				$msg = JText::_('ADDED_TO_WL');

				$stable = JTable::getInstance('setting', 'Table');
				$settings = $stable->getSettings();

				$row1 = JTable::getInstance('listings', 'Table');
				$row1->load($adid);
				$mainframe->triggerEvent('onWishlistPOST', array($row1, $user, $settings));
			}
			catch(Exception $e) {
				$error=new stdClass();
				$error->title=$e->getMessage();
				$error->description=$e->getTraceAsString();
				$mainframe->triggerEvent('error', array($error, $user));
				$link = $_SERVER['HTTP_REFERER'];
				$msg = $e->getMessage();

			}

		} else {

			$returnurl = base64_encode($_SERVER['HTTP_REFERER']);
			$link = JRoute::_("index.php?option=com_user&view=login&return=$returnurl", false);
			$msg = JText::_("LOGIN_TO_ACCESS");

		}
		$mainframe->redirect($link, $msg);
	}

	function removeWishlist() {
		global $mainframe;
		JPluginHelper::importPlugin('joomlistings');
		$wid = JRequest::getVar('wid', 0);
		$user = JFactory::getUser();
		$link = "";
		if ($user->get('id')) {
			$model = $this->getModel('wishlist');

			try {
				$model->remove($wid);
				$link = $_SERVER['HTTP_REFERER'];
				$msg = "Removed from your wishlist";
			}
			catch(Exception $e) {
				$error=new stdClass();
				$error->title=$e->getMessage();
				$error->description=$e->getTraceAsString();
				$mainframe->triggerEvent('error', array($error, $user));
				$link = $_SERVER['HTTP_REFERER'];
				$msg = $e->getMessage();
			}

		} else {

			$returnurl = base64_encode($_SERVER['HTTP_REFERER']);
			$link = JRoute::_("index.php?option=com_user&view=login&return=$returnurl", false);
			$msg = JText::_("LOGIN_TO_ACCESS");


		}
		$mainframe->redirect($link, $msg);
	}


	function pay() {
		global $mainframe;
		$user = JFactory::getUser();
		$userid = $user->get('id');
		if ($userid) {
			$model = $this->getModel('listing');
			$featured = JRequest::getVar('f', 0);
			$payforad = JRequest::getVar('ad', 0);
			$colored = JRequest::getVar('color', 0);
			$pid = JRequest::getInt('pid', 0);
			$settings = JoomListingsFactory::getSettings();
			$pmodel = $this->getModel('profile');
			$profile = $pmodel->getProfile($userid);
			$userinfo = $pmodel->getPackageInfo($userid, $pid);
			$adid = (int) JRequest::getVar('adid', 0);
			$s = $model->isPublishedAndFeatured($adid);
			$isPublished = $s->published;
			$isFeatured = $s->featured;
			$isColored = $s->listingtype;
			$paymodel = $this->getModel('payment');
			$payx = $paymodel->howMuchToPay($userinfo, $settings, $payforad, $featured, $colored);
			$basket = new JBasket(false);
			$itemid = date("Ymdgis").$adid;
			if ($payx->ad) {
				$item = new JItem($itemid, JText::_('CLASSIFIED_AD'), $userinfo->currency, $payx->ad, 1, JText::_("PAY_FOR_AD"));
				$basket->addItem($item);
			} else {
				//$model->publishAd($adid);
			}
			if ($payx->feature) {
				$itemid = date("Ymdgis").$adid.'F';
				$item = new JItem($itemid,JText::_('FEATURED_AD'), $userinfo->currency, $payx->feature, 1, JText::_("PAY_FOR_FEATURED"));
				$basket->addItem($item);
			} elseif ($isFeatured) {
				//$model->featureAd($adid);
			}
			if ($payx->color) {
				$itemid = date("Ymdgis").$adid.'C';
				$item = new JItem($itemid, JText::_('COLORED_AD'), $userinfo->currency, $payx->color, 1, JText::_("PAY_FOR_COLOR"));
				$basket->addItem($item);
			} elseif ($isColored) {
				//$model->colorAd($adid, $colored);
			}
			if (!$basket->isEmpty()) {
				$billing = new JAddress($profile->address, $profile->address2, $profile->city, $profile->state, $profile->zipcode, $profile->country);
				$bill = new JBill($basket->getItems(), $billing);
				$bill->setUser($profile);
				$bill->setCurrency($userinfo->currency);
				$bill->calculateTotal();
				$bill->setDescription('Price for Ad Post');
				$returnurl = base64_encode(JRoute::_("index.php?option=com_joomlistings&c=ad&task=paid&adid=$adid&f=$featured&color=$colored", false));
				$paymentpath = JPATH_COMPONENT.DS."includes".DS."payment.class.php";
				require_once ($paymentpath);
				$payment = new Payment();
				$payment->setInvoice($bill);
				$payment->setInurl($returnurl);
				if($payx->feature && $payx->color){
					$payment->setCustom(base64_encode("pay__forpublishandfeaturedandcolored__".$adid."_".$featured."_".$colored));
				}elseif($payx->feature){
					$payment->setCustom(base64_encode("pay__forpublishandfeatured__".$adid."_".$featured));
				}elseif($payx->color){
					$payment->setCustom(base64_encode("pay__forpublishandcolored__".$adid."_".$colored));
				}else{
					$payment->setCustom(base64_encode("pay__forpublish__".$adid));
				}
				$payment->setOption('com_joomlistings', "package", "");
				$payment->showInvoice();
			} else {
				$link = JRoute::_("index.php?option=com_joomlistings&view=myads", false);
				$msg = "Your ad is published";
				$mainframe->redirect($link, $msg);
			}


		} else {
			$link = base64_encode(JRoute::_("index.php?option=com_joomlistings&view=ad&layout=post", false));
			$rlink = JRoute::_("index.php?option=com_user&view=login&return=$link", false);
			$msg = JText::_("LOGIN_TO_ACCESS");
			$mainframe->redirect($rlink, $msg);
		}
	}

	function paynpublish() {
		global $mainframe;
		$user = JFactory::getUser();
		$userid = $user->get('id');
		if ($userid) {
			$model = $this->getModel('listing');
			$featured = JRequest::getVar('f', 0);
			$payforad = JRequest::getVar('ad', 1);
			$colored = JRequest::getVar('color', 0);
			$settings = JoomListingsFactory::getSettings();
			$pmodel = $this->getModel('profile');
			$profile = $pmodel->getProfile($userid);
			$userinfo = $pmodel->getPackageInfo($userid);
			$adid = JRequest::getVar('adid');
			$s = $model->isPublishedAndFeatured($adid);
			$isPublished = $s->published;
			$isFeatured = $s->featured;
			$isColored = $s->listingType;
			$paymodel = $this->getModel('payment');
			$payx = $paymodel->howMuchToPay($userinfo, $settings, $payforad, $featured, $colored);
			$basket = new JBasket(false);
			$itemid = date("Ymdgis").$adid;
			if ($payx->ad) {
				$item = new JItem($itemid, JText::_('CLASSIFIED_AD'), $settings->currency, $payx->ad, 1, JText::_("PAY_FOR_AD"));
				$basket->addItem($item);
			} else {
				//$model->publishAd($adid);
			}
			if ($payx->feature) {
				$itemid = date("Ymdgis").$adid.'F';
				$item = new JItem($itemid, JText::_('FEATURED_AD'), $settings->currency, $payx->feature, 1, JText::_("PAY_FOR_FEATURED"));
				$basket->addItem($item);

			} elseif ($isFeatured) {
				$model->featureAd($adid);
			}
			if ($payx->color) {
				$itemid = date("Ymdgis").$adid.'C';
				$item = new JItem($itemid, JText::_('COLORED_AD'), $settings->currency, $payx->color, 1, JText::_("PAY_FOR_COLOR"));
				$basket->addItem($item);

			} elseif ($isColored) {
				$model->colorAd($adid, $isColored);
			}

			if (!$basket->isEmpty()) {
				$billing = new JAddress($profile->address, $profile->address2, $profile->city, $profile->state, $profile->zipcode, $profile->country);
				$bill = new JBill($basket->getItems(), $billing);
				$bill->setUser($profile);
				$bill->setCurrency($settings->currency);
				$bill->calculateTotal();
				$bill->setDescription('PAY_FOR_AD');
				$returnurl = base64_encode(JRoute::_("index.php?option=com_joomlistings&c=ad&task=paid&adid=$adid&f=$featured&color=$colored&uid=$userid", false));
				$paymentpath = JPATH_COMPONENT.DS."includes".DS."payment.class.php";
				require_once ($paymentpath);
				$payment = new Payment();
				$payment->setInvoice($bill);
				$payment->setInurl($returnurl);
				$payment->setCustom(base64_encode("pay__forpublish__".$adid));
				$payment->setOption(com_joomlistings, "package", "");
				$payment->showInvoice();
			} else {
				$link = JRoute::_("index.php?option=com_joomlistings&view=myads", false);
				$msg = "Your ad is published";
				$mainframe->redirect($link, $msg);
			}
		} else {
			$link = base64_encode(JRoute::_("index.php?option=com_joomlistings&view=ad&layout=post", false));
			$rlink = JRoute::_("index.php?option=com_user&view=login&return=$link", false);
			$msg = JText::_("LOGIN_TO_ACCESS");
			$mainframe->redirect($rlink, $msg);
		}
	}

	function paid() {
		global $mainframe;
		JPluginHelper::importPlugin('joomlistings');
		$userid = JRequest::getVar('uid', 0);
		if ($userid) {
			$listing = $this->getModel('listing');
			$adid = JRequest::getVar('adid', 0);
			$f = JRequest::getVar('f', 0);
			$color = JRequest::getVar('color', 0);
			$user = JFactory::getUser($userid);
			$settings = JoomListingsFactory::getSettings();
			$row = JTable::getInstance('listings', 'Table');
			$row->load($adid);
			$mainframe->triggerEvent('onPaymentReceived', array($row, $user, $transaction));
			$link = JRoute::_("index.php?option=com_joomlistings&view=transaction", false);
			if ($listing->publishAd($adid)) {
				$mainframe->triggerEvent('onAdPublished', array($row, $user));
				$msg = JText::_('AD_SUCCESSFULLY_PUBLISHED');
			} else {
				$mainframe->triggerEvent('onAdNotPublished', array($row, $user));
				$msg = JText::_('SUCCESSFUL_PAYMENT_NO_PUBLISH');
			}
			if ($f) {
				if ($listing->featureAd($adid)) {
					$mainframe->triggerEvent('onAdFeatured', array($row, $user));
					$msg = JText::_('AD_SUCCESSFULLY_FEATURED');
				} else {
					$mainframe->triggerEvent('onAdNotFeatured', array($row, $user));
					$msg = JText::_('SUCCESSFUL_PAYMENT_NO_FEATURE');
				}
			}
			if ($color) {
				if ($listing->colorAd($adid, $color)) {
					$mainframe->triggerEvent('onAdColored', array($row, $user));
					$msg = JText::_('AD_SUCCESSFULLY_COLORED');
				} else {
					$mainframe->triggerEvent('onAdNotColored', array($row, $user));
					$msg = JText::_('SUCCESSFUL_PAYMENT_NO_COLOR');
				}
			}
		} else {
			$link = base64_encode(JRoute::_("index.php?option=com_joomlistings&view=transaction", false));
			$rlink = JRoute::_("index.php?option=com_user&view=login&return=$link", false);
			$msg = JText::_("LOGIN_TO_ACCESS");
			//   $mainframe->redirect($rlink, $msg);
		}

		$mainframe->redirect($link, $msg);
	}


	function listMyAds() {
		global $mainframe;
		$user = JFactory::getUser();
		$userid = $user->get('id');
		$view = $this->getView('myads', 'html');
		if ($userid) {
			$limitstart = JRequest::getVar('limitstart', 0);
			$limit = JRequest::getVar('limit', 15);
			$filter = new stdClass ();
			$infilter = new stdClass ();
			$infilter->state = JRequest::getVar('state', -1);
			$infilter->text = JRequest::getVar('srchtext', "");
			$filter->srchtext = JRequest::getVar('srchtext', "");
			$model = $this->getModel('listing');
			$myads = $model->getMyAds($userid, $infilter, $limitstart, $limit);
			$total = $model->getMyAdsCount($userid, $infilter);
			jimport("joomla.html.pagination");
			$pagenav = new JPagination($total, $limitstart, $limit);
			$view->assignRef('ads', $myads);
			$view->assignRef('pagenav', $pagenav);
			
			$state[] = JHTML::_('select.option', '-1', JText::_('All'), 'id', 'title');
			$state[] = JHTML::_('select.option', '1', JText::_('Published'), 'id', 'title');
			$state[] = JHTML::_('select.option', '0', JText::_('Unpublished'), 'id', 'title');

			$filter->states = JHTML::_('select.genericlist', $state, 'state', 'class="inputbox" size="1"', 'id', 'title', intval($infilter->state));
			$view->assignRef('filter', $filter);
			$view->modDisplay();
		} else {
			$link = base64_encode(JRoute::_("index.php?option=com_joomlistings&c=ad&task=myads", false));
			$rlink = JRoute::_("index.php?option=com_user&view=login&return=$link");
			$msg = JText::_("LOGIN_TO_ACCESS");
			$mainframe->redirect($rlink, $msg);
		}
	}

	// ajax get country_id, state_id , location_id by country_code, state_code, location_name
//	function csr(){
////		$model = $this->getModel('country');
////		$country_id = $model->getCountryIdByCountryCode(JRequest::getVar('cc'));
//		$rModel = $this->getModel('region');
//		$rid = $rModel->getRidByCode(JRequest::getVar('rc'));
//		$lid = $rModel->getLocationIdByName(trim(JRequest::getVar('lc')), $rid);
//		echo $rid.";". $lid;
//		jexit();
//	}
//	
//	//ajax function check user package category
//	function cupc(){
//		$db =& JFactory::getDBO();
//		$uid = JRequest::getInt('uid');
//		$cid = JRequest::getInt('cid');
//		$query = "SELECT packageid FROM #__jlusers_packages WHERE userid = '$uid' AND published = 1 AND (expirydate = -1 OR expirydate >= curdate())";
//		$db->setQuery($query);
//		$currentUserPackages = $db->loadResultArray();
//		$query = "SELECT package_id FROM #__jlcategory_package WHERE category_id = '$cid'";
//		$db->setQuery($query);
//		$categoryPackages = $db->loadResultArray();
//		$inter = array_intersect($currentUserPackages, $categoryPackages);
//		if(count($inter)< 1){
//			echo JText::_("You need proper package to post and publish an ad in this category. Your ad will be published after you pay for proper package");
//		}
//		jexit();
//	}
	
	function _checkCaptcha(){
		$settings = JoomListingsFactory::getSettings();
		//reCaptcha
		require_once (JPATH_SITE.DS.'components'.DS.'com_joomlistings'.DS.'includes'.DS.'recaptchalib.php');
		$privatekey = $settings->captcha_private_key;
		// the response from reCAPTCHA
		$resp = null;
		// the error code from reCAPTCHA, if any
		$error = null;

		// was there a reCAPTCHA response?
		$recaptcha_response_field = JRequest::getVar('recaptcha_response_field', '', 'post', 'string');
		if ( $recaptcha_response_field !='' ) {
			$resp = recaptcha_check_answer ($privatekey,
											$_SERVER["REMOTE_ADDR"],
											$_POST["recaptcha_challenge_field"],
											$recaptcha_response_field);

			if (!$resp->is_valid) {
				// set the error code so that we can display it
				$error = $resp->error;
				JError::raiseWarning(0, JText::_($error) );
				$adid = JRequest::getVar('adid', '');
				$url = "";
				if($adid != '')
				{
					$url = JRoute::_( JURI::base() . 'index.php?option=com_joomlistings&c=ad&task=edit&cid[0]=' . $adid);
				} else {
					$url = JURI::base() . 'index.php?option=com_joomlistings&view=ad&layout=post';
					unset($data['task']);
					unset($data['c']);
					unset($data['option']);
					unset($data['layout']);
					unset($data['recaptcha_challenge_field']);
					unset($data['recaptcha_response_field']);

					foreach($data as $key=>$value)
					{
						if($key != 'field')
						{
							$url .= '&' . $key . '=' . $value;
						} else {
							foreach($value as $v=>$val)
							{
								$url .= '&field['.$v.']' . '=' . $val;
							}
						}
					}
				}
				$mainframe->redirect($url);
				return false;
			}
		} 
		else{
			JError::raiseWarning(0, JText::_('ARG_YOU_MUST_ENTER_THE_VERIFICATION_CODE') );
			//$this->register(JRequest::get('post'));
			//$this->contact(JRequest::get('post'));
			$adid = JRequest::getVar('adid', '');
			$url = "";
			if($adid != '')
			{
				$url = JRoute::_( JURI::base() . 'index.php?option=com_joomlistings&c=ad&task=edit&cid[0]=' . $adid);
			} else {
				$url = JURI::base() . 'index.php?option=com_joomlistings&view=ad&layout=post';

				unset($data['task']);
				unset($data['option']);
				unset($data['c']);
				unset($data['layout']);
				unset($data['recaptcha_challenge_field']);
				unset($data['recaptcha_response_field']);

				foreach($data as $key=>$value)
				{
					if($key != 'field')
					{
						$url .= '&' . $key . '=' . $value;
					} else {
						foreach($value as $v=>$val)
						{
							$url .= '&field['.$v.']' . '=' . $val;
						}
					}
				}
			}

			$mainframe->redirect($url);
			return false;
		}
	}
	
	function _checkCanPostAndExpired($userid, $adid, $pid = ''){
		$canPost = false;
		$expired = false;
		$ret = array();
		$pay_for_package = false;
		$settings = JoomListingsFactory::getSettings();
		if((!$settings->payable && ! $settings->enable_packages) ||($settings->payable && $settings->enable_packages)){
			return array('canPost'=> false, 'expired'=>false);
		}
		if ($adid){
			$canPost = true;
		}else{
			$canPost = false;
		}
		if ($settings->payable) {
			$canPost = true;
			$expired = false;
		}
		
		if ($settings->enable_packages) {
			$pamodel = JModel::getInstance('packages', 'JoomlistingsModel');
			$info = $pamodel->getPackageInfoOfUser($userid, $pid);
			if(count($info)>0){
				$pi = $info[0];
				if((($pi->days == -1 || $pi->expirydate == -1) && $pi->used < $pi->adsnumber)  || $pi->adsnumber == -1){
					$canPost = true;
				}
				else{
					$today = date("Y-m-d H:i:s");
					if($today > $pi->expirydate){
						$canPost = false;
						$expired = true;
					}
					elseif($pi->used >= $pi->adsnumber){
						$canPost = false;
						$expired = true;
					}
					else{
						$canPost = true;
					}
				}
			}
			else{
				$canPost = false;
			}
		}
		$ret = array('canPost' => $canPost, 'expired' => $expired);
		return $ret;
	}
	
	function _preparePayMessage($pay){
		$settings = JoomListingsFactory::getSettings();
		$featured = $toFeature && !$isFeatured;
		$colored = $toColor && !$listingType;
		$paymsg = array();
		$data = array();
		if($pay != false){
			$data['published'] = 0;
			if ($pay->pay_for_featured) {
				if ($userinfo->priceforfeatured > 0) {
					$data['featured'] = 0;
					$paymsg[] = " featured ";
				}
				else{
					$data['featured'] = isset($data['featured']) ? $data['featured'] : 0;
				}
			}
			if ($pay->pay_for_color) {
				switch ($pay->pay_for_color) {
					case 1:
						$paymsg[] = " colored ";
						$data['listingtype'] = 1;
						break;
					case 2:
						$paymsg[] = " colored ";
						$data['listingtype'] = 2;
						break;
					case 3:
						$paymsg[] = " bold ";
						$data['listingtype'] = 3;
						break;
					default:
						$data['listingtype'] = 0;
						break;
				}
			}
			if ($pay->pay_for_ad) {
				$paymsg[] = " activated ";
			}
			$paymessage = implode("and", $paymsg);
			$msg = "Your Ad has been saved Successfully. But it will be $paymessage as soon as you make the payment for ad.";
		}
		return array('data'=>$data, 'msg'=> $msg);				
	}
	
	function _storeData($data, $edit, $userPackageInfo){
		global $mainframe;
		$user =& JFactory::getUser();
		$model = $this->getModel('listing');
		$settings = JoomListingsFactory::getSettings();
		$adid = $model->save($data, JRequest::get('files'), $userPackageInfo, $edit);
		$newrow = JTable::getInstance('listings', 'Table');
		$newrow->load($adid);
		$alphabet = array('A', 'B', 'C', 'D', 'E', 'F','G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z');
		shuffle($alphabet);
		$newrow->listingid = $newrow->id . '-' . $alphabet[0] . $alphabet[1] . $alphabet[2];
		$newrow->store();
		$rowx = JTable::getInstance('listings', 'Table');
		$rowx->load($adid);
		if($edit){
			$mainframe->triggerEvent('onAdEdit', array($rowx, $user));
		}
		else{
			$mainframe->triggerEvent('onAdPost', array($rowx, $user));
		}
		return $adid;
	}
	
	function report(){
		$adid = JRequest::getVar('cid', 0);
		$report_reason = JRequest::getVar('aid', 0);
		if($adid && $report_reason){
			$db =& JFactory::getDBO();
			$query = "INSERT INTO #__jlreports(id, ad_id, reason_id, published) VALUES ('', '$adid', '$report_reason', 1)";
			$db->setQuery($query);
			$db->query();
		}
		echo JText::_("Thank you for taking the time to report this Ad. We have been notified and will investigate.");
		jexit();
	}
	
	function _moveUploadedFile($adid, $jlhash, $userid){
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.folder');
		$settings = JoomListingsFactory::getSettings();
		$user =& JFactory::getUser();
		$db =& JFactory::getDBO();
		
		if(JFolder::exists(JPATH_ROOT . DS . 'tmp' . DS . $jlhash)){
			$files = JFolder::files(JPATH_ROOT . DS . 'tmp' . DS . $jlhash . DS);
			//fopen( JPATH_BASE . DS . 'logs' . DS .'log'.date("ymd").'.txt', 'a+');
			//file_put_contents(JPATH_BASE . DS . 'logs' . DS .'log'.date("ymd").'.txt', "\r\nFile Data:". serialize($files), FILE_APPEND);
			if(is_array($files) && count($files) > 0){
				$query = "INSERT INTO #__jlvdocs(id, adid, filename, fileext, originname, user_id) VALUES";
				$insValue = array();
				$allowable = explode( '|', $settings->upload_extension_allow);
				$hasInsert = false;
				foreach($files as $file){
					$ext = strtolower(JFile::getExt($file));
					if(in_array($ext, $allowable)){
						$dest = JOOMLISTINGS_VIDEO_DOCS_PATH . DS . $user->get('id') . DS . $adid;
						if(!JFolder::exists($dest)) JFolder::create($dest);
						JFile::move(JPATH_ROOT . DS . 'tmp' . DS . $jlhash . DS . $file, $dest. DS . $file);
						$hasInsert = true;
						$origin = explode("__", $file);
						$origin = $origin[1];
						$insValue[] ="('', '$adid', '$file', '$ext', '$origin', '$userid')";
					}
				}
				if($hasInsert){
					$query .= implode(",", $insValue);
					$db->setQuery($query);
					$db->query();
				}
				JFolder::delete(JPATH_ROOT . DS . 'tmp' . DS . $jlhash);
			}
		}
	}
	
	function _prepareAdinfo($adid, $listingModel, $toFeature, $toColor){
		$settings = JoomListingsFactory::getSettings();
		if($adid){
			$data['id'] = $adid;
			$s = $listingModel->isPublishedAndFeatured($adid);
			$isPublished = (int)$s->published;
			$isFeatured = $s->featured;
			$listingType = $s->listingtype;
		}
		else{
			$isPublished = $settings->auto_submit;
			$isFeatured = 0;
			$listingType = 0;
		}
		$adinfo = new stdClass ();
		$adinfo->published = $isPublished;
		$adinfo->featured = $isFeatured;
		$adinfo->wantstofeature = $toFeature;
		$adinfo->wantstocolor = $toColor;
		$adinfo->listingtype = $listingType;
		return $adinfo;
	}
	
	function relist(){
		$cid = JRequest::getVar('cid', '');
		if($cid){
			global $mainframe;
			$settings = JoomListingsFactory::getSettings();
			$user =& JFactory::getUser();
			$adid = $cid[0];
			$row = JTable::getInstance('listings', 'Table');
			$row->load($adid);
			$pmodel = $this->getModel('packages');
			$package = $pmodel->getPackageInfoOfUser($user->get('id'), $row->pid);
			if(count($package)> 0){
				$package = $package[0];
				if(($package->used > $package->adsnumber && $package->adsnumber > 0) || ($package->expirydate != -1 && $package->expirydate < date('Y-m-d H:i:s'))){
					// need to buy package
					$mainframe->redirect(JRoute::_('index.php?option=com_joomlistings&view=packages'), JText::_("You need to buy a package first"));
				}
				else{
					$row->expirydate = date('Y-m-d H:i:s', strtotime("+ $settings->ads_expiry_days days"));
					$row->store();
					$mainframe->redirect(JRoute::_('index.php?option=com_joomlistings&view=myads'), JText::_("Your ad is relisting successfully"));
				}
			}
			else{
				// TODO: need to fix this
				$mainframe->redirect(JRoute::_('index.php?option=com_joomlistings&view=myads'));
			}
		}
	}
	
	function listCategoryByPackageAndSection(){
		$settings = JoomListingsFactory::getSettings();
		$query = "";
		$sid = JRequest::getVar('sid', 0);
		if($settings->enable_packages){
			$pid = JRequest::getVar('pid', 0);
			$query = "SELECT * FROM #__jlcategories AS c WHERE c.section_id = '$sid' AND c.id IN (SELECT category_id FROM #__jlcategory_package WHERE package_id = '$pid') ORDER BY c.parent_id ASC"; // order by c.id is very important
		}else{
			$query = "SELECT * FROM #__jlcategories AS c WHERE c.section_id = '$sid' ORDER BY c.parent_id ASC"; // order by c.id is very important
		}
		$db =& JFactory::getDBO();
		$db->setQuery($query);
		$cats = $db->loadObjectList();
		require_once(JPATH_ADMINISTRATOR.DS."components".DS.'com_joomlistings'.DS."helpers".DS."tree.php");
		$tree = new pvgTree(new pvgNode(0));
		if(count($cats)>0){
			foreach($cats as $cat){
				$node = new pvgNode($cat->id, $cat->id, $cat->title);
				$tree->appendChild($cat->parent_id, $node);
			}
		}else{
			echo '<script type="text/javascript">alert(\'Do not have category in this section can post ads.\');</script>';	
		}
		echo $tree->renderTree('catid', false, 'Select Category', false, false);
		jexit();
	}
	
	function short(){
		global $mainframe;
		$uniq = JRequest::getVar('uniq');
		$db =& JFactory::getDBO();
		$query = "SELECT * FROM #__joomlistings WHERE s_unique = ". $db->quote($uniq);
		$db->setQuery($query);
		$obj = $db->loadObject();
		$mainframe->redirect(JRoute::_('index.php?option=com_joomlistings&c=ad&task=view&adid='. $obj->id));
	}
	
	function listByPostedUser(){
		global $mainframe;
        $view = $this->getView('ad', 'html');
        $rmodel = $this->getModel('region');
        $view->setModel($rmodel, true);
        $cmodel = $this->getModel('category');
        $view->setModel($cmodel, true);
        $model = $this->getModel('listing');
        $view->setModel($model, true);
        $view->setLayout('_listu');
        $view->listByPostedUser();
	}
	
	function download(){
		$att =(int) JRequest::getVar('att');
		if(!$att){
			die();
		}
		$db =& JFactory::getDBO();
		$query ="SELECT * FROM #__jlvdocs WHERE id='$att'";
		$db->setQuery($query);
		$obj = $db->loadObject();

				
		if($obj){
			$file = JOOMLISTINGS_VIDEO_DOCS_PATH . DS . $obj->user_id . DS . $obj->adid . DS .  $obj->filename;
			header("Location: ".JURI::base()."/components/com_joomlistings/download.php?d=".$file);
		}else{
			echo "<html><head><title>File not found.</title></head><body>File not found.</body></html>";
			jexit();
		}
		die();
	}
}
?>


