<?php
/*************************************************
Author: JoomClan.com
Creation Date: 2009-11-25
Author Email: joomclan@gmail.com
Url: http://www.joomclan.com
Copyright: 2009-2010
License: GNU
Component Version: 2.1.7
Software License: All of our PHP and HTML source code is released under the GNU General Public License (GPL) to ensure it is 100% compatible with Joomla!.
The GPL is the world's most popular Free (as in Freedom) and Open Source Software license.
Some javascript and other media (images, css, ajax scripts, flv players, mp3 players etc …) may be released under different licenses. Please see the details with the individual products.
**************************************************/
defined('_JEXEC') or die('Restricted access');
jimport("joomla.application.component.controller");
class JoomlistingsControllerDirectory extends JController {

	function __construct() {
		parent::__construct();
		$itemid = JLHelper::getBaseItemid();
		JRequest::setVar('Itemid', $itemid);
	}
	function display() {
		$view = &$this->getView('directory', 'html');
		$model = &$this->getModel('region');
		$regions = $model->getRegionsWithLocations();
		$view->assignRef('regions', $regions);
		$view->display();
	}

	function change() {
		global $mainframe;
		$pathway = &$mainframe->getPathway();
		$pathway->addItem(JText::_('SELECT_REGION'), '');
		$view = $this->getView('directory', 'html');
		$view->regions();
	}
	function select() {
		global $mainframe;
		$settings = JoomListingsFactory::getSettings();
		$rid = JRequest::getVar('rid', 0);
		$lid = JRequest::getVar('lid', 0);
		$nid = JRequest::getVar('nid', 0);
		$return = base64_decode(JRequest::getVar('return'));
		if ($rid) {
			$rmodel = $this->getModel('region');
			$xCls = new stdClass();
			$xCls->rid = $rid;
			$xCls->lid = $lid;
			if($settings->enable_neighbor){
				$xCls->nid = $nid;
			}
			$rmodel->setRegion($xCls);
		}
		$mainframe->redirect($return);

	}
	function cat() {
		require_once JPATH_ADMINISTRATOR . DS . 'components'. DS . 'com_joomlistings' . DS . 'helpers'. DS .  'tree.php';
		$Itemid = JLHelper::getBaseItemid();
		global $mainframe;
		JPluginHelper::importPlugin('joomlistings');
		$rmodel = $this->getModel('region');
		$settings = JoomListingsFactory::getSettings();
		if ($sess = $rmodel->getRegion()) {
			if (!$sess->rid) {
				$mainframe->redirect(JRoute::_("index.php?option=com_joomlistings&view=directory", false), "Select Region before you continue");
			}
			$cmodel = $this->getModel('category');
			$categories = $cmodel->getListCategory($sess->rid, $sess->lid, $sess->nid);
			$tree = new pvgTree2(new pvgNode2(0));
			foreach ($categories as $cat){
				$link = JRoute::_("index.php?option=com_joomlistings&c=listing&cid={$cat->id}&Itemid={$Itemid}");
				$node = new pvgNode2($cat->id, $cat->id, $cat->title, $cat->parent_id, $link, $cat->adcount);
				$tree->appendChild($cat->parent_id, $node);
			}
			$tree_rendered = $tree->renderTree();
			$view = $this->getView('directory', 'html');
			$view->setLayout('_categories');
			$view->assignRef('region', $sess);
			$view->assignRef('settings', $settings);
			$view->assignRef('categories', $categories);
			$view->assignRef('tree_rendered', $tree_rendered);
			$view->assignRef('section', $sectiondetail);
			$user = JFactory::getUser();
			$view->assignRef('user', $user);
			$pathway = &$mainframe->getPathway();
			$pathway->addItem($sess->region.",  ".$sess->location, JRoute::_("index.php?option=com_joomlistings&c=directory&task=change", false));
			$pathway->addItem(JText::_('CATEGORIES'));
			$view->modDisplay();
		} else {
			$url = JRoute::_("index.php?option=com_joomlistings&view=_error&layout=redirect", false);
			$mainframe->redirect($url);
		}
	}

	function section() {
		global $mainframe;
		JPluginHelper::importPlugin('joomlistings');
		$rmodel = $this->getModel('region');
		$settings = JoomListingsFactory::getSettings();
		if(!$settings->enable_sections){
			$cmodel = $this->getModel('category');
			$defaultSection = $cmodel->getDefaultSection();
			$rlink = JRoute::_("index.php?option=com_joomlistings&c=directory&task=cat&sid=".$defaultsection->id, false);
			$mainframe->redirect($rlink);
		}
		else{
			if ($sess = $rmodel->getRegion()){
				if (!$sess->rid) {
					global $mainframe;
					$mainframe->redirect(JRoute::_("index.php?option=com_joomlistings&view=directory", false), "Select Region before you continue");
				}
				$model = $this->getModel('directory');
				$sections = $model->getSectionsWithCategories($sess);
				$view = $this->getView('directory', 'html');
				$view->setLayout('_sections');
				$view->assignRef('region', $sess);
				$view->assignRef('settings', $settings);
				$view->assignRef('sections', $sections);
				$user = JFactory::getUser();
				$view->assignRef('user', $user);
				$pathway = &$mainframe->getPathway();
				if ($settings->enable_regions) {
					$text = $sess->region.", ".$sess->location;
					if($settings->enable_neighbor){
						$text .= ", ".$sess->neighbor;
					}
					$pathway->addItem($text, JRoute::_("index.php?option=com_joomlistings&c=directory&task=change", false));
				}
				$dlink = JRoute::_("index.php?option=com_joomlistings&c=directory&task=section", false);
				$pathway->addItem(JText::_('CATEGORIES'), $dlink);
				$view->modDisplay();
			}
			else {
				$url = JRoute::_("index.php?option=com_joomlistings&view=_error&layout=redirect", false);
				$mainframe->redirect($url);
			}
		}
	}
	
	function neibough(){
		$rid = (int) JRequest::getVar('rid');
		$lid = (int) JRequest::getVar('lid');
		$db =& JFactory::getDBO();
		$query = "SELECT *, (SELECT count(*) FROM #__joomlistings AS l WHERE l.nid = jn.id AND l.published='1' AND l.rid = $rid AND l.lid = $lid AND expirydate>=curdate()) as adcount FROM #__jlneighbors as jn  WHERE published = 1 AND location_id = '$lid'";
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		$itemid=JLHelper::getBaseItemid();
		$return = base64_encode(JRoute::_("index.php?option=com_joomlistings&c=directory&task=section&Itemid=$itemid", false));
		$text = "<ul>";
		foreach($rows as $row){
			$link = JRoute::_("index.php?option=com_joomlistings&c=directory&task=select&rid={$rid}&lid={$lid}&nid={$row->id}&Itemid=$itemid&return=$return");
			$text .= "<li><a href='$link'>".$row->title." (" . $row->adcount. ")</a></li>";
		}
		$text .= "</ul>";
		echo $text;
		jexit();
	}
}
?>
