<?php
/*************************************************
Author: JoomClan.com
Creation Date: 2009-11-25
Author Email: joomclan@gmail.com
Url: http://www.joomclan.com
Copyright: 2009-2010
License: GNU
Component Version: 2.1.7
Software License: All of our PHP and HTML source code is released under the GNU General Public License (GPL) to ensure it is 100% compatible with Joomla!.
The GPL is the world's most popular Free (as in Freedom) and Open Source Software license.
Some javascript and other media (images, css, ajax scripts, flv players, mp3 players etc …) may be released under different licenses. Please see the details with the individual products.
**************************************************/
defined('_JEXEC') or die('Restricted access');
jimport("joomla.application.component.controller");

require_once(JPATH_ROOT.DS."components".DS.'com_joomlistings'.DS."includes".DS."bill.class.php");

class JoomlistingsControllerPackage extends JController{
	
	function pay(){
		//Get Currently Logged in User
		global $mainframe;
		JPluginHelper::importPlugin('joomlistings');
		$user =& JFactory::getUser();
		$userid = $user->get('id');
		if($userid)
		{
			$pid=JRequest::getVar('pid',0);
			$pmodel = $this->getModel('profile');
			$profile = $pmodel->getProfile($userid);
			$settings = JoomListingsFactory::getSettings();
			$packagemodel = $this->getModel('packages');
			$package = $packagemodel->getPackageDetail($pid);
			if(!$package->isfree)
			{
				$itemid = date("Y-m-d").$package->id;
				$item = new JItem($itemid, $package->title, $package->currency, $package->price, 1, $package->description);
				$basket = new JBasket(false);
				$basket->addItem($item);
				$billing = new JAddress($profile->address, $profile->address2, $profile->city, $profile->state, $profile->zipcode, $profile->country);
				$bill = new JBill($basket->getItems(),$billing);
				$bill->setUser($profile);
				$bill->setInvoice(date("Ymdgis".$package->id));
				$bill->calculateTotal();
				$bill->setDescription('Price for '.$package->title." Package");
				$bill->setCurrency($package->currency);
				$inurl = base64_encode(JRoute::_("index.php?option=com_joomlistings&c=package&task=paid&pid=$pid",false));
				$paymentpath = JPATH_COMPONENT.DS."includes".DS."payment.class.php";
				require_once($paymentpath);
				$payment = new Payment();
				$payment->setInvoice($bill);
				$payment->setInurl($inurl);
				$payment->setCustom(base64_encode("pay__package__".$pid));
				$payment->setOption("com_joomlistings", "package");
				$payment->showInvoice();

			} else {

				$link = JRoute::_("index.php?option=com_joomlistings&view=transaction",false);
				//if($packagemodel->addPackageToUser($userid,$package))
				//{
					$mainframe->triggerEvent('onPackageBuy', array($package, $user));
					$msg="You have successfully bought a ".$package->title." package";
				//}
//				else
//				{
//
//					$msg = "Your transaction was successfull. But We could not add Packages to your account. Contact Support now!";
//					//@TODO auto notification to support.
//				}
				$mainframe->redirect($link,$msg);
			}


		}
		else
		{
			global $mainframe;
			$returnurl = base64_encode($_SERVER['HTTP_REFERER']);
			$link = JRoute::_("index.php?option=com_user&view=login&return=$returnurl",false);
			$msg = JText::_("LOGIN_TO_ACCESS");
			$mainframe->redirect($link, $msg);
		}
	}

	function paid()
	{
		global $mainframe;
		JPluginHelper::importPlugin('joomlistings');
		$userid=JRequest::getVar('uid',0);
		$pid = JRequest::getVar('pid',0);
//		fopen(JPATH_ROOT.DS.'logs'.DS.'log'.date("ymd").'.txt', 'a+');
//		file_put_contents(JPATH_ROOT . DS .'logs'. DS. 'log'.date("ymd").'.txt', "\n\rUser $uid paid package $pid success", FILE_APPEND);
		if($userid)
		{
			$packagemodel = $this->getModel('packages');
			$pid = JRequest::getVar('pid',0);
			$package = $packagemodel->getPackageDetail($pid);
			$link=JRoute::_("index.php?option=com_joomlistings&view=transaction", false);
			$user =& JFactory::getUser($userid);
			$mainframe->triggerEvent('onPackageBuy', array($package, $user));
			$msg = "You have successfully bought a ".$package->title." package";
		}
		else
		{
			$returnurl=base64_encode($_SERVER['HTTP_REFERER']);
			$link = JRoute::_("index.php?option=com_user&view=login&return=$returnurl", false);
			$msg = JText::_("LOGIN_TO_ACCESS");
		}
		$mainframe->redirect($link, $msg);
	}

	function upgrade()
	{
		global $mainframe;
		$user=JFactory::getUser();
		$userid=$user->get('id');
		if($userid)
		{
//			$model=$this->getModel('packages');
//			$packages=$model->getAvailablePackages();
//
//			$view=$this->getView('packages','html');
//			$view->assignRef('packages',$packages);
//			$view->modDisplay();
			$mainframe->redirect(JRoute::_("index.php?option=com_joomlistings&view=packages"));

		}
		else
		{
			$link = JRoute::_("index.php?option=com_joomlistings&view=mypackage",false);
			$return = base64_encode($link);
			$linkx = JRoute::_("index.php?option=com_user&view=login&return=$return",false);
			$msg = JText::_("LOGIN_TO_ACCESS");
			$mainframe->redirect($linkx,$msg);
		}
	}

	function renew(){
		global $mainframe;
		$user =& JFactory::getUser();
		$userid = $user->get('id');
		$pid = JRequest::getVar('pid');
		$Itemid = JRequest::getVar('Itemid');
		if($userid){
			$mainframe->redirect(JRoute::_("index.php?option=com_joomlistings&c=package&task=pay&pid=$pid&Itemid=$Itemid"));
		}
		else{
			$link = JRoute::_("index.php?option=com_joomlistings&view=mypackage",false);
			$return = base64_encode($link);
			$linkx = JRoute::_("index.php?option=com_user&view=login&return=$return");
			$msg=JText::_("LOGIN_TO_ACCESS");
			$mainframe->redirect($linkx,$msg);
		}
	}

	function free(){
		global $mainframe;
		JPluginHelper::importPlugin('joomlistings');
		$model = $this->getModel('packages');
		$user =& JFactory::getUser();
		$userid = $user->get('id');
		$return = JRequest::getVar('return','');
		if($userid){
			$availablepackages = $model->getAvailablePackages(1);
			if(count($availablepackages)>0){
				$settings = JoomListingsFactory::getSettings();
				if($settings->enable_free_package){
					$package = $model->assignFreePackage($userid);
					$mainframe->triggerEvent('onPackageBuy', array($package, $user));
					if(!empty($return)){
						$linkx = base64_decode($return);
					}
					else{
						$linkx = JRoute::_("index.php?option=com_joomlistings&view=ad&layout=post",false);
					}
				}
				else
				{
					$linkx = JRoute::_("index.php?option=com_joomlistings&c=package&task=upgrade",false);
					$msg = "Please buy a package to post a listing";

				}
			}
			else{
				$linkx=JRoute::_("index.php?option=com_joomlistings&view=_error&layout=nopackage",false);
				$msg="";
			}
			$mainframe->redirect($linkx,$msg);
		}
		else{
			$link = JRoute::_("index.php?option=com_joomlistings&view=ad&layout=post",false);
			$return = base64_encode($link);
			$linkx = JRoute::_("index.php?option=com_user&view=login&return=$return",false);
			$msg = JText::_("LOGIN_TO_ACCESS");
			$mainframe->redirect($linkx,$msg);
		}

	}
	
	function subscribe(){
		global $mainframe;
		JPluginHelper::importPlugin('joomlistings');
		$user =& JFactory::getUser();
		$userid = $user->get('id');
		if($userid)
		{
			$pid=JRequest::getVar('pid',0);
			$pmodel = $this->getModel('profile');
			$profile = $pmodel->getProfile($userid);
			$settings = JoomListingsFactory::getSettings();
			$packagemodel = $this->getModel('packages');
			$package = $packagemodel->getPackageDetail($pid);
			if(!$package->isfree)
			{
				$itemid = date("Y-m-d").$package->id;
				$item = new JItem($itemid, $package->title, $package->currency, $package->price, 1, $package->description);
				$basket = new JBasket(false);
				$basket->addItem($item);
				$billing=new JAddress($profile->address, $profile->address2, $profile->city, $profile->state, $profile->zipcode, $profile->country);
				$bill = new JBill($basket->getItems(),$billing);
				$bill->setUser($profile);
				$bill->setInvoice(date("Ymdgis".$package->id));
				$bill->calculateTotal();
				$bill->setDescription('Price for '.$package->title." Package");
				$bill->setCurrency($package->currency);
				$returnurl = base64_encode(JRoute::_("index.php?option=com_joomlistings&c=package&task=paid&pid=$pid",false));
				$paymentpath = JPATH_COMPONENT.DS."includes".DS."payment.class.php";
				require_once($paymentpath);
				$payment = new Payment();
				$payment->setInvoice($bill);
				$payment->setInurl($returnurl);
				$payment->setCustom(base64_encode("subscribe__package__".$pid));
				$payment->setOption('com_joomlistings',"package","");
				$payment->showInvoice();

			} else {

				$link=JRoute::_("index.php?option=com_joomlistings&view=transaction",false);
				//if($packagemodel->addPackageToUser($userid,$package))
				//{
					$mainframe->triggerEvent('onPackageBuy', array($package, $user));
					$msg="You have successfully bought a ".$package->title." package";
//				}
//				else
//				{
//
//					$msg="Your transaction was successfull. But We could not add Packages to your account. Contact Support now!";
//					//@TODO auto notification to support.
//				}

				$mainframe->redirect($link,$msg);

			}


		}
		else
		{
			global $mainframe;
			$returnurl = base64_encode($_SERVER['HTTP_REFERER']);
			$link=JRoute::_("index.php?option=com_user&view=login&return=$returnurl",false);
			$msg=JText::_("LOGIN_TO_ACCESS");
			$mainframe->redirect($link,$msg);
		}
	}
	
	function popbox(){
		$pid = (int) JRequest::getVar('pid');
		if(!$pid){
			die();
		}
		$pmodel = $this->getModel('packages');
		$sections = $pmodel->getSectionCategoryPopbox($pid);
		$view = $this->getView('packages', 'html');
		$view->setLayout('_popbox');
		$view->assignRef('sections', $sections);
		$view->modDisplay();
	}
}
?>