<?php

// no direct access
defined('_JEXEC') or die('Restricted access');

class JLUploadHelper {
	
	function upload($dest = '', $file = '', $uniquename = '' ){
		global $mainframe;
		// Make the filename safe
		jimport('joomla.filesystem.file');
		$file['name']	= JFile::makeSafe($file['name']);
		
		if (isset($file['name'])) {
			$filepath = JPath::clean($dest.DS.strtolower($uniquename));

			if (!JLUploadHelper::canUpload( $file, $err )) {
				JError::raiseNotice(100, JText::_($err));
				return;
			}
			
			if (JFile::exists($filepath)) {
					JError::raiseNotice(100, JText::_('Error. File already exists'));
					// REDIRECT
					return;
			}

			if (!JFile::upload($file['tmp_name'], $filepath)) {
					JError::raiseWarning(100, JText::_('Error. Unable to upload file'));
					// REDIRECT
					return;
			} else {
				return 1;
			}
		}
	}

	function canUpload( $file, &$err )
	{
		$params = &JComponentHelper::getParams( 'com_media' );
		$settings = JoomListingsFactory::getSettings();
		
		
		if(empty($file['name'])) {
			$err = 'Please input a file for upload';
			return false;
		}
		jimport('joomla.filesystem.file');
		if ($file['name'] !== JFile::makesafe($file['name'])) {
			$err = 'WARNFILENAME';
			return false;
		}
		
		$format = strtolower(JFile::getExt($file['name']));
		$allowable = explode( '|', $settings->upload_extension_allow);
		
//		fopen( JOOMLISTINGS_COMPONENT_PATH . DS .'log'.date("ymd").'.txt', 'a+');
//		file_put_contents(JOOMLISTINGS_COMPONENT_PATH . DS .'log'.date("ymd").'.txt', "\r\nFile Data:". serialize($format). ' - ' .  serialize($allowable));
		
		if (!in_array($format, $allowable))
		{
			$err = 'WARNFILETYPE';
			return false;
		}
		
		$maxSize = (int) $params->get( 'upload_maxsize', 0 );
		if ($maxSize > 0 && (int) $file['size'] > $maxSize)
		{
			$err = 'WARNFILETOOLARGE';
			return false;
		}
		$xss_check =  JFile::read($file['tmp_name'],false,256);
		$html_tags = array('abbr','acronym','address','applet','area','audioscope','base','basefont','bdo','bgsound','big','blackface','blink','blockquote','body','bq','br','button','caption','center','cite','code','col','colgroup','comment','custom','dd','del','dfn','dir','div','dl','dt','em','embed','fieldset','fn','font','form','frame','frameset','h1','h2','h3','h4','h5','h6','head','hr','html','iframe','ilayer','img','input','ins','isindex','keygen','kbd','label','layer','legend','li','limittext','link','listing','map','marquee','menu','meta','multicol','nobr','noembed','noframes','noscript','nosmartquotes','object','ol','optgroup','option','param','plaintext','pre','rt','ruby','s','samp','script','select','server','shadow','sidebar','small','spacer','span','strike','strong','style','sub','sup','table','tbody','td','textarea','tfoot','th','thead','title','tr','tt','ul','var','wbr','xml','xmp','!DOCTYPE', '!--');
		foreach($html_tags as $tag) {
			// A tag is '<tagname ', so we need to add < and a space or '<tagname>'
			if(stristr($xss_check, '<'.$tag.' ') || stristr($xss_check, '<'.$tag.'>')) {
				$err = 'WARNIEXSS';
				return false;
			}
		}
		return true;
	}
	
	function copyAndResize($src = '', $dest = '', $filename){
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.folder');
		if(!JFolder::exists($dest)) JFolder::create($dest);
		JFile::copy($src, $dest.DS.$filename);
		$resized = JLUploadHelper::resize($dest.DS.$filename, 200, 200);
		if(!$resized) return false;
		else return true;
	}
	
	function resize($image, $max_width, $max_height){
		$imgInfo = getimagesize($image);
		$width = $imgInfo[0];
		$height = $imgInfo[1];
		if(!$max_width && !$max_height) {
	        $max_width = $width;
	        $max_height = $height;
		}else{
	        if(!$max_width) $max_width = 1000;
	        if(!$max_height) $max_height = 1000;
	    }
		$x_ratio = $max_width / $width;
		$y_ratio = $max_height / $height;
		if (($width <= $max_width) && ($height <= $max_height) ) {
			$tn_width = $width;
			$tn_height = $height;
		} else if (($x_ratio * $height) < $max_height) {
			$tn_height = ceil($x_ratio * $height);
			$tn_width = $max_width;
		} else {
			$tn_width = ceil($y_ratio * $width);
			$tn_height = $max_height;
		}
		
		switch ($imgInfo[2]) {
		  case 1: $im = imagecreatefromgif($image); break;
		  case 2: $im = imagecreatefromjpeg($image);  break;
		  case 3: $im = imagecreatefrompng($image); break;
		  default: return '';  break;
		}
					
		$newImg = imagecreatetruecolor($tn_width, $tn_height);
		 
		 /* Check if this image is PNG or GIF, then set if Transparent*/  
		if(($imgInfo[2] == 1) OR ($imgInfo[2]==3)){
			imagealphablending($newImg, false);
			imagesavealpha($newImg,true);
			$transparent = imagecolorallocatealpha($newImg, 255, 255, 255, 127);
			imagefilledrectangle($newImg, 0, 0, $tn_width, $tn_height, $transparent);
		}
		imagecopyresampled($newImg, $im, 0, 0, 0, 0, $tn_width, $tn_height, $imgInfo[0], $imgInfo[1]);
			//Generate the file, and rename it to $newfilename
		switch ($imgInfo[2]) {
		  case 1: imagegif($newImg,$image); break;
		  case 2: imagejpeg($newImg,$image, 90);  break;
		  case 3: imagepng($newImg,$image); break;
		  default: return '';  break;
		}
		return $image;
	}
	
}
?>