<?php
/*************************************************
Author: JoomClan.com
Creation Date: 2009-11-25
Author Email: joomclan@gmail.com
Url: http://www.joomclan.com
Copyright: 2009-2010
License: GNU
Component Version: 2.1.7
Software License: All of our PHP and HTML source code is released under the GNU General Public License (GPL) to ensure it is 100% compatible with Joomla!. 
The GPL is the world's most popular Free (as in Freedom) and Open Source Software license.
Some javascript and other media (images, css, ajax scripts, flv players, mp3 players etc …) may be released under different licenses. Please see the details with the individual products.
**************************************************/

defined('_JEXEC') or die('Restricted access');
class JItem
{
	var $itemid=null;
	var $title=null;
	var $price=null;
	var $description=null;
	var $remarks=null;
	var $currency=null;
	var $quantity=null;
	


	function __construct($id=0,$title="",$currency='USD',$price=0,$qty=1,$description="",$remarks="")
	{
		$this->itemid=$id;
		$this->title=$title;
		$this->price=$price;
		$this->currency=$currency;
		$this->description=$description;
		$this->remarks=$remarks;
		$this->quantity=$qty;
	}

	function add($qty=1)
	{
		$this->quantity+=$qty;
	}
}

/**
 * Items Collector
 *
 */
class JBasket
{
	public $items=array();

	public $allowDuplicates=null;

	function __construct($allowdups=true)
	{
		$this->allowDuplicates=$allowdups;
	}

	function addItem(&$item)
	{
		if(!in_array($item,$this->items))
		{
			$this->items[$item->itemid]=$item;
		}
		else
		{
			if($this->allowDuplicates)
			{
				$this->items[$item->itemid]->add($item->quantity);
			}
		}

	}

	function getItems()
	{
		return $this->items;
	}
	
	function isEmpty()
	{
		return count($this->items)<=0;
	}


}

/**
 * Address Class for JBill class
 *
 */
class JAddress
{
	var $address1=null;
	var $address2=null;
	var $city=null;
	var $state=null;
	var $zipcode=null;
	var $country=null;


	function __construct($ad1="",$ad2="",$city="",$state="",$zip="",$country="")
	{
		$this->address1=$ad1;
		$this->address2=$ad2;
		$this->city=$city;
		$this->state=$state;
		$this->zipcode=$zip;
		$this->country=$country;

	}
}



class JBill
{

	public $items=array();
	public $shipping=null;
	public $billing=null;

	public $discount=null;

	public $grosstotal=null;
	public $nettotal=null;

	public $currency;

	public $user=null;

	public $description;
	
		var $invoice=null;

	function __construct(&$items=array(),&$billing=null,&$shipping=null)
	{

		$this->items=$items;
		$this->billing=$billing;
		$this->shipping=$shipping;
		$this->currency='USD';
	}

	function calculateTotal()
	{
		if(count($this->items)>0)
		{
			$this->grosstotal=0;
			foreach($this->items as $item)
			{
				$this->grosstotal+=$item->price;
			}

			if($this->discount)
			{
				$this->nettotal=$this->grosstotal*$this->discount/100;
			}
			else
			{
				$this->nettotal=$this->grosstotal;
			}
			return $this->nettotal;

		}
		else
		{
			return 0;
		}

	}

	function setDiscount($dis)
	{
		$this->discount=$dis;
	}

	
function setInvoice($inv)
	{
		$this->invoice=$inv;
	}
	function setDescription($dis)
	{
		$this->description=$dis;
	}
	function setCurrency($cur='USD')
	{
		$this->currency=$cur;
	}

	function setUser($user=null)
	{
		$this->user=$user;
	}

	function showBill()
	{
		?>
<h3><?php echo JText::_('INVOICE');?></h3>
<div>
<table width="100%" cellpadding="5" cellspacing="0" border="1"
	class="bill">
	<tr>
		<th width="20%"><?php echo JText::_('NAME');?></th>
		<td width="30%"><?php echo $this->user->name; ?> <?php echo $this->user->lastname; ?></td>
		<th width="20%"><?php echo JText::_('ADDRESS')?></th>
		<td width="30%"><?php echo $this->billing->address1; ?>, <?php echo $this->billing->address2; ?></td>
		
	</tr>
	<tr>
		<th width="20%"><?php echo JText::_('DATE');?></th>
		
		<td><?php echo date("D d M, Y") ?></td>
		<th width="20%"><?php  echo  JText::_('CITY');?></th>
		<td> <?php echo $this->user->city; ?></td>
	</tr>
	<tr>
		<th width="20%"><?php  echo JText::_('TOTAL_AMT');?></th>
		<td><strong><?php echo $this->currency; ?> <?php echo $this->calculateTotal(); ?></strong></td>
		<th width="20%"><?php  echo JText::_('COUNTRY');?></th>
		<td> <?php echo $this->user->country; ?></td>
	</tr>
		<tr>
		<th width="20%"><?php  echo  JText::_('DESCRIPTION');?></th>
		<td><?php echo $this->description; ?></td>
		<th width="20%">&nbsp;</th>
		<td> &nbsp;</td>
	</tr>
	
</table>
</div>
<br/>
<h3><?php JText::_('INVOICE_DETAIL');?></h3>
<div>
<table width="100%" cellpadding="5" cellspacing="0" border="1" class="bill">
<tr>
<th width="5">&nbsp;</th>
<th><?php JText::_('PARTICULARS');?></th>
<th width="15%"><?php JText::_('PRICE');?></th>
</tr>
<?php
if(count($this->items)>0)
{
	$i=1;
	foreach($this->items as $item)
	{?>
	<tr>
	<td><?php echo $i;?></td>
	<td><?php echo $item->title;?><br/>(<?php echo $item->description;?>)</td>
	<td><?php echo $item->currency;?> <?php echo $item->price;?></td>
	</tr>
	<?php 
		$i++;
	}
}
else
{
	?>
	<tr><td colspan="3"><?php JText::_('NO_ITEMS_INVOICE');?></td>
	</tr>
	<?php
}
?>
<tr>
<th colspan="2"></th><th><?php echo $item->currency;?> <?php echo sprintf("%.2f",$this->nettotal);?></th>
</tr>
</table>
</div>
		<?php
	}


}
?>