<?php
/*************************************************
Author: JoomClan.com
Creation Date: 2009-11-25
Author Email: joomclan@gmail.com
Url: http://www.joomclan.com
Copyright: 2009-2010
License: GNU
Component Version: 2.1.7
Software License: All of our PHP and HTML source code is released under the GNU General Public License (GPL) to ensure it is 100% compatible with Joomla!. 
The GPL is the world's most popular Free (as in Freedom) and Open Source Software license.
Some javascript and other media (images, css, ajax scripts, flv players, mp3 players etc …) may be released under different licenses. Please see the details with the individual products.
**************************************************/

defined('_JEXEC') or die('Restricted access');

class JoomListingsRouteHelper{
function _makeTitleAdController($task, &$uri){
    	$vars = $uri->getQuery(true);
    	extract($vars);
    	$title = '';
    	switch ($task){
        	
        	case 'print_ad':
        		$title = $adid . '-print-ad-'. $this->_getAdTitle($adid);
        		break;
        	case 'send_email':
        		$title = $adid . '-send-email-'.$this->_getAdTitle($adid);
        		break;
        	
        	case 'contact':
        		$title = $adid. '-contact-'. $this->_getAdTitle($adid);
        		break;
        	case 'adw':
        		if($adid){
        			$title = $adid .'-add-to-wishlist-'. $this->_getAdTitle($adid);
        		}
        		break;
        	case 'ef':
        	case 'efa':
        		if(isset($adid) && isset($cid)){
        			$title = $task . '-' . $adid . '-' . $cid;
        		}
        		break;
        	case 'save':
        		break;
        	case 'edit':
        		if($cid){
        			$title = $task . '-' . $cid[0]. '-'. $this->_getAdTitle($cid[0]);
        		}
        		break;
        	case 'del':
        		if($cid){
        			$title = $task . '-' . $cid[0]. '-'. $this->_getAdTitle($cid[0]);
        		}
        		break;
        	case 'msg':
        		break;
        	case 'rw':
        		if($wid){
        			$title = $wid . '-remove-from-wishlist' ;
        		}
        		break;
        	case 'pay':
        		$title = $task . '-' . $adid . '-'. $this->_getAdTitle($adid);
        		if($pid){
        			$title .= '-' . $pid . '-' . $this->_getPackageTitle($pid);
        		}
        		if($f){
        			$title .= '-' . $f;
        		}
    			if($ad){
        			$title .= '-' . $ad;
        		}
    			if($color){
        			$title .= '-' . $color;
        		}
        		break;
        	case 'paynpublish':
        		// ???
        		break;
        	case 'paid':
    			$title = $task . '-' . $adid . '-'. $this->_getAdTitle($adid);
        		if($f){
        			$title .= '-' . $f;
        		}
    			if($ad){
        			$title .= '-' . $ad;
        		}
    			if($color){
        			$title .= '-' . $color;
        		}
    			if($uid){
        			$title .= '-' . $uid;
        		}
        		break;
        	case 'myads':
        		// do nothing
        		break;
        	case 'report':
        		$title = $task . '-' . $cid;
        		break;
        	case 'catpacksec':
        		$title = 'catpacksec';
        		break;
        	case 'view':
        		$title = $adid. '-view-'. $this->_getAdTitle($adid);
        		break;
        	case 'send':
        		break;
        }
        if(isset($title)){
        	if(is_array($title)){
        		return $title;
	        }else{
	        	return array($title);
	        }
        }else{
        	return array();
        }
    }
    
	function _makeTitleDirectoryController($task, &$uri){
    	$vars = $uri->getQuery(true);
    	extract($vars);
    	$title = '';
    	switch ($task){
    		case 'display':
    		case 'change':
    			$title = $task;
    			break;
    		case 'select':
    			$title = $task;
    			if($rid){
    				 $title .= '-' . $rid;
    			}
    			if($lid){
    				$title .= $lid;
    			}
    			if($nid){
    				$title .= $nid;
    			}
    			if($rid){
    				 $title .= '-' . $rid . '-' . $this->_getRegionTitle($rid);
    			}
    			if($lid){
    				$title .= '-' . $lid . '-' . $this->_getLocationTitle($lid);
    			}
    			if($nid){
    				$title .= '-' . $nid . '-' . $this->_getNeiboughTitle($nid);
    			}
    			if($return){
    				$title .="-".$return;
    			}
    			break;
    		case 'cat':
    			$title = 'show-categories';
    			break;
    		case 'neibough':
    			$title = $task;
    			break;
    		case 'section':
    			$title = 'section';
    			break;
        }
        if(is_array($title)){
        	return $title;
        }
        return array($title);
    }
    
	function _makeTitleImageController($task, &$uri){
    	$vars = $uri->getQuery(true);
    	extract($vars);
    	switch ($task){
    		case 'images':
    			$title = 'images-'.$cid[0];
    			break;
    		case 'orderup':
    			break;
    		case 'orderdown':
    			break;
    		case 'saveorder':
    			break;
    		case 'save':
    			break;
    		case 'del':
    			break;
    		case 'publish':
    			break;
    		case 'unpublish':
    			break;
        }
        if(is_array($title)){
        	return $title;
        }
        return array($title);
    }
    
	function _makeTitleListingController($task, &$uri){
    	$vars = $uri->getQuery(true);
    	extract($vars);
    	$title = '';
    	switch ($task){
    		case 'add':
    			$title = 'add';
    			break;
    		case 'vote':
    			$title = 'vote';
    			break;
    		case 'display':
    		default:
    			if($cid){
    				$title[] = $cid. '-listing-ad-of-category-'. $this->_getCategoryTitle($cid);
    			}
    			if(isset($limitstart)){
    				$title[] ='page-'.($limitstart/10 +1);
    			}
    			unset($limitstart);
        }
        if(is_array($title)){
        	return $title;
        }
        return array($title);
    }
    
	function _makeTitleMessageController($task, &$uri){
    	$vars = $uri->getQuery(true);
    	extract($vars);
    	$title = '';
    	switch ($task){
    		case 'detail':
    			$title = $id . '-' . $this->_getMessageSubject($id);
    			break;
    		case 'compose':
    			$title = $id.'-compose';
    			break;
    		case 'inbox':
    			$title = 'inbox';
    			break;
    		case 'notification':
    			$title = 'notification';
    			break;
    		case 'save':
    			break;
    		case 'delete':
    			break;
    		case 'gm':
    			break;
        }
        if(is_array($title)){
        	return $title;
        }
        return array($title);
    }
	
    function _makeTitlePackageController($task, &$uri){
    	$pid = '';
    	$vars = $uri->getQuery(true);
    	extract($vars);
    	$title = '';
    	switch ($task){
    		case 'pay':
    			$title = $pid . '-buy-' . $this->_getPackageTitle($pid);
    			break;
    		case 'paid':
    			$title = $pid . '-paid-' . $this->_getPackageTitle($pid);
    			break;
    		case 'upgrade':
    			$title = 'upgrade';
    			break;
    		case 'renew':
    			$title = $pid . '-renew-' . $this->_getPackageTitle($pid);
    			break;
    		case 'free':
    			$title = 'free-package';
    			break;
    		case 'subscribe':
    			$title = $pid.'-subscribe-' . $this->_getPackageTitle($pid);
    			break;
    		case 'popbox':
    			$title = $pid.'-popbox-' . $this->_getPackageTitle($pid);
    			break;
        }
        if(is_array($title)){
        	return $title;
        }
        return array($title);
    }
	
    function _makeTitlePaymentController($task, &$uri){
    	$vars = $uri->getQuery(true);
    	extract($vars);
    	switch ($task){
    		case 'pay':
    			$title = 'pay';
    			break;
    		case 'confirm':
    			$title = 'confirm';
    			break;
    		case 'notify':
    			$title = 'notify';
    			break;
    		case 'success':
    			$title = 'success';
    			break;
    		case 'cancel':
    			$title = 'cancel';
    			break;
        }
        if(is_array($title)){
        	return $title;
        }
        return array($title);
    }
    
	function _makeTitleProfileController($task, &$uri){
    	$vars = $uri->getQuery(true);
    	extract($vars);
    	switch ($task){
    		case 'save':
    			break;
        }
        if(is_array($title)){
        	return $title;
        }
        return array($title);
    }

    function _makeTitleSearchController($task, &$uri){
    	$vars = $uri->getQuery(true);
    	extract($vars);
    	switch ($task){
    		case 'search':
    			break;
        }
        if(is_array($title)){
        	return $title;
        }
        return array($title);
    }
    
	function _getPackageTitle($pid){
    	$db =& JFactory::getDBO();
    	$query = "SELECT * FROM #__jlpackages WHERE id = '$pid'";
    	$db->setQuery($query);
    	$package = $db->loadObject();
    	return $package->title;
    }
    
    function _getAdTitle($adid){
    	$db =& JFactory::getDBO();
    	$query = "SELECT * FROM #__joomlistings WHERE id = '$adid'";
    	$db->setQuery($query);
    	$listing = $db->loadObject();
    	return $listing->title;
    }
    
    function _getRegionTitle($rid){
    	$db =& JFactory::getDBO();
    	$query = "SELECT * FROM #__jlstates WHERE id = '$rid'";
    	$db->setQuery($query);
    	$region = $db->loadObject();
    	return $region->title;
    }
    
    function _getLocationTitle($lid){
    	$db =& JFactory::getDBO();
    	$query = "SELECT * FROM #__jllocations WHERE id = '$lid'";
    	$db->setQuery($query);
    	$location = $db->loadObject();
    	return $location->title;
    }
    
    function _getNeiboughTitle($nid){
    	$db =& JFactory::getDBO();
    	$query = "SELECT * FROM #__jlneighbors WHERE id = '$lid'";
    	$db->setQuery($query);
    	$neighbor = $db->loadObject();
    	return $neighbor->title;
    }
    
    function _getCategoryTitle($cid){
    	$db =& JFactory::getDBO();
    	$query = "SELECT * FROM #__jlcategories WHERE id = '$cid'";
    	$db->setQuery($query);
    	$cat = $db->loadObject();
    	return $cat->title;
    }
    
	function _getMessageSubject($cid){
    	$db =& JFactory::getDBO();
    	$query = "SELECT * FROM #__jlmessages WHERE id = '$cid'";
    	$db->setQuery($query);
    	$cat = $db->loadObject();
    	return $cat->subject;
    }
}

?>