<?php
/*************************************************
Author: JoomClan.com
Creation Date: 2009-11-25
Author Email: joomclan@gmail.com
Url: http://www.joomclan.com
Copyright: 2009-2010
License: GNU
Component Version: 2.1.7
Software License: All of our PHP and HTML source code is released under the GNU General Public License (GPL) to ensure it is 100% compatible with Joomla!. 
The GPL is the world's most popular Free (as in Freedom) and Open Source Software license.
Some javascript and other media (images, css, ajax scripts, flv players, mp3 players etc …) may be released under different licenses. Please see the details with the individual products.
**************************************************/
defined('_JEXEC') or die('Restricted access');
class JLHelper
{

	function truncate($string, $length = 200, $etc = '...',$break_words = false, $middle = false)
	{
		if ($length == 0)
		return '';

		if (strlen($string) > $length) {
			$length -= min($length, strlen($etc));
			if (!$break_words && !$middle) {
				$string = preg_replace('/\s+?(\S+)?$/', '', substr($string, 0, $length+1));
			}
			if(!$middle) {
				return substr($string, 0, $length) . $etc;
			} else {
				return substr($string, 0, $length/2) . $etc . substr($string, -$length/2);
			}
		} else {
			return $string;
		}
	}

	function published( &$row, $i, $imgY = 'tick.png', $imgX = 'publish_x.png', $prefix='' )
	{
		global $option;
		$path=JUri::base()."components/$option/images/";
		$img 	= $row->published ? $imgY : $imgX;
		$alt 	= $row->published ? JText::_( 'Published' ) : JText::_( 'Unpublished' );

		$href = '
			<img src="'.$path. $img .'" border="0" alt="'. $alt .'" />'
			;

			return $href;
	}

	function featured( &$row, $i, $imgY = 'tick.png', $imgX = 'publish_x.png', $prefix='' )
	{
		global $option;
		$path=JUri::base()."components/$option/images/";
		$img 	= $row->featured ? $imgY : $imgX;
		$alt 	= $row->featured ? JText::_( 'Featured' ) : JText::_( 'Not Featured' );

		$href = '
			<img src="'.$path. $img .'" border="0" alt="'. $alt .'" />'
			;

			return $href;
	}
	
	function colored( &$row, $i, $imgX = 'bullet_red.png', $imgY = 'bullet_orange.png', $imgZ = 'bullet_grey.png', $prefix='' )
	{
		$path = JUri::base()."components/com_joomlistings/images/";
		$href = '';
		if($row->listingtype==1){
			$img = $imgX;
			$alt  = JText::_( 'Red' );
			$href = '<img src="'.$path. $img .'" border="0" alt="'. $alt .'" />';
		}
		if($row->listingtype==2){
			$img = $imgY;
			$alt  = JText::_( 'Orange' );
			$href = '<img src="'.$path. $img .'" border="0" alt="'. $alt .'" />';
		}
		if($row->listingtype==3){
			$img = $imgZ;
			$alt  = JText::_( 'Bold' );
			$href = '<img src="'.$path. $img .'" border="0" alt="'. $alt .'" />';
		}		

		return $href;
	}

	function publishedWL( &$row, $i, $imgY = 'tick.png', $imgX = 'publish_x.png', $prefix='' )
	{
		global $option;
		$img 	= $row->published ? $imgY : $imgX;
		$task 	= $row->published ? 'unpublish' : 'publish';
		$alt 	= $row->published ? JText::_( 'Published' ) : JText::_( 'Unpublished' );
		$action = $row->published ? JText::_( 'Unpublish Item' ) : JText::_( 'Publish item' );
		$path=JUri::base()."components/$option/images/";

		$href = '
		<a href="javascript:void(0);" onclick="return listItemTask(\'cb'. $i .'\',\''. $prefix.$task .'\')" title="'. $action .'">
		<img src="'.$path. $img .'" border="0" alt="'. $alt .'" /></a>'
		;

		return $href;
	}

	function sort( $title, $order, $direction = 'asc', $selected = 0, $task=NULL )
	{
		global $option;
		$direction	= strtolower( $direction );
		$images		= array( 'sort_asc.png', 'sort_desc.png' );
		$index		= intval( $direction == 'desc' );
		$direction	= ($direction == 'desc') ? 'asc' : 'desc';

		$html = '<a href="javascript:tableOrdering(\''.$order.'\',\''.$direction.'\',\''.$task.'\');" title="'.JText::_( 'Click to sort this column' ).'">';
		$html .= JText::_( $title );
		if ($order == $selected ) {
			$html .= "<img src='".JUri::base()."components/$option/images/".$images[$index]."' />";
		}
		$html .= '</a>';
		return $html;
	}

	function order( $rows, $image='filesave.png', $task="saveorder" )
	{
		global $option;
		$image =  "<img src='".JUri::base()."components/$option/images/filesave.png' alt='".JText::_( 'Save Order' )."' />";
		$href = '<a href="javascript:saveorder('.(count( $rows )-1).', \''.$task.'\')" title="'.JText::_( 'Save Order' ).'">'.$image.'</a>';
		return $href;
	}


	function orderUpIcon($i, $condition = true, $task = 'orderup', $alt = 'Move Up', $enabled = true)
	{
		global $option;
		$alt = JText::_($alt);

		$html = '&nbsp;';
		if (($i > 0 || ($i + $this->limitstart > 0)) && $condition)
		{
			if($enabled) {
				$html	= '<a href="#reorder" onclick="return listItemTask(\'cb'.$i.'\',\''.$task.'\')" title="'.$alt.'">';
				$html	.= '   <img src="'.JUri::base().'components/'.$option.'/images/uparrow.png" width="16" height="16" border="0" alt="'.$alt.'" />';
				$html	.= '</a>';
			} else {
				$html	= '<img src="images/uparrow0.png" width="16" height="16" border="0" alt="'.$alt.'" />';
			}
		}

		return $html;
	}

	/**
	 * Return the icon to move an item DOWN
	 *
	 * @access	public
	 * @param	int		$i The row index
	 * @param	int		$n The number of items in the list
	 * @param	boolean	$condition True to show the icon
	 * @param	string	$task The task to fire
	 * @param	string	$alt The image alternate text string
	 * @return	string	Either the icon to move an item down or a space
	 * @since	1.0
	 */
	function orderDownIcon($i, $n, $condition = true, $task = 'orderdown', $alt = 'Move Down', $enabled = true)
	{
		global $option;
		$alt = JText::_($alt);

		$html = '&nbsp;';
		if (($i < $n -1 || $i + $this->limitstart < $this->total - 1) && $condition)
		{
			if($enabled) {
				$html	= '<a href="#reorder" onclick="return listItemTask(\'cb'.$i.'\',\''.$task.'\')" title="'.$alt.'">';
				$html	.= '  <img src="'.JUri::base().'components/'.$option.'/images/downarrow.png" width="16" height="16" border="0" alt="'.$alt.'" />';
				$html	.= '</a>';
			} else {
				$html	= '<img src="images/downarrow0.png" width="16" height="16" border="0" alt="'.$alt.'" />';
			}
		}

		return $html;
	}

	function getUrlWOLayout($querystr)
	{

		if($pos=strpos($querystr,'layout'))
		{
			$parts=explode('layout',$querystr);
			return $parts[0];
		}
		else
		{
			return $querystr."&";
		}
	}

	function getBaseItemid($case = null)
	{
		$menu = &JSite::getMenu();
		$item = null;
		switch($case){
			case 'postad':
				$item = $menu->getItems("index.php?option=com_joomlistings&view=ad&layout=post&c=ad&task=postad");
				break;
			default:
			$item = $menu->getItems("link", "index.php?option=com_joomlistings&view=directory", true);		
		}
		return $item->id;
	}


	function invoke($url="")
	{
		$app	= &JFactory::getApplication();
		$router = &$app->getRouter();
	
		
		$aurl=$url;
		$objUrl=new JUri($aurl);
	/*	file_put_contents(JPATH_ROOT.DS.'log'.date("ymd").'.txt', "\n\rInvoker Url".$url, FILE_APPEND);
		file_put_contents(JPATH_ROOT.DS.'log'.date("ymd").'.txt', "\n\rInvoker Aurl".$aurl, FILE_APPEND);
	*/
		$x=$router->parse($objUrl);
		if(count($x)>0)
		{
			foreach($x as $k=>$v)
			{
				JRequest::setVar($k,$v);
				
			}
		}
		$mod=$x['c'];
		$method=$x['task'];
		$classpath=JPATH_COMPONENT.DS."controllers".DS.strtolower($mod).".php";
		require_once($classpath);
		$class=JoomlistingsController.ucfirst($mod);
		$x=new $class();
		$x->$method();
	
	}
}
?>