<?php
/*************************************************
Author: JoomClan.com
Creation Date: 2009-11-25
Author Email: joomclan@gmail.com
Url: http://www.joomclan.com
Copyright: 2009-2010
License: GNU
Component Version: 2.1.7
Software License: All of our PHP and HTML source code is released under the GNU General Public License (GPL) to ensure it is 100% compatible with Joomla!.
The GPL is the world's most popular Free (as in Freedom) and Open Source Software license.
Some javascript and other media (images, css, ajax scripts, flv players, mp3 players etc …) may be released under different licenses. Please see the details with the individual products.
**************************************************/
defined('_JEXEC') or die('Restricted access');

global $option;
$pluginpath=JPATH_ADMINISTRATOR.DS."components".DS."com_joomlistings".DS."plugins".DS."payment".DS."payment.plg.php";
require_once($pluginpath);

class Payment{
	
	var $invoice	=	null;
	var $option		=	null;
	var $pluginpath	=	null;
	var $plugin		=	null;
	var $data		=	null;
	var $returnurl	=	null;
	var $notifyurl	=	null;
	var $cancelurl	=	null;
	var $inurl		=	null;
	var $redir		=	null;
	var $custom		= 	null;

	function setPlugin($id){
		$db =& JFactory::getDBO();
		$query = "SELECT * from #__jlplugins where id='$id'";
		$db->setQuery($query);
		$row = $db->loadObject();
		$objPayment = new PaymentPlugin();
		$this->plugin = $objPayment->getInstance($row->element);
		$this->plugin->filldata($row);
		return $this->plugin;
	}
	
	function setUrls($urls=array()){
		$this->notifyurl = $urls['notifyurl'];
		$this->returnurl = $urls['returnurl'];
		$this->cancelurl = $urls['cancelurl'];
	}
	
	function setOption($option="", $mod="", $task=""){
		$this->option 	= $option;
		$this->mod 		= $mod;
		$this->task		= $task;
	}

	function setInvoice($invoice){
		$this->invoice = $invoice;
	}

	function setInurl($url){
		$this->inurl=$url;
	}

	function showInvoice(){
		$option = $this->option;
		$viewpath = JPATH_ROOT.DS."components".DS.$option.DS."views".DS."_payment".DS."view.html.php";
		require_once($viewpath);
		$view = new JoomlistingsView_Payment();
		$view->setLayout('_default');
		$query = "SELECT * from #__jlplugins where published='1'";
		$db =& JFactory::getDBO();
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		$plugins = array();
		if(count($rows)>0)
		{
			$pluginfolder = JPATH_ADMINISTRATOR.DS."components".DS.$option.DS."plugins";
			foreach($rows as $r)
			{
				//echo $pluginfolder.DS.$r->pgroup.DS.$r->folder.DS.$r->element.'.php';
				require_once($pluginfolder.DS.$r->pgroup.DS.$r->folder.DS.$r->element.'.php');
				$clsName = "PaymentPlugin".ucfirst($r->element);
				$plg = new $clsName();
				$plg->name = $r->title;
				$plg->folder = $r->folder;
				$plg->group = $r->pgroup;
				$plg->id = $r->id;
				$plg->element = $r->element;
				$plg->setInvoice($this->invoice);
				$plg->setInurl($this->inurl);
				$plg->setCustom($this->custom);
				$plg->setReturnUrl($this->returnurl);
				$plg->setNotifyUrl($this->notifyurl);
				$plg->setCancelUrl($this->cancelurl);
				$plugins[]=$plg;
			}
		}

		$view->assignRef('invoice',$this->invoice);
		$view->assignRef('plugins',$plugins);
		$view->assignRef('inurl',$this->inurl);
		$view->display();
	}

	function confirm($post){
		$this->data=$post;
		$this->plugin->setReturnUrl($this->returnurl);
		$this->plugin->setNotifyUrl($this->notifyurl);
		$this->plugin->setCancelUrl($this->cancelurl);
		$this->plugin->setCustom($this->custom);
	}

	function pay($post){
		$x = $this->plugin->pay($post);
		$this->redir = $this->plugin->redir;
		return $x;
	}
	
	function preprocess(){
		return $this->plugin->preprocess($this->data);
	}

	function notify()
	{
		global $mainframe,$option;
		JPluginHelper::importPlugin('joomlistings');
		$userid = JRequest::getVar('uid',0);
		if($x= $this->plugin->notify())
		{
			$this->redir=$this->plugin->redir;
			$user =& JFactory::getUser($userid);
			$ttable = JTable::getInstance('transaction','Table');
			$transact = $ttable->loadWithTx($x);
			$mainframe->triggerEvent('onPaymentReceived', array($transact, $user));
			return $x;
		}
		else
		{
			return false;
		}
	}

	function cancel(){
		$x = $this->plugin->cancel();
		$this->redir = $this->plugin->redir;
		return $x;
	}

	function success(){
//		global $mainframe,$option;
//		JPluginHelper::importPlugin('joomlistings');
//		$userid = JRequest::getVar('uid',0);
//		$x = $this->plugin->success();
//		$this->redir = $this->plugin->redir;
//		return $x;
	}
	
	function setCustom($custom){
		$this->custom = $custom;
	}
}
?>