<?php

	function jlCronGetArgs($args){
		$out = array();
		$last_arg = null;
	    for($i = 1, $il = sizeof($args); $i < $il; $i++) {
	        if( (bool)preg_match("/^--(.+)/", $args[$i], $match) ) {
	         $parts = explode("=", $match[1]);
	         $key = preg_replace("/[^a-z0-9]+/", "", $parts[0]);
	            if(isset($parts[1])) {
	             $out[$key] = $parts[1];   
	            }
	            else {
	             $out[$key] = true;   
	            }
	         $last_arg = $key;
	        }
	        else if( (bool)preg_match("/^-([a-zA-Z0-9]+)/", $args[$i], $match) ) {
	            for( $j = 0, $jl = strlen($match[1]); $j < $jl; $j++ ) {
	             $key = $match[1]{$j};
	             $out[$key] = true;
	            }
	         $last_arg = $key;
	        }
	        else if($last_arg !== null) {
	         $out[$last_arg] = $args[$i];
	        }
	    }
	 return $out;
	}
	
	// Set flag that this is a parent file
	define( '_JEXEC', 1 );
	define( 'JOOMLISTINGS_COMPONENT_PATH', dirname(__FILE__));
	define('JPATH_BASE', dirname(dirname(dirname(__FILE__))));
	define( 'DS', DIRECTORY_SEPARATOR );
	define('LOG_PATH', JPATH_BASE. DS . 'logs');
	require_once ( JPATH_BASE .DS.'includes'.DS.'defines.php' );
	require_once ( JPATH_BASE .DS.'includes'.DS.'framework.php' );
	
	$mainframe =& JFactory::getApplication('site');
	
	require_once ( JOOMLISTINGS_COMPONENT_PATH . DS . 'includes' . DS . 'jlfactory.php' );
	
	$argv = jlCronGetArgs($_SERVER['argv']);
	$task = $argv['task'];
	fopen( LOG_PATH . DS .'cron_log'.date("ymd").'.txt', 'a+');
	file_put_contents(LOG_PATH . DS .'cron_log'.date("ymd").'.txt', "\r\nCron argument:". serialize($task), FILE_APPEND);
	switch ($task){
		case 'expireads':
			archiveExpiredAds();
			break;
		case 'checksubscription':
			recalculateUserPackageExpire();
			break;
		case 'adviceexpiry':
			sendEmailAdviceExpiry();
			break;
		case 'tweet':
			tweetToTwitter();
			break;
		default:
			return;
	}
	
	function archiveExpiredAds(){
		$db =& JFactory::getDBO();
		$query = "UPDATE #__joomlistings as jl SET jl.status = 2 WHERE jl.expirydate < curdate()";
		$db->setQuery($query);
		$db->query();
	}
	
	function recalculateUserPackageExpire(){
		$db =& JFactory::getDBO();
		// first: make array of package which need to update 
		$query = "SELECT id, days FROM #__jlpackages WHERE id IN (SELECT pid FROM #__jluser_subscribes WHERE next_update_user_package <= curdate() AND cancelled = '0')";
		$db->setQuery($query);
		$packages = $db->loadObjectList('id');
		//fopen( JOOMLISTINGS_COMPONENT_PATH . DS .'cron_log'.date("ymd").'.txt', 'a+');
		//file_put_contents(JOOMLISTINGS_COMPONENT_PATH . DS .'cron_log'.date("ymd").'.txt', "\r\nCron argument:". serialize($packages), FILE_APPEND);
		//now $package is array with key is pid and value is stdClass object
		
		// list user - packages need to update expirydate
		$query = "SELECT * FROM #__jluser_subscribes WHERE next_update_user_package <= curdate() AND cancelled = '0'";
		$db->setQuery($query);
		$subscribes = $db->loadObjectList();
		if(count($subscribes)){
			foreach($subscribes as $uid_pid){
				$sid = $uid_pid->id;
				$pid = $uid_pid->pid;
				$uid = $uid_pid->user_id;
				$days = $packages[$pid]->days;
				$query = "UPDATE #__jlusers_packages SET expirydate = ADDDATE( expirydate, $days) WHERE userid='$uid' AND packageid = '$pid'";
				$db->setQuery($query);
				//fopen( JOOMLISTINGS_COMPONENT_PATH . DS .'cron_log'.date("ymd").'.txt', 'a+');
				//file_put_contents(JOOMLISTINGS_COMPONENT_PATH . DS .'cron_log'.date("ymd").'.txt', "\r\nCron argument:". serialize($db->getQuery()), FILE_APPEND);
				$db->query();
				// then update next_update_user_package too
				$query = "UPDATE #__jluser_subscribes SET next_update_user_package = ADDDATE(next_update_user_package, $days) WHERE id = $sid";
				$db->setQuery($query);
				$db->query();
			} 
		}
	}
	
	function sendEmailAdviceExpiry(){
		$db =& JFactory::getDBO();
		fopen( LOG_PATH . DS .'cron_log'.date("ymd").'.txt', 'a+');
		$mainframe =& JFactory::getApplication('site');
		//$mainframe->initialise();
		jimport('joomla.plugin.helper');
		jimport('joomla.database.table');
		JPluginHelper::importPlugin('joomlistings');
		JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_joomlistings'.DS.'tables');
		
		$settings = JoomListingsFactory::getSettings();
		$expiry_alert_days = $settings->expiry_alert_days;
		$query = "SELECT jup.*, DATEDIFF(expirydate, CURDATE()) as remain_expiry FROM #__jlusers_packages AS jup INNER JOIN #__jlpackages AS jp ON jup.packageid = jp.id WHERE jup.expirydate <> '-1' AND expirydate > CURDATE() AND DATEDIFF(expirydate,CURDATE()) <= $expiry_alert_days AND DATEDIFF( expirydate, CURDATE()) <= jp.days AND jup.archived = '0' AND jup.published = '1' ";
		
		$db->setQuery($query);
		$ups = $db->loadObjectList();
		//file_put_contents(JOOMLISTINGS_COMPONENT_PATH . DS .'cron_log'.date("ymd").'.txt', "\r\nCron Expired:". serialize($ups), FILE_APPEND);
		if(count($ups)){
			foreach($ups as $up){
				$user =& JFactory::getUser($up->userid);
				$mainframe->triggerEvent('onPackageAboutToExpire', array($up, $user));
			}
		}
	}
	
	function tweetToTwitter(){
		include_once(JPATH_BASE . DS . 'administrator'. DS . 'components' . DS . 'com_joomlistings' . DS . 'helpers' . DS . 'twitteroauth' . DS . 'twitteroauth' . DS . 'twitteroauth.php');
		$settings = JoomListingsFactory::getSettings();
		if(!$settings->enable_twitter)
			return;
		$ad = getListingToTweet();
		if($ad->id){
			$unique = makeUniqueString();
			//fopen( LOG_PATH . DS .'cron_log'.date("ymd").'.txt', 'a+');
			//file_put_contents(LOG_PATH . DS .'cron_log'.date("ymd").'.txt', "\r\nCron tweet:". serialize(JURI::root()), FILE_APPEND);
			updateListingUniqeString($ad->id, 'jls-'.$unique);
			if($settings->form_twitter_status == 'text-link'){
				$status = $ad->title .' - ' . $settings->twitter_base_url . 'jls-'.$unique;
			}else{
				$status = $settings->twitter_base_url . 'jls-'.$unique .' - '. $ad->title;
			}
			$connection = new TwitterOAuth($settings->twitter_consumer_key, $settings->twitter_consumer_secret, $settings->twitter_oauth_token, $settings->twitter_oauth_token_secret);
			$connection->post('statuses/update', array('status' => $status));
		}
	}
	
	function makeUniqueString(){
		$db =& JFactory::getDBO();
		$uniqString = '';
		$uniq = false;
		while($uniq == false){
			$uniqString = generateString();
			$query = "SELECT count(*) as total FROM #__joomlistings WHERE s_unique = '$uniqString'";
			$db->setQuery($query);
			$obj = $db->loadObject();
			if($obj->total == 0){
				$uniq = true;
			}
		}
		return $uniqString;
	}
		
	function generateString(){
		$length = 3;
		$ret = "";
		$az_low = range(97, 122);
		$az_up = range(65, 90);
		$dig = range(48, 57);
		$charCodes = array_merge($az_low, $az_up, $dig);
		foreach($charCodes as $key => $code){
			$charCodes[$key] = chr($code);
		}
		for($i = 0; $i< $length; $i++){
			shuffle($charCodes);
			$ret .= $charCodes[0];
		}
		return $ret;
	}
	
	function getListingToTweet(){
		$db =& JFactory::getDBO();
		$query = "SELECT * FROM #__joomlistings WHERE s_unique = '' LIMIT 1 AND catid IN (SELECT id FROM #__jlcategories WHERE enable_twitter = 1)";
		$db->setQuery($query);
		$obj = $db->loadObject();
		return $obj;
	}
	
	function updateListingUniqeString($id, $unique){
		$db =& JFactory::getDBO();
		$query = "UPDATE #__joomlistings SET s_unique = '$unique' WHERE id = '$id'";
		$db->setQuery($query);
		$db->query();
	}


?>



