<?php
/*************************************************
 Author: JoomClan.com
 Creation Date: 2009-11-25
 Author Email: joomclan@gmail.com
 Url: http://www.joomclan.com
 Copyright: 2009-2010
 License: GNU
 Component Version: 2.1.7
 Software License: All of our PHP and HTML source code is released under the GNU General Public License (GPL) to ensure it is 100% compatible with Joomla!.
 The GPL is the world's most popular Free (as in Freedom) and Open Source Software license.
 Some javascript and other media (images, css, ajax scripts, flv players, mp3 players etc …) may be released under different licenses. Please see the details with the individual products.
 **************************************************/

defined('_JEXEC') or die('Restricted access');

jimport("joomla.application.component.model");

class JoomlistingsModelCategory extends JModel
{

	function getExtraFields($cid=0,$adid=0)
	{
		$db=JFactory::getDBO();

		if($adid)
		{
			$query="SELECT * from #__jllist_extrafields where adid='$adid'";
			$db->setQuery($query);
			$values=$db->loadObjectList();
		}

		$query="SELECT * from #__jlextrafields where (catid='$cid' or common='1') and published='1' order by ordering";
		$db->setQuery($query);
		$rows=$db->loadObjectList();
		if(count($rows)>0)
		{
			for($i=0;$i<count($rows);$i++)
			{
				$r=$rows[$i];
				if( $r->fieldtype!='text' && $r->fieldtype!='textarea')
				{
					$query="SELECT * from #__jltypeoptions where fieldid='$r->id' and published='1' order by ordering";
					$db->setQuery($query);
					$r->options=$db->loadObjectList();

				}

				if($adid)
				{
					foreach($values as $v)
					{
						if($v->fieldid==$r->id)
						{
							$r->value[]=$v->fieldvalue;
						}
					}
				}
			}
		}
		return $rows;
	}

	function getCategoriesWithSections()
	{

		$db=JFactory::getDBO();
		$query="SELECT * from #__jlsections order by ordering";
		$db->setQuery($query);
		$rows=$db->loadObjectList();

		if(count($rows)>0)
		{
			for($i=0;$i<count($rows);$i++)
			{
				$r=$rows[$i];
				$query2="SELECT * from #__jlcategories where section_id='$r->id'";
				$db->setQuery($query2);
				$r->categories=$db->loadObjectList();
			}
		}
		return $rows;

	}

	function getSections()
	{
		$db=JFactory::getDBO();
		$query="SELECT id,title from #__jlsections where published ='1' order by ordering";

		$db->setQuery($query);
		$rows=$db->loadObjectList();
		return $rows;
	}

	function getCategories($section_list)
	{
		$db=JFactory::getDBO();
		$section_list = implode('\', \'', $section_list);

		$query = 'SELECT id, title, section_id' .
				' FROM #__jlcategories' .
				' WHERE section_id IN ( \''.$section_list.'\' )' .
				' ORDER BY ordering';
		$db->setQuery($query);
		$rows=$db->loadObjectList();
		return $rows;

	}

	function getCurrencies()
	{
		$db=JFactory::getDBO();
		$query="SELECT concat(symbol,':',title) as value, title as text from #__jlcurrencies where published='1' order by title";
		$db->setQuery($query);
		return $db->loadObjectList();
	}

	function getMakes()
	{
		$db=JFactory::getDBO();
		$query="SELECT id , title from #__jlmakes where published='1' order by title";
		$db->setQuery($query);
		return $db->loadObjectList();
	}


	function getModels($makelist)
	{
		$db=JFactory::getDBO();
		$makelist = implode('\', \'', $makelist);

		$query = 'SELECT id, title, make_id' .
				' FROM #__jlmodels' .
				' WHERE section_id IN ( \''.$makelist.'\' )' .
				' ORDER BY ordering';
		$db->setQuery($query);
		return $db->loadObjectList();
	}


	function getAdTypes()
	{
		$db=JFactory::getDBO();
		$query="SELECT title as value , title as text from #__jltypes where published='1' order by title";
		$db->setQuery($query);
		return $db->loadObjectList();
	}


	function getCategoryDetail($cid)
	{
		$db=JFactory::getDBO();
		$query="SELECT * from #__jlcategories as cat where id='$cid' and published='1'";
		$db->setQuery($query);
		$obj= $db->loadObject();

		if($obj)
		{
			return $obj;
		}
		else
		{
			$obj=new stdClass();
			$obj->id=0;
			$obj->title=JText::_("ALL_CAT");
			return $obj;
		}

	}

	function getSectionDetail($sid)
	{
		$db=JFactory::getDBO();
		$query="SELECT * from #__jlsections where id='$sid'";
		$db->setQuery($query);
		return $db->loadObject();
	}

	function getSectionDetailFromCategory($cid)
	{
		$db=JFactory::getDBO();
		$query="SELECT s.* from #__jlsections as s left join #__jlcategories as c on c.section_id=s.id where c.id='$cid'";
		$db->setQuery($query);
		return $db->loadObject();
	}


	function getDefaultSection(){
		$query="SELECT * from #__jlsections where default_section='1'";
		$this->_db->setQuery($query);
		return $this->_db->loadObject();
	}
	
	function getListCategory($rid = null, $lid = null, $nid = null, $pid = null){
		$region_condition = "";
		if($rid && $lid && $nid){
			$region_condition = " AND l.rid = $rid AND l.lid = $lid AND l.nid = $nid ";
		}
		$query = "SELECT c.*, ";
		$query .="(SELECT count(*) FROM #__joomlistings AS l ";
		$query .="WHERE l.catid=c.id AND l.published='1' $region_condition and expirydate>=curdate()) as adcount ";
		$query .="FROM #__jlcategories as c WHERE published = 1 ";
		if($pid != null && $pid != 0){
			$query .="AND c.id IN (SELECT category_id FROM #__jlcategory_package WHERE package_id = '$pid') ";
		}
		$query .="ORDER BY c.parent_id ASC"; //order by c.parent_id very important
		$this->_db->setQuery($query);
		return $this->_db->loadObjectList();
	}

}
?>