<?php
/*************************************************
 Author: JoomClan.com
 Creation Date: 2009-11-25
 Author Email: joomclan@gmail.com
 Url: http://www.joomclan.com
 Copyright: 2009-2010
 License: GNU
 Component Version: 2.1.7
 Software License: All of our PHP and HTML source code is released under the GNU General Public License (GPL) to ensure it is 100% compatible with Joomla!.
 The GPL is the world's most popular Free (as in Freedom) and Open Source Software license.
 Some javascript and other media (images, css, ajax scripts, flv players, mp3 players etc …) may be released under different licenses. Please see the details with the individual products.
 **************************************************/

defined('_JEXEC') or die('Restricted access');



//import Joomla Model
jimport("joomla.application.component.model");

class JoomlistingsModelListing extends JModel
{
	function getCountAllListings($rid, $lid, $nid = null){
		$settings = JoomListingsFactory::getSettings();
		$cond = "";
		if($settings->enable_regions){
			$cond .= " AND rid = '$rid'";
			$cond .= " AND lid = '$lid'";
			if($nid)
				$cond .= " AND nid = '$nid'";
		}
		$db =& JFactory::getDBO();
		$query="SELECT count(*) from #__joomlistings as j where published='1' $cond and expirydate>=curdate()";
		$db->setQuery($query);
		return $db->loadResult();
	}

	function getAdDetail($id){
		$db =& JFactory::getDBO();
		$query = "SELECT * from #__joomlistings where id='$id'";
		$db->setQuery($query);
		return $db->loadObject();
	}

	function getAllListings($rid = null, $lid = null, $nid = null, $limitstart, $limit)
	{
		$settings = JoomListingsFactory::getSettings();

		$db =& JFactory::getDBO();
		if(isset($settings->frontend_alpha) && $settings->frontend_alpha)
		{
			$query="SELECT j.*,
		(select image from #__jlimages where adid=j.id order by ordering limit 1) as image,
		(select count(*) from #__jlimages where adid=j.id ) as imagecount from #__joomlistings as j
		where published='1' AND lid='$lid' AND rid= '$rid' AND nid='$nid' and expirydate>=curdate() order by j.featured desc, j.listingtype ASC, j.title asc, j.postdate desc limit $limitstart,$limit ";
		}
		else
		{
			$cond = "";
			if($settings->enable_regions){
				$cond .= " AND rid = '$rid'";
				$cond .= " AND lid = '$lid'";
				if(isset($nid))
					$cond .= " AND nid = '$nid'";
			}
			$query="SELECT j.*,
		(select image from #__jlimages where adid=j.id order by ordering limit 1) as image,
		(select count(*) from #__jlimages where adid=j.id ) as imagecount from #__joomlistings as j
		where published='1' $cond and expirydate>=curdate() order by j.featured desc, j.postdate desc   limit $limitstart,$limit ";
		}
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		if(count($rows)>0)
		{
			for($i=0,$n=count($rows);$i<$n;$i++)
			{
				$r =& $rows[$i];
				$query2="SELECT e.*,f.* from #__jllist_extrafields as e left join #__jlextrafields as f on f.id=e.fieldid";
				$db->setQuery($query2);
				$r->extrafields=$db->loadObjectList();
				
				$query = "SELECT SUM(total_vote) AS sum_total_vote FROM #__jllisting_star WHERE listing_id = ". $r->id;
				$db->setQuery($query);
				$fv = $db->loadObjectList();
				$sum_total_vote = $fv[0]->sum_total_vote;
				
				$query3 = "SELECT SUM(star_value * total_vote) / $sum_total_vote AS aver FROM #__jllisting_star WHERE listing_id = ". $r->id;
				$db->setQuery($query3);
				$aver = $db->loadObjectList();
				if($aver){
					$r->star_average = $aver[0]->aver;
				}else{
					$r->star_average = 0;
				}
			}
		}
		return $rows;
	}

	function getListingsByCategory($rid = null, $lid = null, $nid = null, $id, $limitstart, $limit)
	{
		$settings = JoomListingsFactory::getSettings();
		$db =& JFactory::getDBO();
		if(isset($settings->frontend_alpha) && $settings->frontend_alpha)
		{
			$query="SELECT j.*,
		(select image from #__jlimages where adid=j.id order by ordering limit 1) as image,
		(select count(*) from #__jlimages where adid=j.id ) as imagecount from #__joomlistings as j where j.catid='$id'
		and published='1' AND lid='$lid' AND rid= '$rid' AND nid='$nid' and expirydate>=curdate() order by j.featured desc, j.listingtype ASC, j.title asc, j.postdate desc  limit $limitstart,$limit ";
		}
		else
		{
			$cond = "";
			if($settings->enable_regions){
				$cond .= " AND rid = '$rid'";
				$cond .= " AND lid = '$lid'";
				if($nid)
					$cond .= " AND nid = '$nid'";
			}
			$query="SELECT j.*,
		(select image from #__jlimages where adid=j.id order by ordering limit 1) as image,
		(select count(*) from #__jlimages where adid=j.id ) as imagecount from #__joomlistings as j where j.catid='$id'
		and published='1' $cond and expirydate>=curdate() order by j.featured desc, j.listingtype ASC, j.postdate desc limit $limitstart,$limit ";
		}

		$db->setQuery($query);
		$rows = $db->loadObjectList();
		if(count($rows)>0)
		{
			for($i=0,$n=count($rows);$i<$n;$i++)
			{
				$r =& $rows[$i];
				$query2 = "SELECT e.*,f.* from #__jllist_extrafields as e left join #__jlextrafields as f on f.id=e.fieldid";
				$db->setQuery($query2);
				$r->extrafields = $db->loadObjectList();
				
				$query = "SELECT SUM(total_vote) AS sum_total_vote FROM #__jllisting_star WHERE listing_id = ". $r->id;
				$db->setQuery($query);
				$fv = $db->loadObjectList();
				$sum_total_vote = $fv[0]->sum_total_vote;
				
				$query3 = "SELECT SUM(star_value * total_vote) / $sum_total_vote AS aver FROM #__jllisting_star WHERE listing_id = ". $r->id;
				$db->setQuery($query3);
				$aver = $db->loadObjectList();
				if(count($aver)> 0)
					$r->star_average = $aver[0]->aver;
				else
					$r->star_average = 0;
			}
		}
		return $rows;
	}

	function getCountListingsByCategory($rid, $lid, $nid = null, $id)
	{
		$settings = JoomListingsFactory::getSettings();
		$cond = "";
		if($settings->enable_regions){
			$cond .= " AND rid = '$rid'";
			$cond .= " AND lid = '$lid'";
			if($nid)
				$cond .= " AND nid = '$nid'";
		}
		$db =& JFactory::getDBO();
		$query = "SELECT count(*) FROM #__joomlistings as j WHERE j.catid='$id' AND published='1' $cond AND expirydate>=curdate()";
		$db->setQuery($query);
		return $db->loadResult();
	}

	function save($data, $images, &$package, $edit)
	{
		$settings = JoomListingsFactory::getSettings();
		$user =& JFactory::getUser();
		$userid = $user->get('id');
		if($userid){
			$data['userid'] = $userid;
			
			if(!isset($data['published']))
				$data['published'] = $settings->auto_submit;
			if(!$edit){
				
				$data['postdate'] = date("Y-m-d G:i:s");
				if((int)$settings->auto_expire_ads){
					if($settings->enable_packages){
						if($package->listing_days == -1){
							$data['expirydate'] = date("Y-m-d G:i:s", strtotime("+ $settings->ads_expiry_days days"));
						}else{
							$data['expirydate'] = date("Y-m-d G:i:s", strtotime("+ $package->listing_days days"));
						}
					}else{
						$data['expirydate'] = date("Y-m-d G:i:s", strtotime("+ $settings->ads_expiry_days days"));
					}
				}
			}
			else{
				$data['id'] = $data['adid'];
			}
			$table = $this->getTable('listings','Table');
			$table->bind($data);
			if (!$table->id) {
				$table->ordering = $table->getNextOrder( );
			}
			$table->description = JRequest::getVar( 'description', '', 'post', 'string', JREQUEST_ALLOWRAW );
			$table->externalvideo = JRequest::getVar( 'externalvideo', '', 'post', 'string', JREQUEST_ALLOWRAW );
			$prices = explode(":", $data['currency']);
			$table->currency = $prices[1];
			$table->currencysymbol = $prices[0];
			$table->store($data['field'], $images, $package);
			return $table->id;
		}
		else
		{
			throw new Exception('User Not Logged in', 500);
		}
	}


	function isPublishedAndFeatured($id)
	{
		$db=JFactory::getDBO();
		$query="SELECT published,featured,listingtype from #__joomlistings where id='$id'";
		$db->setQuery($query);

		return $db->loadObject();
	}

	function delete($arr)
	{
		if(count($arr)>0)
		{
			$ids="(".implode(",",$arr).")";

			$db=JFactory::getDBO();

			$query="DELETE from #__joomlistings where id in $ids";

			$db->setQuery($query);
			$db->query();

			$query="DELETE from #__jllist_extrafields where adid in $ids";

			$db->setQuery($query);
			$db->query();

			$query="SELECT * from #__jlimages where adid  in $ids";
			$db->setQuery($query);
			$images=$db->loadObjectlist();

			$user=JFactory::getUser();

			$basepath=JPATH_ROOT.DS."images".DS."ads".DS.$user->get('id');
			if(count($images)>0)
			{
				foreach($images as $img)
				{
					if(file_exists($basepath.DS.$img->image."_thm.jpg"))
					{
						unlink($basepath.DS.$img->image."_thm.jpg");
					}

					if(file_exists($basepath.DS.$img->image."_sthm.jpg"))
					{
						unlink($basepath.DS.$img->image."_sthm.jpg");
					}

					if(file_exists($basepath.DS.$img->image."_lthm.jpg"))
					{
						unlink($basepath.DS.$img->image."_lthm.jpg");
					}

					if(file_exists($basepath.DS.$img->image.".jpg"))
					{
						unlink($basepath.DS.$img->image.".jpg");
					}
				}
			}

			$query="DELETE from #__jlimages where adid in $ids";
			$db->setQuery($query);
			return $db->query();
		}
		else
		{
			return false;
		}
	}

	function publishAd($id)
	{
		$db=JFactory::getDBO();
		$query="UPDATE #__joomlistings set published='1' where id='$id'";
		$db->setQuery($query);
		return $db->query();
	}

	function featureAd($id)
	{
		$db=JFactory::getDBO();
		$query="UPDATE #__joomlistings set featured='1' where id='$id'";
		$db->setQuery($query);
		return $db->query();
	}

	function colorAd($id,$color)
	{
		$db=JFactory::getDBO();
		$query="UPDATE #__joomlistings set listingtype='$color' where id='$id'";
		$db->setQuery($query);
		return $db->query();
	}

	function getCategories()
	{

	}

	function getMyAds($userid,$filter,$limitstart=0,$limit=20)
	{
		$db=JFactory::getDBO();
		$wherex=array();
		if($filter->state>=0)
		{
			$wherex[]=" published='$filter->state'";

		}
		$wherey=array();
		if(!empty($filter->text))
		{
			$text		= $db->Quote( '%'.$db->getEscaped( $filter->text, true ).'%', false );
			$wheres2 	= array();
			$wheres2[] 	= 'title LIKE '.$text;
			$wheres2[] 	= 'description LIKE '.$text;
			$wheres2[] 	= 'type LIKE '.$text;
			$wheres2[] 	= 'tags LIKE '.$text;

			$wherey 		= ' (' . implode( ') OR (', $wheres2 ) . ')';

			$wherex[]=' ('.$wherey.') ';

		}

		$where="";
		if(count($wherex)>0)
		{
			$where=' and '.implode(' and ',$wherex);
		}
		$query="SELECT * from #__joomlistings where userid='$userid' $where limit $limitstart,$limit";

		$db->setQuery($query);
		return $db->loadObjectList();
	}

	function getMyAdsCount($userid,$filter)
	{
		$db=JFactory::getDBO();
		$wherex = array();
		if($filter->state>=0)
		{
			$wherex[]=" published='$filter->state'";

		}
		$where="";
		if(count($wherex)>0)
		{
			$where=' and ('.implode(' and ',$wherex).')';
		}

		$query="SELECT count(*) from #__joomlistings where userid='$userid' $where";
		$db->setQuery($query);

		return $db->loadResult();
	}

	function hasToPay(&$userinfo, &$adinfo) {
		$settings = JoomListingsFactory::getSettings();
		$pay = new stdClass();
		if($settings->enable_packages) {
			if($userinfo->hasPost>0 || $userinfo->hasPost<=-1) {
				$pay->pay_for_ad = 0;
			}
			elseif($adinfo->published){
				$pay->pay_for_ad = 0;
			}
			else{
				$pay->pay_for_ad = 1;
			}
			
			//pay for featured
			if($adinfo->wantstofeature && $settings->feature_payable && !$adinfo->featured && $userinfo->priceforfeatured > 0){
				if($userinfo->priceforfeatured > 0){
					$pay->pay_for_featured = 1;
				}
				else{
					$pay->pay_for_featured = 0;
				}
			}else{
				$pay->pay_for_featured=0;
			}
			
			//pay for color
			if($adinfo->wantstocolor){
				if($settings->orange_payable && !$adinfo->listingtype && ($userinfo->pricefororange > 0)){
					$pay->pay_for_color = (int)$adinfo->wantstocolor;
				}
				if($settings->red_payable && !$adinfo->listingtype && ($userinfo->priceforred > 0)){
					$pay->pay_for_color = (int)$adinfo->wantstocolor;
				}
				if($settings->bold_payable && !$adinfo->listingtype && ($userinfo->priceforbold > 0)){
					$pay->pay_for_color = (int)$adinfo->wantstocolor;
				}
			}else{
				$pay->pay_for_color = 0;
			}
			if($pay->pay_for_ad || $pay->pay_for_featured || $pay->pay_for_color ){
				return $pay;
			}
			else{
				return false;
			}
		}
		elseif($settings->payable){
			
//			if($adinfo->published){
//				$pay->pay_for_ad = 0;
//			}
//			else{
				if($settings->price_per_ad > 0){
					$pay->pay_for_ad=1;
				}else{
					$pay->pay_for_ad=0;
				}
			//}
			if($adinfo->wantstofeature && $settings->feature_payable && !$adinfo->featured){
				if($settings->featured_price>0){
					$pay->pay_for_featured = 1;
				}else{
					$pay->pay_for_featured = 0;
				}
			}else{
				$pay->pay_for_featured = 0;
			}

			if($adinfo->wantstocolor && ($settings->orange_payable || $settings->red_payable)){
				switch((int)$adinfo->wantstocolor) {
					case 1:
						if($settings->price_for_orange > 0) {
							$pay->pay_for_color = (int)$adinfo->wantstocolor;
						}else{
							$pay->pay_for_color = 0;
						}
						break;
					case 2:
						if($settings->price_for_red > 0) {
							$pay->pay_for_color = (int)$adinfo->wantstocolor;
						}else{
							$pay->pay_for_color = 0;
						}
						break;
					case 3:
						if($settings->price_for_bold > 0) {
							$pay->pay_for_color = (int)$adinfo->wantstocolor;
						}else{
							$pay->pay_for_color = 0;
						}
						break;
					default:
						$pay->pay_for_color = 0;
						break;
				}
			}
			else{
				$pay->pay_for_color=0;
			}

			if($pay->pay_for_ad || $pay->pay_for_featured || $pay->pay_for_color) {
				return $pay;
			}
			else{
				return false;
			}
		}
		else{
			return false;
		}

	}

	function search($filter,$limitstart,$limit)
	{
		$db=JFactory::getDBO();
		
		$where = $this->_buildWhere($filter);

		/**
		 * If there is search in filter use search in filter
		 */
		$inwheres="";

		if($filter->simple == '0')
		{
			if(count($filter->searchin)>0)
			{
				$inwhere=" AND (j.sectionid in (".implode(",",$filter->searchin)."))";
				$where.=$inwhere;
			}

			if($filter->region==1&&$filter->region_id)
			{
				$where.=" AND (j.rid ='$filter->region_id')";
			}

			if($filter->region==2&&$filter->location_id)
			{
				$where.=" AND (j.lid ='$filter->location_id')";
			}

		}

		$orderby="j.".$filter->orderby." ".$filter->dir;

		$query="SELECT j.*,s.title as section, c.title as category,
		(select image from #__jlimages where adid=j.id order by ordering limit 1) as image,
		(select count(*) from #__jlimages where adid=j.id ) as imagecount from #__joomlistings as j
		left join #__jlsections as s on s.id=j.sectionid
		left join #__jlcategories as c on c.id=j.catid" .
				" left join #__jllocations as lc on j.lid = lc.id" .
				" left join #__jlstates as st on st.id = lc.region_id" .
		" where j.published='1' and expirydate>=curdate() and $where  order by $orderby, j.postdate desc   limit $limitstart,$limit ";

		$db->setQuery($query);

		$rows=$db->loadObjectList();
		$results = array();
		if($rows){
			$results = $this->array_copy($rows);
			switch($filter->included_images)
			{
				case '0':
					if(count($rows > 0))
					{
						for($i=0; $i < count($rows); $i++)
						{
							$r = $rows[$i];
							if($r->imagecount != "0") unset($results[$i]);
						}
					}
				break;
				case '1':
					if(count($rows > 0))
					{
						for($i=0; $i < count($rows); $i++)
						{
							$r = $rows[$i];
							if($r->imagecount == "0") unset($results[$i]);
						}
					}
				break;
				default:
				break;
			}
		}
		if(count($results)>0)
		{
			for($i=0,$n=count($results);$i<$n;$i++)
			{
				$r=$results[$i];
				$query2="SELECT e.*,f.* from #__jllist_extrafields as e left join #__jlextrafields as f on f.id=e.fieldid";
				$db->setQuery($query2);
				$r->extrafields=$db->loadObjectList();
			}
		}
		return $results;
	}

	function searchCounts($filter)
	{
		$db=JFactory::getDBO();
		$where = $this->_buildWhere($filter);

		/**
		 * If there is search in filter use search in filter
		 */
		$inwheres="";
		if(count($filter->searchin)>0)
		{
			$inwhere=" AND (j.sectionid in (".implode(",",$filter->searchin)."))";
			$where.=$inwhere;
		}

		if($filter->region==1&&$filter->region_id)
		{
			$where.=" AND (j.rid ='$filter->region_id')";
		}

		if($filter->region==2&&$filter->location_id)
		{
			$where.=" AND (j.lid ='$filter->location_id')";
		}
		
		$append = "";
		if($filter->included_images){
			switch($filter->included_images)
			{
				case '0':
					$append = " AND j.id IN (SELECT jlia.adid FROM jos_jlimages AS jlia INNER JOIN jos_jlimages AS jlib ON jlia.id = jlib.id 
								 GROUP BY adid HAVING count( jlia.id ) = 0)";
				break;
				case '1':
					$append = " AND j.id IN (SELECT jlia.adid FROM jos_jlimages AS jlia INNER JOIN jos_jlimages AS jlib ON jlia.id = jlib.id 
								 GROUP BY adid HAVING count( jlia.id ) > 0)";
				break;
				default:
				break;
			}
		}
		

		$query="SELECT count(*) from #__joomlistings as j
		left join #__jlsections as s on s.id=j.sectionid
		left join #__jlcategories as c on c.id=j.catid ".
		" left join #__jllocations as lc on j.lid = lc.id" .
				" left join #__jlstates as st on st.id = lc.region_id" .
		" where j.published='1' and expirydate>=curdate() and $where  ". $append;

		$db->setQuery($query);
		return ($db->loadResult());

	}


	/**
     * make a recursive copy of an array
     *
     * @param array $aSource
     * @return array    copy of source array
     */
    function array_copy ($aSource) {
        // check if input is really an array
        if (!is_array($aSource)) {
            throw new Exception("Input is not an Array");
        }

        // initialize return array
        $aRetAr = array();

        // get array keys
        $aKeys = array_keys($aSource);
        // get array values
        $aVals = array_values($aSource);

        // loop through array and assign keys+values to new return array
        for ($x=0;$x<count($aKeys);$x++) {
            // clone if object
            if (is_object($aVals[$x])) {
                $aRetAr[$aKeys[$x]]=clone $aVals[$x];
            // recursively add array
            } elseif (is_array($aVals[$x])) {
                $aRetAr[$aKeys[$x]]=array_copy ($aVals[$x]);
            // assign just a plain scalar value
            } else {
                $aRetAr[$aKeys[$x]]=$aVals[$x];
            }
        }

        return $aRetAr;
    }
    
    function _buildWhere($filter){
    	$db=JFactory::getDBO();
    	$wheres = array();
		$where = "";
		if($filter->simple == '1')
		{
			switch ($filter->phrase) {
				case 'exact':
					$text		= $db->Quote( '%'.$db->getEscaped( $filter->text, true ).'%', false );
					$wheres2 	= array();
					$wheres2[] 	= 'j.title LIKE '.$text;
					$wheres2[] 	= 'j.description LIKE '.$text;
					$wheres2[] 	= 'j.alias LIKE '.$text;
					$wheres2[] 	= 'j.keywords LIKE '.$text;
					$wheres2[] 	= 'j.tags LIKE '.$text;
					$wheres2[] 	= 'j.price LIKE '.$text;
					$wheres2[] 	= 's.title LIKE '.$text;
					$wheres2[] 	= 'c.title LIKE '.$text;
					$where 		= '(' . implode( ') OR (', $wheres2 ) . ')';
					break;
				case 'listing_id':
					$text		= $db->Quote( '%'.$db->getEscaped( $filter->text, true ).'%', false );
					$wheres2 	= array();
					$wheres2[] 	= 'j.listingid LIKE '.$text;
					$where 		= '(' . implode( ') OR (', $wheres2 ) . ')';
					break;

				case 'all':
				case 'any':
				default:
					$words = explode( ' ', $filter->text );
					$wheres = array();
					foreach ($words as $word) {
						$word		= $db->Quote( '%'.$db->getEscaped( $word, true ).'%', false );
						$wheres2 	= array();
						$wheres2[] 	= 'j.title LIKE '.$word;
						$wheres2[] 	= 'j.description LIKE '.$word;
						$wheres2[] 	= 'j.alias LIKE '.$word;
						$wheres2[] 	= 'j.keywords LIKE '.$word;
						$wheres2[] 	= 'j.tags LIKE '.$word;
						$wheres2[] 	= 'j.price LIKE '.$word;
						$wheres2[] 	= 's.title LIKE '.$word;
						$wheres2[] 	= 'c.title LIKE '.$word;

						$wheres[] 	= implode( ' OR ', $wheres2 );
					}
					$where = '(' . implode( ($filter->phrase == 'all' ? ') AND (' : ') OR ('), $wheres ) . ')';
					break;
			}

		} else {
			/**
			 * Searching on every fields
			 */
				$words = explode( ' ', $filter->text );
				$wheres = array();
				foreach ($words as $word) {
					$word		= $db->Quote( '%'.$db->getEscaped( $word, true ).'%', false );
					$wheres2 	= array();
					$wheres2[] 	= 'j.listingid LIKE '.$word;
					$wheres2[] 	= 'j.title LIKE '.$word;
					$wheres2[] 	= 'j.description LIKE '.$word;
					$wheres2[] 	= 'j.alias LIKE '.$word;
					$wheres2[] 	= 'j.keywords LIKE '.$word;
					$wheres2[] 	= 'j.tags LIKE '.$word;
					$wheres2[] 	= 'j.price LIKE '.$word;
					$wheres2[] 	= 's.title LIKE '.$word;
					$wheres2[] 	= 'c.title LIKE '.$word;
					$wheres2[] 	= 'lc.title LIKE '.$word;
					$wheres2[] 	= 'st.title LIKE '.$word;
					$wheres2[]  .= " (j.id IN (SELECT e.adid from #__jllist_extrafields as e left join #__jlextrafields as f on f.id=e.fieldid" .
				" WHERE e.fieldvalue LIKE ".$word." ))";

					$wheres[] 	= implode( ' OR ', $wheres2 );
				}
				$where = '(' . implode(  ') OR (', $wheres ) . ')';
		}
		return $where;
    }
    
	function getListingsByUser($uid, $limitstart, $limit){
		$settings = JoomListingsFactory::getSettings();
		$db =& JFactory::getDBO();
		$query = "SELECT j.*, (SELECT image FROM #__jlimages WHERE adid = j.id ORDER BY ordering limit 1) as image";
		if($settings->enable_regions){
			$query .= ", (SELECT title FROM #__jlstates WHERE id = j.rid) as ad_region";
		}
		if($settings->enable_sections){
			$query .= ", (SELECT title FROM #__jlsections WHERE id = j.sectionid) as ad_section";
		}
		
		$query .= ", (SELECT title FROM #__jlcategories WHERE id = j.catid) as ad_category";
		$query .= " FROM #__joomlistings as j where j.userid='$uid' AND published='1' and expirydate>=curdate() ORDER BY j.featured desc, j.postdate desc limit $limitstart,$limit ";
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		if(count($rows)>0)
		{
			for($i=0,$n=count($rows);$i<$n;$i++)
			{
				$r =& $rows[$i];
				$query2 = "SELECT e.*,f.* from #__jllist_extrafields as e left join #__jlextrafields as f on f.id=e.fieldid";
				$db->setQuery($query2);
				$r->extrafields = $db->loadObjectList();
				
				$query = "SELECT SUM(total_vote) AS sum_total_vote FROM #__jllisting_star WHERE listing_id = ". $r->id;
				$db->setQuery($query);
				$fv = $db->loadObjectList();
				$sum_total_vote = $fv[0]->sum_total_vote;
				
				$query3 = "SELECT SUM(star_value * total_vote) / $sum_total_vote AS aver FROM #__jllisting_star WHERE listing_id = ". $r->id;
				$db->setQuery($query3);
				$aver = $db->loadObjectList();
				$r->star_average = $aver[0]->aver;
			}
		}
		return $rows;
	}

	function getCountListingsByUser($uid)
	{
		$db =& JFactory::getDBO();
		$query = "SELECT count(*) FROM #__joomlistings as j WHERE j.userid='$uid' AND published='1' AND expirydate>=curdate()";
		$db->setQuery($query);
		return $db->loadResult();
	}
}
?>
