<?php
/*************************************************
Author: JoomClan.com
Creation Date: 2009-11-25
Author Email: joomclan@gmail.com
Url: http://www.joomclan.com
Copyright: 2009-2010
License: GNU
Component Version: 2.1.7
Software License: All of our PHP and HTML source code is released under the GNU General Public License (GPL) to ensure it is 100% compatible with Joomla!.
The GPL is the world's most popular Free (as in Freedom) and Open Source Software license.
Some javascript and other media (images, css, ajax scripts, flv players, mp3 players etc …) may be released under different licenses. Please see the details with the individual products.
**************************************************/

defined('_JEXEC') or die('Restricted access');
jimport("joomla.application.component.model");

class JoomlistingsModelPackages extends JModel
{
	function getAvailablePackages($if=0){
		global $option;
		$db=JFactory::getDBO();
		if($if){
			$query="SELECT * from #__jlpackages where published='1' order by ordering, price desc";
		}
		else{
			$query="SELECT * from #__jlpackages where published='1' and isfree='0' order by ordering, price desc";
		}
		$db->setQuery($query);
		return $db->loadObjectList();
	}

	function getPackageDetail($pid){
		$db =& JFactory::getDBO();
		$query = "SELECT * FROM #__jlpackages WHERE id='$pid'";
		$db->setQuery($query);
		return $db->loadObject();
	}

	function addPackageToUser($userid, $package){
		
		$packageinfo = $this->getPackageInfoOfUserPaid($userid, $package->id);
		
		$row = JTable::getInstance('userpackage','Table');
		$row->userid = $userid;
		$row->packageid = $package->id;
		if($package->id == $packageinfo->packageid){
			$adsnumber = ($packageinfo->adsnumber) + $package->adsnumber;
		}
		else{
			$adsnumber = $package->adsnumber;
		}
		if($package->days != -1){
			$exdate = date("Y-m-d G:i:s", strtotime( "$packageinfo->boughtdate + $package->days days"));
		}else{
			$exdate	= -1;
		}
		$row->expirydate = $exdate;
		$row->boughtdate = date("Y-m-d G:i:s");
		$row->adsnumber	= $adsnumber;
		$row->published	= 1;
		return $row->store($packageinfo);
	}

	function alertPackageExpiry($userid,$settings){
		$db =& JFactory::getDBO();
		$days=$settings->expiry_alert_days;
		$query="SELECT up.*, p.days  from #__jlusers_packages as up INNER JOIN #__jlpackages as p ON " .
				" up.packageid = p.id where up.userid='$userid' order by up.boughtdate desc limit 1";
		$db->setQuery($query);
		$pkg = $db->loadObject();
		if($pkg->days >-1){
			$query="SELECT count(*) from #__jlusers_packages as up INNER JOIN #__jlpackages as p ON up.packageid = p.id WHERE (expirydate <> '-1' AND expirydate > curdate()) and up.userid='$userid' AND up.published = 1";
		}
		else{
			$query="SELECT count(*) from #__jlusers_packages as up where up.userid='$userid'";
		}
		$db->setQuery($query);
		return $db->loadResult();
	}

	function isPackageExpired($userid)
	{
		$db=JFactory::getDBO();
		$query="SELECT count(*) from #__jlusers_packages as up where DATE_ADD(up.boughtdate,INTERVAL up.validdays DAY)>curdate() and up.userid='$userid'";
		$db->setQuery($query);
		return $db->loadResult();
	}

/*	function getPackageInfoOfUser($uid)
	{
		global $option,$mainframe;
		$db=JFactory::getDBO();

		$query="SELECT * from #__jlusers_packages where userid='$uid' order by boughtdate desc limit 1";
		$db->setQuery($query);
		$pkg=$db->loadObject();

		if($pkg->validdays>-1)
		{
		 $query="SELECT up.*,DATEDIFF(curdate(),up.boughtdate) as leftdays,
		 (select sum(adsused) from #__jluser_package_track as t where t.userid=up.userid) as used
		 from #__jlusers_packages as up where up.userid='$uid' and
		 DATE_ADD(up.boughtdate,INTERVAL up.validdays DAY)>curdate()  order by up.boughtdate desc limit 1";
		}
		else
		{
			 $query="SELECT up.*,DATEDIFF(curdate(),up.boughtdate) as leftdays,
			 (select sum(adsused) from #__jluser_package_track as t where t.userid=up.userid) as used
			 from #__jlusers_packages as up where up.userid='$uid'  order by up.boughtdate desc limit 1";
		}
		 $db->setQuery($query);
		 $obj= $db->loadObject();
		 return $obj;

	}*/

	function getPackageInfoOfUser($uid, $pid=''){
		//return null;
		global $option, $mainframe;
		$db =& JFactory::getDBO();
		$settings = JoomListingsFactory::getSettings();
		$today = date('Y-m-d H:i:s');
		$query  = "SELECT up.packageid, up.boughtdate, up.expirydate, p.*, up.adsnumber AS adsnumber, ";
		$query .= "(SELECT sum(adsused) FROM #__jluser_package_track AS t WHERE t.userid = up.userid AND t.pid = up.packageid) AS used, ";
 		$query .= "DATEDIFF('$today', up.boughtdate) AS leftdays ";
 		$query .= "FROM #__jlusers_packages AS up, #__jlpackages AS p ";
 		$query .= "WHERE up.userid='$uid' ";
 		$query .= "AND up.packageid = p.id ";
 		if($pid != ''){
 			$query .="AND up.packageid = '$pid'";
 		}
 		$query .= "AND p.published = 1 AND up.archived = 0 ";
 		$query .= "ORDER BY up.boughtdate DESC ";
 		$db->setQuery($query);
 		
 		return $db->loadObjectList();
	}

	function getUserPackage($uid)
	{
		global $option,$mainframe;
		$objs = $this->getPackageInfoOfUser($uid);
		$settings = JoomListingsFactory::getSettings();
		if(count($obj) < 1 && $settings->enable_packages ){
			$link = JRoute::_("index.php?option=$option&c=package&task=free");
			$mainframe->redirect($link);
		}
		else{
			return $objs;
		}
	}

	function getFreePackage(){
		$db=JFactory::getDBO();
		$query="SELECT * from #__jlpackages where isfree='1' and published='1'";
		$db->setQuery($query);
		return $db->loadObject();
	}
	
	function assignFreePackage($userid){
		$packageinfo = $this->getPackageInfoOfUser($userid);
		$package = $this->getFreePackage();
		$row = JTable::getInstance('userpackage','Table');
		$row->userid		=	$userid;
		$row->packageid 	=	$package->id;
		$row->boughtdate	=	date("Y-m-d G:i:s");
		$row->published		=	1;
		if($package->days == -1){
			$row->expirydate	=  -1;
		}else{
			$row->expirydate	=  date('Y-m-d G:i:s', strtotime("+ $package->days days"));
		}
        $row->adsnumber		=	$package->adsnumber;
		if($row->store($packageinfo)){
			return $packageinfo;
		}
		else{
			return false;
		}
	}
	
	function removeUserPackageTrack($userid, $pid){
//		$query = "UPDATE #__jluser_package_track SET adsused = 0 WHERE userid = '$userid' AND pid = '$pid'";
//		$this->_db->setQuery($query);
//		$this->_db->query();
	}
	
	function getPackageInfoOfUserPaid($userid, $pid){
		$today = date('Y-m-d H:i:s');
		$sql = "SELECT up.packageid, up.boughtdate, up.adsnumber, up.userid FROM #__jlusers_packages AS up WHERE userid = '$userid' AND packageid = '$pid'";
		$sql .= " ORDER BY up.boughtdate DESC LIMIT 0,1";
		$this->_db->setQuery($sql);
		$obj = $this->_db->loadObject();
		return $obj;
	}
	
	function getSectionOfCategoryPackage($pid){
		require_once JPATH_ADMINISTRATOR . DS . 'components'. DS . 'com_joomlistings' . DS . 'helpers'. DS .  'tree.php';
		$query = "SELECT * FROM #__jlsections AS s WHERE s.id IN (SELECT DISTINCT(section_id) FROM #__jlcategories WHERE id IN(SELECT category_id FROM #__jlcategory_package WHERE package_id = '$pid'))";
		$this->_db->setQuery($query);
		$rows = $this->_db->loadObjectList();
		if(count($rows)>0){
			$i=0;
			for($i=0,$n=count($rows);$i<$n;$i++){
				$r =& $rows[$i];
				$query2 = "SELECT c.* ";
				$query2 .="FROM #__jlcategories as c WHERE published = 1 AND c.section_id = ".$r->id. " ";
				$query2 .="ORDER BY c.parent_id ASC"; //order by c.parent_id very important
				$this->_db->setQuery($query2);
				$categories = $this->_db->loadObjectList();
				$Itemid = JLHelper::getBaseItemid();
				$tree = new pvgTree2(new pvgNode2(0));
				if($categories){
					foreach ($categories as $cat){
						$link = JRoute::_("index.php?option=com_joomlistings&c=listing&cid={$cat->id}&Itemid={$Itemid}");
						$node = new pvgNode2($cat->id, $cat->id, $cat->title, $cat->parent_id, $link, $cat->adcount);
						$tree->appendChild($cat->parent_id, $node);
					}
					$r->categories = $tree->renderTree2($r->id, false, false);
				}else{
					$r->categories = '';
				}
			}
		}
		
		return $rows;
	}
	
	function getSectionCategoryPopbox($pid){
		require_once JPATH_ADMINISTRATOR . DS . 'components'. DS . 'com_joomlistings' . DS . 'helpers'. DS .  'tree.php';
		$query = "SELECT * FROM #__jlsections AS s WHERE s.id IN (SELECT DISTINCT(section_id) FROM #__jlcategories WHERE id IN(SELECT category_id FROM #__jlcategory_package WHERE package_id = '$pid'))";
		$this->_db->setQuery($query);
		$rows = $this->_db->loadObjectList();
		for($j = 0 ; $j < count($rows); $j++){
			$rows[$j]->categories = '';
			$query2 = "SELECT c.* ";
			$query2 .="FROM #__jlcategories as c WHERE published = 1 AND id IN(SELECT category_id FROM #__jlcategory_package WHERE package_id = '$pid') AND section_id = ".$rows[$j]->id ;
			$query2 .=" ORDER BY c.parent_id ASC"; //order by c.parent_id very important
			$this->_db->setQuery($query2);
			$categories = $this->_db->loadObjectList();
			$Itemid = JLHelper::getBaseItemid();
			$tree = new pvgTree2(new pvgNode2(0));
			if($categories){
				foreach ($categories as $cat){
					$link = JRoute::_("index.php?option=com_joomlistings&c=listing&cid={$cat->id}&Itemid={$Itemid}");
					$node = new pvgNode2($cat->id, $cat->id, $cat->title, $cat->parent_id, $link, 0, $cat->section_id);
					$tree->appendChild($cat->parent_id, $node);
				}
			}
			$rows[$j]->categories = $tree->renderTree22(0, false, false);
		}
		$ret = array();
		for($j = 0 ; $j < count($rows); $j++){
			if($rows[$j]->categories != ''){
				$ret[] = $rows[$j];
			}
		}
		return $ret;
	}
	
}
?>