<?php
/*************************************************
Author: JoomClan.com
Creation Date: 2009-11-25
Author Email: joomclan@gmail.com
Url: http://www.joomclan.com
Copyright: 2009-2010
License: GNU
Component Version: 2.1.7
Software License: All of our PHP and HTML source code is released under the GNU General Public License (GPL) to ensure it is 100% compatible with Joomla!. 
The GPL is the world's most popular Free (as in Freedom) and Open Source Software license.
Some javascript and other media (images, css, ajax scripts, flv players, mp3 players etc …) may be released under different licenses. Please see the details with the individual products.
**************************************************/

defined('_JEXEC') or die('Restricted access');
jimport("joomla.application.component.model");

class JoomlistingsModelPayment extends JModel
{
	function getPlugins()
	{
		global $option;

		$pluginfolder=JPATH_ADMINISTRATOR.DS."components".DS.$option.DS."plugins";
		$folders=JFolder::folders($pluginfolder);
		return $folders;
	}

	function getPaymentPluginsWitBill($bill,$returnurl)
	{
		global $option;

		$pluginfolder=JPATH_ADMINISTRATOR.DS."components".DS.$option.DS."plugins";
		$folders=JFolder::folders($pluginfolder);
		$plugins=array();
		if(count($folders)>0)
		{
			foreach($folders as $f)
			{
				require_once($pluginfolder.DS.$f.DS.$f.'.plg.php');
				$clsName="PaymentPlugin".ucfirst($f);
				$plg=new $clsName();
				$plg->setBill($bill);
				$plg->setReturnUrl($returnurl);
				$plg->folder=$f;
				$plugins[]=$plg;
			}
		}
		return $plugins;
	}

	function howMuchToPay(&$userinfo,&$settings,$ad=null,$feature=null,$color=null)
	{
		$pay = new stdClass();
		if($settings->enable_packages)
		{
			//pay from package
			if($userinfo->hasPost>0||$userinfo->hasPost<=-1){
				$pay->ad=0;
				if($settings->feature_payable&&$feature){
					$pay->feature=$userinfo->priceforfeatured;
				}
				else{
					$pay->feature=0;
				}
				$deduct=0;
				if($settings->cumulative_pricing&&$pay->feature){
					$deduct = $pay->feature;
				}
				if($settings->orange_payable&&$color==1){
					$pay->color = $userinfo->pricefororange - $deduct;
				}
				elseif($settings->red_payable&&$color==2){
					$pay->color = $userinfo->priceforred - $deduct;
				}
				elseif($settings->bold_payable&&$color==3){
					$pay->color = $userinfo->priceforbold - $deduct;
				}
				else
				{
					$pay->color=0;
				}
			}
			else
			{
				//If you dont have package pay per ad price which ofcourse should be hefty
				if($ad)
				{
					$pay->ad=$settings->price_per_ad;
				}
				else
				{
					$pay->ad=0;
				}

				if($settings->feature_payable&&$feature)
				{
					$pay->feature=$settings->featured_price;
				}
				else
				{
					$pay->feature=0;
				}

				if($settings->orange_payable&&$color==1)
				{
					$pay->color=$userinfo->pricefororange;
				}
				elseif($settings->red_payable&&$color==2)
				{
					$pay->color=$userinfo->priceforred;

				}
				elseif($settings->red_payable&&$color==3)
				{
					$pay->color=$userinfo->priceforbold;

				}
				else
				{
					$pay->color=0;
				}
			}


		}
		elseif($settings->payable)
		{

			//Pay for ad and featured
			if($ad)
			{
				$pay->ad=$settings->price_per_ad;
			}
			else
			{
				$pay->ad=0;
			}
			if($settings->feature_payable&&$feature)
			{
				$pay->feature=$settings->featured_price;
			}
			else
			{
				$pay->feature=0;
			}

			if($settings->orange_payable&&$color==1)
			{
				$pay->color=$userinfo->pricefororange;
			}
			elseif($settings->red_payable&&$color==2)
			{
				$pay->color=$userinfo->priceforred;
					
			}
			elseif($settings->bold_payable&&$color==3)
			{
				$pay->color=$userinfo->priceforbold;
					
			}
			else
			{
				$pay->color=0;
			}
		}
		else
		{
			//Pay only for featured others are free
			$pay->ad=0;
			if($settings->feature_payable&&$feature)
			{
				$pay->feature=$settings->featured_price;
			}
			else
			{
				$pay->feature=0;
			}
				
			if($settings->orange_payable&&$color==1)
			{
				$pay->color=$userinfo->pricefororange;
			}
			elseif($settings->red_payable&&$color==2)
			{
				$pay->color=$userinfo->priceforred;
					
			}
			elseif($settings->bold_payable&&$color==3)
			{
				$pay->color=$userinfo->priceforbold;
					
			}
			else
			{
				$pay->color=0;
			}
		}
		return $pay;
	}


}
?>