<?php 
/*************************************************
Author: JoomClan.com
Creation Date: 2009-11-25
Author Email: joomclan@gmail.com
Url: http://www.joomclan.com
Copyright: 2009-2010
License: GNU
Component Version: 2.1.7
Software License: All of our PHP and HTML source code is released under the GNU General Public License (GPL) to ensure it is 100% compatible with Joomla!. 
The GPL is the world's most popular Free (as in Freedom) and Open Source Software license.
Some javascript and other media (images, css, ajax scripts, flv players, mp3 players etc …) may be released under different licenses. Please see the details with the individual products.
**************************************************/

defined('_JEXEC') or die('Restricted access');
jimport("joomla.application.component.model");

class JoomlistingsModelRegion extends JModel {

    function getSettings() {
        $db = JFactory::getDBO();
        $query = "SELECT * from #__jlsettings";
        $db->setQuery($query);
        $cls = new stdClass ();
        $rows = $db->loadObjectList();
        if (count($rows) > 0) {
            foreach ($rows as $r) {
                $key = $r->configkey;
                $cls->$key = $r->configvalue;
            }
        }
        
        return $cls;
    }
    function getRegionsWithLocations() {
        $db = JFactory::getDBO();
        $query = "SELECT * from #__jlstates where published='1' order by ordering";
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        $sess = $this->getRegion();
        if (count($rows) > 0) {
            for ($i = 0; $i < count($rows); $i++) {
                $r = &$rows[$i];
                $query2 = "SELECT x.*,
                		  (SELECT COUNT(*) from #__joomlistings AS l where l.lid = x.id AND l.published='1' AND l.expirydate>=curdate())
                		  AS adcount
                		  FROM #__jllocations as x where region_id='$r->id' and published='1'";
                $db->setQuery($query2);
                $r->categories = $db->loadObjectList();
            }
        }
        return $rows;
        
    }
    
    function getSectionsWithCategories() {
        $db = JFactory::getDBO();
        $query = "SELECT * from #__jlsections where published='1' order by ordering, title";
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        
        if (count($rows) > 0) {
            $i = 0;
            for ($i = 0, $n = count($rows); $i < $n; $i++) {
                $r = $rows[$i];
                $query2 = "SELECT * from #__jlcategories where section_id='$r->id' and published='1' order by ordering, title";
                
                $db->setQuery($query2);
                $r->categories = $db->loadObjectList();
            }
        }
        
        return $rows;
    }
    
    function setRegion($cls) {
        $session = &JFactory::getSession();
        $session->set('jrid', $cls->rid);
        $session->set('jlid', $cls->lid);
        $session->set('jnid', $cls->nid);
        $user =& JFactory::getUser();
        $userid = $user->get('id');
        if ($userid) {
            $utable = JTable::getInstance('profile', 'Table');
            $utable->setRegion($userid, $cls->rid, $cls->lid, $cls->nid);
        }
    }
    
    function getRegion() {
    
        $settings = JoomListingsFactory::getSettings();
        if ((int) $settings->enable_regions) {
            $session = JFactory::getSession();
            $sess = new stdClass ();
            $sess->rid = 0;
            $sess->lid = 0;
            $sess->nid = 0;
            $db = JFactory::getDBO();
            if ($session->has('jrid') && $session->has('jlid')) {
                $sess->rid = $session->get('jrid');
                $query = "SELECT title from #__jlstates where id='$sess->rid'";
                $db->setQuery($query);
                $sess->region = $db->loadResult();
                
                $sess->lid = $session->get('jlid');
                $query = "SELECT title from #__jllocations where id='$sess->lid'";
                $db->setQuery($query);
                $sess->location = $db->loadResult();
                
                if($settings->enable_neighbor){
	                $sess->nid = $session->get('jnid');
	                $query = "SELECT title from #__jlneighbors where id='$sess->nid'";
	                $db->setQuery($query);
	                $sess->neighbor = $db->loadResult();
                }
            } else {
                $user = JFactory::getUser();
                $userid = $user->get('id');
                if ($userid) {
                    $utable = JTable::getInstance('profile', 'Table');
                    $rxd = $utable->getRegion($userid);

                    if ($rxd) {
                        $sess->rid = $rxd->rid;
                        $query = "SELECT title from #__jlstates where id='$sess->rid'";
                        $db->setQuery($query);
                        $sess->region = $db->loadResult();
                        
                        $sess->lid = $rxd->lid;
                        $query = "SELECT title from #__jllocations where id='$sess->lid'";
                        $db->setQuery($query);
                        $sess->location = $db->loadResult();
                        
                        $sess->nid = $rxd->nid;
                        $query = "SELECT title from #__jllocations where id='$sess->nid'";
                        $db->setQuery($query);
                        $sess->neighbor = $db->loadResult();
                        
                        $session = &JFactory::getSession();
                        $session->set('jrid', $rxd->rid);
                        $session->set('jlid', $rxd->lid);
                        $session->set('jnid', $rxd->nid);
                    }
                }

                
            }
            
            return $sess;
        } else {

        
            $sess = new stdClass ();
            $sess->rid = 0;
            $sess->lid = 0;
            $sess->jrid = 0;
            $sess->jlid = 0;
            $db = JFactory::getDBO();
            $query = "SELECT l.id as lid,l.title as ltitle,s.id as rid,s.title as rtitle from #__jllocations as l
			left join #__jlstates as s on l.region_id=s.id where l.published='1' and l.default_location='1' limit 1";
            $db->setQuery($query);
            $obj = $db->loadObject();
            if ($obj) {
                $sess->rid = $obj->rid;
                $sess->lid = $obj->lid;
                $sess->jrid = $obj->rid;
                $sess->jlid = $obj->lid;
                $sess->location = $obj->ltitle;
                $sess->region = $obj->rtitle;
            } else {
            
                return false;
            }
            
            return $sess;
            
        }
    }
    
    public function getRidByCode($rcode){
    	$query = "SELECT id from #__jlstates where code='".$rcode."' AND published = '1'";
    	$rows = $this->_getList($query);
    	$row = $rows[0];
    	return $row->id;
    }
    
    public function getLocationIdByName($location_name, $rid){
    	// get from database
    	$query = "SELECT id from #__jllocations where published = '1' AND region_id = '".$rid."' AND title = '".$location_name."'";
    	$rows = $this->_getList($query);
    	if(count($rows) > 0){
    		$row = $rows[0];
    		return $row->id;
    	}
    	// if not exist then add new location
    	else{
    		$query = "INSERT INTO #__jllocations(id,title, published, default_location, region_id) VALUES ('','".$location_name."', '1', '0','".$rid."')";
    		$this->_db->setQuery($query);
    		$this->_db->query();
    		return $this->_db->insertid();
    	}
    }
    
}
?>
