<?php 
/*************************************************
Author: JoomClan.com
Creation Date: 2009-11-25
Author Email: joomclan@gmail.com
Url: http://www.joomclan.com
Copyright: 2009-2010
License: GNU
Component Version: 2.1.7
Software License: All of our PHP and HTML source code is released under the GNU General Public License (GPL) to ensure it is 100% compatible with Joomla!. 
The GPL is the world's most popular Free (as in Freedom) and Open Source Software license.
Some javascript and other media (images, css, ajax scripts, flv players, mp3 players etc …) may be released under different licenses. Please see the details with the individual products.
**************************************************/
defined('_JEXEC') or die('Restricted access');

include_once('includes/jlroute.helper.php');
 
function JoomlistingsBuildRoute(&$query) {

    $segments = array();
    
    // get a menu item based on Itemid or currently active
    $menu = &JSite::getMenu();
    if ( empty($query['Itemid'])) {
        $menuItem = &$menu->getActive();
    } else {
        $menuItem = &$menu->getItem($query['Itemid']);
    }
    
	if(isset($query['c'])){
        switch ($query['c']){
        	case 'ad':
        		$segments[] = 'ad';
        		unset($query['c']);
        		if(isset($query['task'])){
        			$segments[] = $query['task'];
        			unset($query['task']);
        		}
        		if(isset($query['cid'])){
        			$segments[] = $query['cid'];
        			unset($query['cid']);
        		}
        		if(isset($query['adid'])){
        			$segments[] = $query['adid'];
        			unset($query['adid']);
        		}
        		break;
        	case 'directory':
        		//$segments[] = 'directory';
        		unset($query['c']);
        		if(isset($query['task'])){
        			$segments[] = $query['task'];
        			unset($query['task']);
        		}
        		break;
        	case 'image':
        		$segments[] = 'image';
        		break;
        	case 'listing':
        		$segments[] = 'listing';
        		unset($query['c']);
        		if(isset($query['cid'])){
        			$segments[] = $query['cid'];
        			unset($query['cid']);
        		}
        		if(isset($query['type'])){
        			if($query['type']==1){
        				$segments[] = 'all';
        			}
        			unset($query['type']);
        		}
        		if(isset($query['layout'])){
        			$segments[] = substr($query['layout'], 1, strlen($query['layout']));
        			unset($query['layout']);
        		}
        		
        		break;
        	case 'message':
        		$segments[] = 'message';
        		unset($query['c']);
        		if(isset($query['task'])){
        			$segments[] = $query['task'];
        			unset($query['task']);
        		}
        		if(isset($query['id'])){
        			$segments[] = $query['id'];
        			unset($query['id']);
        		}
        		break;
        	case 'package':
        		unset($query['c']);
        		$title = '';
        		if($query['task'] == 'pay'){
        			$title = 'buy-package';
        		}
        		if($query['task'] == 'subscribe'){
        			$title = 'subscribe-package';
        		}
        		if($query['task'] == 'paid'){
        			$title = 'paid-package';
        		}
        		if($query['task'] == 'popbox'){
        			$title = 'popbox-package';
        		}
        		if($query['task'] == 'upgrade'){
        			$title = 'upgrade-package';
        		}
        		if($query['task'] == 'renew'){
        			$title = 'renew-package';
        		}
				$segments[] = $title;
				unset($query['task']);
        		if(isset($query['pid'])){
        			$segments[] = $query['pid'];
        			unset($query['pid']);
        		}
        		break;
        	case 'payment':
        		$segments[] = 'payment';
        		if(isset($query['task'])){
        			$segments[] = $query['task'];
        			unset($query['task']);
        		}
        		if(isset($query['uid'])){
        			$segments[] = $query['uid'];
        			unset($query['uid']);
        		}
        		if(isset($query['inurl'])){
        			$segments[] = $query['inurl'];
        			unset($query['inurl']);
        		}
        		unset($query['c']);
        		break;
        	case 'profile':
        		$segments[] = 'profile';
        		break;
        	case 'search':
        		$segments[] = 'search';
        		break;
        	}
        }
        if( isset($query['view']) ) {
            switch($query['view']) {
                case 'ad':
           			if(isset($query['layout'])){
                    	$segments[] = $query['layout'];
                    	unset($query['layout']);
                    }
                	if(isset($query['pid'])){
                    	$segments[] = $query['pid'];
                    	unset($query['pid']);
                    }
            		
                    break;
               	case 'transaction':
               		$segments[] = 'transaction';
                case 'listing':
                	//if(isset($query['cid'])){
                	//	$segments[] = $query['cid'];
                	//}
                    break;
                case 'directory':
                case 'message':
                    break;
                case 'myads':
                case 'mypackage':
                case 'profile':
               	case 'wishlist':
               	case 'packages':
               		$segments[] = $query['view'];
               		break;
                    
            }
            unset($query['view']);
        }
    
    return $segments;

    
}

function JoomlistingsParseRoute(&$segments) {
    $vars = array();
    $vars['c'] = $segments[0];
    //var_dump($segments);die();
    switch(count($segments)){
    	case 2:
    		if($segments[0]=='post'){
    			$vars['view'] = 'ad';
    			$vars['layout'] = 'post';
    			$vars['pid'] = $segments[1];
    			unset($vars['c']);
    		}
    		if($segments[0]=='buy:package'){
    			$vars['c'] = 'package';
    			$vars['task'] = 'pay';
    			$vars['pid'] = $segments[1];
    		}
    		if($segments[0]=='subscribe:package'){
    			$vars['c'] = 'package';
    			$vars['task'] = 'subscribe';
    			$vars['pid'] = $segments[1];
    		}
    		if($segments[0]=='paid:package'){
    			$vars['c'] = 'package';
    			$vars['task'] = 'paid';
    			$vars['pid'] = $segments[1];
    		}
    		if($segments[0]=='popbox:package'){
    			$vars['c'] = 'package';
    			$vars['task'] = 'popbox';
    			$vars['pid'] = $segments[1];
    		}
    		if($segments[0]=='renew:package'){
    			$vars['c'] = 'package';
    			$vars['task'] = 'renew';
    			$vars['pid'] = $segments[1];
    		}
    		if($segments[0]=='payment'){
    			$vars['c'] = 'payment';
    			if($segments[1] == 'confirm' || $segments[1] == 'cancel'){
    				$vars['task'] = $segments[1];
    			}
    		}
    		if($segments[0]=='ad'){
    			$vars['c'] = 'ad';
    			if($segments[1] == 'catpacksec' || $segments[1] == 'ef' || $segments[1] == 'rw'){
    				$vars['task'] = $segments[1];
    			}
    		}
    		if($segments[0]=='message'){
    			$vars['c'] = 'message';
    			if($segments[1] == 'inbox' || $segments[1] == 'notification'){
    				$vars['task'] = $segments[1];
    			}
    		}
    		break;
    	case 3:
    		if($segments[0]=='ad'){
    			$vars['c'] = 'ad';
    			if($segments[1] == 'edit' || $segments[1] == 'del'){
    				$vars['task'] = $segments[1];
    				$vars['cid'] = $segments[2];
    			}
    			if($segments[1] == 'view'){
    				$vars['task'] = $segments[1];
    				$vars['adid'] = $segments[2];
    			}
    		}
    		if($segments[0]=='message'){
    			$vars['c'] = 'message';
    			if($segments[1] == 'detail' || $segments[1] == 'compose'){
    				$vars['task'] = $segments[1];
    				$vars['id'] = $segments[2];
    			}
    		}
    		break;
    		break;
    	case 4:
    		if($segments[0]=='payment'){
    			$vars['c'] = 'payment';
    			if($segments[1] == 'success' || $segments[1] == 'notify'){
    				$vars['task'] = $segments[1];
    				$vars['uid'] = $segments[2];
    				$vars['inurl'] = $segments[3];
    			}
    		}
    		break;
    	default:
    }
	if($segments[0]=='listing'){
    	$vars['c'] = 'listing';
    	if(isset($segments[1])){
    		if(is_numeric($segments[1])){
    			$vars['cid'] = $segments[1];
    		}else{
    			$vars['type'] = 1;
    		}
    	}
    	if(isset($segments[2])){
    		$vars['layout'] = "_".$segments[2];
    	}
    }
    //$vars['view'] = $segments[0];
    if(isset($vars['c']) && $vars['c'] == 'transaction'){
    	$vars['view'] = 'transaction';
    	unset($vars['c']);
    }
	if(isset($vars['c']) && $vars['c'] == 'section'){
    	$vars['c'] = 'directory';
    	$vars['task'] = 'section';
    }
	if(isset($vars['c']) && $vars['c'] == 'change'){
    	$vars['c'] = 'directory';
    	$vars['task'] = 'change';
    }
	if(isset($vars['c']) && $vars['c'] == 'select'){
    	$vars['c'] = 'directory';
    	$vars['task'] = 'select';
    }
    // Itemid problem here --> need to set item id of the link "index.php?option=com_joomlistings&view=ad&layout=post" to the menu 'post-ad'
	if(isset($vars['c']) && $vars['c'] == 'post'){
    	unset($vars['c']);
    	$vars['view'] = 'ad';
    	$vars['layout'] = 'post';
    }
	if(isset($vars['c']) && $vars['c']=='upgrade:package'){
    	$vars['c'] = 'package';
    	$vars['task'] = 'upgrade';
    }
	if(isset($vars['c']) && $vars['c']=='packages'){
		unset($vars['c']);
    	$vars['view'] = 'packages';
    }
	if(isset($vars['c']) && $vars['c']=='myads'){
		unset($vars['c']);
    	$vars['view'] = 'myads';
    }
//    var_dump($vars);die();
    return $vars;
}


?>
