--
-- Table structure for table `jos_jlcategories`
--

CREATE TABLE IF NOT EXISTS `jos_jlcategories` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `published` varchar(2) NOT NULL,
  `description` text NOT NULL,
  `ordering` int(100) NOT NULL,
  `alias` varchar(50) NOT NULL,
  `parent_id` int(10) unsigned DEFAULT NULL,
  `section_id` int(10) unsigned DEFAULT NULL,
  `hideef` tinyint(4) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Table structure for table `jos_jlcategory_package`
--

CREATE TABLE IF NOT EXISTS `jos_jlcategory_package` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `category_id` int(11) NOT NULL,
  `package_id` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Table structure for table `jos_jllisting_star`
--

CREATE TABLE IF NOT EXISTS `jos_jllisting_star` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `listing_id` int(11) NOT NULL,
  `star_id` int(11) NOT NULL,
  `star_value` int(11) NOT NULL,
  `total_vote` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Table structure for table `jos_jlneighbors`
--

CREATE TABLE IF NOT EXISTS `jos_jlneighbors` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `published` varchar(2) NOT NULL,
  `description` text NOT NULL,
  `ordering` int(100) NOT NULL,
  `code` varchar(50) NOT NULL,
  `location_id` int(10) unsigned NOT NULL,
  `region_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


-- --------------------------------------------------------

--
-- Table structure for table `jos_jlpackages`
--

CREATE TABLE IF NOT EXISTS `jos_jlpackages` (
  `id` tinyint(3) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) DEFAULT NULL,
  `currency` varchar(10) NOT NULL,
  `price` float(10,2) unsigned DEFAULT NULL,
  `adsnumber` int(10) DEFAULT NULL,
  `impressions` int(10) DEFAULT NULL,
  `clicks` int(10) DEFAULT NULL,
  `days` int(10) DEFAULT NULL,
  `listing_days` int(10) DEFAULT NULL,
  `isfree` tinyint(3) unsigned DEFAULT NULL,
  `published` tinyint(3) unsigned DEFAULT NULL,
  `ordering` int(10) unsigned DEFAULT NULL,
  `description` text,
  `imagesnumber` int(11) NOT NULL,
  `showcontact` tinyint(4) NOT NULL,
  `enablesubscription` tinyint(1) NOT NULL,
  `priceforfeatured` float(10,2) NOT NULL,
  `currencysymbol` varchar(20) NOT NULL,
  `pricefororange` float NOT NULL,
  `priceforred` float NOT NULL,
  `priceforbold` float NOT NULL,
  `enable_video` tinyint(4) NOT NULL,
  `title_max` int(11) NOT NULL,
  `description_max` int(11) NOT NULL,
  `enable_upload_video_doc` tinyint(1) NOT NULL DEFAULT '0',
  `num_upload_per_ad` int(11) NOT NULL DEFAULT '3',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Table structure for table `jos_jlreports`
--

CREATE TABLE IF NOT EXISTS `jos_jlreports` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ad_id` varchar(100) NOT NULL,
  `reason_id` varchar(1000) NOT NULL,
  `published` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Table structure for table `jos_jlreport_reasons`
--

CREATE TABLE IF NOT EXISTS `jos_jlreport_reasons` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL,
  `description` varchar(1000) NOT NULL,
  `published` tinyint(1) NOT NULL,
  `ordering` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

INSERT INTO `jos_jlreport_reasons` (`id`, `title`, `description`, `published`, `ordering`) VALUES
(null, 'Fraud', 'Fraud', 1, 1),
(null, 'Offensive', 'Offensive', 1, 2),
(null, 'Scam', 'Scam', 1, 3),
(null, 'Spam', 'Spam', 1, 4),
(null, 'Duplicate', 'Duplicate', 1, 5),
(null, 'No Longer Available', 'No Longer Available', 1, 6),
(null, 'Outdated', 'Outdated', 1, 7),
(null, 'Wrong Category', 'Wrong Category', 1, 8),
(null, 'Copyright or Trademark Violation', 'Copyright or Trademark Violation', 1, 9);

-- --------------------------------------------------------

--
-- Table structure for table `jos_jlsections`
--

CREATE TABLE IF NOT EXISTS `jos_jlsections` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `published` varchar(2) NOT NULL,
  `description` text NOT NULL,
  `ordering` int(11) NOT NULL,
  `alias` varchar(50) NOT NULL,
  `parent_id` int(10) unsigned DEFAULT NULL,
  `default_section` int(11) NOT NULL,
  `image_of_section` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


-- --------------------------------------------------------

--
-- Table structure for table `jos_jlstars`
--

CREATE TABLE IF NOT EXISTS `jos_jlstars` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `value` int(11) NOT NULL,
  `title` varchar(50) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;


-- --------------------------------------------------------

--
-- Table structure for table `jos_jlusers_packages`
--


CREATE TABLE IF NOT EXISTS `jos_jlusers_packages` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userid` int(11) NOT NULL,
  `packageid` int(11) NOT NULL,
  `boughtdate` datetime NOT NULL,
  `adsnumber` int(4) NOT NULL DEFAULT '0',
  `archived` tinyint(4) NOT NULL DEFAULT '0',
  `published` tinyint(4) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


-- --------------------------------------------------------

--
-- Table structure for table `jos_jluser_subscribes`
--

CREATE TABLE IF NOT EXISTS `jos_jluser_subscribes` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `subscr_id` varchar(20) NOT NULL,
  `subscribe_date` datetime NOT NULL,
  `next_update_user_package` datetime NOT NULL,
  `cancelled` tinyint(1) NOT NULL,
  `cancel_date` datetime DEFAULT NULL,
  `pid` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

-- --------------------------------------------------------

--
-- Table structure for table `jos_jlvdocs`
--


CREATE TABLE IF NOT EXISTS `jos_jlvdocs` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `adid` int(11) NOT NULL,
  `filename` varchar(255) NOT NULL,
  `fileext` varchar(5) NOT NULL,
  `originname` varchar(255) NOT NULL,
  `user_id` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=5 ;


-- --------------------------------------------------------

--
-- Table structure for table `jos_joomlistings`
--

CREATE TABLE IF NOT EXISTS `jos_joomlistings` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `listingid` varchar(20) NOT NULL,
  `title` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `published` int(2) NOT NULL,
  `ordering` int(11) NOT NULL,
  `alias` varchar(20) NOT NULL,
  `catid` int(10) unsigned DEFAULT NULL,
  `userid` int(10) unsigned DEFAULT NULL,
  `keywords` varchar(255) DEFAULT NULL,
  `currency` varchar(50) DEFAULT NULL,
  `price` float(12,2) unsigned DEFAULT NULL,
  `postdate` datetime DEFAULT NULL,
  `expirydate` datetime DEFAULT NULL,
  `glat` float unsigned DEFAULT NULL,
  `glng` float unsigned DEFAULT NULL,
  `status` tinyint(4) NOT NULL,
  `type` varchar(255) NOT NULL,
  `tags` varchar(255) NOT NULL,
  `sectionid` int(11) NOT NULL,
  `rid` int(11) NOT NULL,
  `lid` int(11) NOT NULL,
  `address` text NOT NULL,
  `featured` tinyint(4) NOT NULL DEFAULT '0',
  `currencysymbol` varchar(20) NOT NULL,
  `hideef` tinyint(4) NOT NULL,
  `listingtype` tinyint(4) NOT NULL,
  `externalvideo` text NOT NULL,
  `metadesc` text NOT NULL,
  `has_images` tinyint(4) NOT NULL DEFAULT '0',
  `postal_code` varchar(10) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;



DROP PROCEDURE IF EXISTS AddColumns

delimiter //

CREATE PROCEDURE AddColumns() BEGIN

IF not exists (select * from information_schema.COLUMNS where table_name = 'jos_jlprofiles' and column_name = 'nid') THEN
ALTER TABLE `jos_jlprofiles` ADD `nid` int(11) DEFAULT NULL;
END IF;

IF not exists (select * from information_schema.COLUMNS where table_name = 'jos_jlcategories' and column_name = 'meta_keyword') THEN
ALTER TABLE `jos_jlcategories` ADD `meta_keyword` text NOT NULL;
END IF;

IF not exists (select * from information_schema.COLUMNS where table_name = 'jos_jlcategories' and column_name = 'meta_description') THEN
ALTER TABLE `jos_jlcategories` ADD `meta_description` text NOT NULL;
END IF;

IF not exists (select * from information_schema.COLUMNS where table_name = 'jos_jlcategories' and column_name = 'enable_twitter') THEN
ALTER TABLE `jos_jlcategories` ADD `enable_twitter` tinyint(1) NOT NULL DEFAULT '1';
END IF;

IF not exists (select * from information_schema.COLUMNS where table_name = 'jos_jlpackages' and column_name = 'listing_days') THEN
ALTER TABLE `jos_jlpackages` ADD `listing_days` int(10) NOT NULL DEFAULT '5';
END IF;

IF not exists (select * from information_schema.COLUMNS where table_name = 'jos_jlpackages' and column_name = 'enablesubscription') THEN
ALTER TABLE `jos_jlpackages` ADD `enablesubscription` tinyint(1) NOT NULL DEFAULT '0';
END IF;

IF not exists (select * from information_schema.COLUMNS where table_name = 'jos_jlpackages' and column_name = 'priceforbold') THEN
ALTER TABLE `jos_jlpackages` ADD `priceforbold` float NOT NULL;
END IF;

IF not exists (select * from information_schema.COLUMNS where table_name = 'jos_jlpackages' and column_name = 'title_max') THEN
ALTER TABLE `jos_jlpackages` ADD `title_max` int(11) NOT NULL DEFAULT '100';
END IF;

IF not exists (select * from information_schema.COLUMNS where table_name = 'jos_jlpackages' and column_name = 'description_max') THEN
ALTER TABLE `jos_jlpackages` ADD `description_max` int(11) NOT NULL DEFAULT '400';
END IF;

IF not exists (select * from information_schema.COLUMNS where table_name = 'jos_jlpackages' and column_name = 'enable_upload_video_doc') THEN
ALTER TABLE `jos_jlpackages` ADD `enable_upload_video_doc` tinyint(1) NOT NULL DEFAULT '0';
END IF;

IF not exists (select * from information_schema.COLUMNS where table_name = 'jos_jlpackages' and column_name = 'num_upload_per_ad') THEN
ALTER TABLE `jos_jlpackages` ADD `num_upload_per_ad` int(11) NOT NULL DEFAULT '3';
END IF;

IF not exists (select * from information_schema.COLUMNS where table_name = 'jos_jlpackages' and column_name = 'enable_video') THEN
ALTER TABLE `jos_jlpackages` ADD `enable_video` tinyint(4) NOT NULL;
END IF;

IF not exists (select * from information_schema.COLUMNS where table_name = 'jos_jlsections' and column_name = 'meta_keyword') THEN
ALTER TABLE `jos_jlsections` ADD `meta_keyword` text NOT NULL;
END IF;

IF not exists (select * from information_schema.COLUMNS where table_name = 'jos_jlsections' and column_name = 'meta_description') THEN
ALTER TABLE `jos_jlsections` ADD `meta_description` text NOT NULL;
END IF;

IF not exists (select * from information_schema.COLUMNS where table_name = 'jos_jlusers_packages' and column_name = 'expirydate') THEN
ALTER TABLE `jos_jlusers_packages` ADD `expirydate` varchar(19) DEFAULT NULL;
END IF;

IF not exists (select * from information_schema.COLUMNS where table_name = 'jos_jlusers_packages' and column_name = 'archived') THEN
ALTER TABLE `jos_jlusers_packages` ADD `archived` tinyint(4) DEFAULT NULL;
END IF;

IF not exists (select * from information_schema.COLUMNS where table_name = 'jos_joomlistings' and column_name = 'nid') THEN
ALTER TABLE `jos_joomlistings` ADD `nid` int(11) NOT NULL;
END IF;

IF not exists (select * from information_schema.COLUMNS where table_name = 'jos_joomlistings' and column_name = 'pid') THEN
ALTER TABLE `jos_joomlistings` ADD `pid` int(11) NOT NULL;
END IF;

IF not exists (select * from information_schema.COLUMNS where table_name = 'jos_joomlistings' and column_name = 'hits') THEN
ALTER TABLE `jos_joomlistings` ADD `hits` int(11) NOT NULL;
END IF;

IF not exists (select * from information_schema.COLUMNS where table_name = 'jos_joomlistings' and column_name = 's_unique') THEN
ALTER TABLE `jos_joomlistings` ADD `s_unique` varchar(15) NOT NULL;
END IF;

IF not exists (select * from information_schema.COLUMNS where table_name = 'jos_joomlistings' and column_name = 'privacy') THEN
ALTER TABLE `jos_joomlistings` ADD `privacy` text NOT NULL;
END IF;

IF not exists (select * from information_schema.COLUMNS where table_name = 'jos_jlusers_packages' and column_name = 'archived') THEN
ALTER TABLE `jos_jlusers_packages` ADD `archived` tinyint(4) NOT NULL default '0';
END IF;

IF not exists (select * from information_schema.COLUMNS where table_name = 'jos_joomlistings' and column_name = 'listingid') THEN
ALTER TABLE `jos_joomlistings` ADD `listingid` VARCHAR( 20 ) NOT NULL AFTER `id` ;
END IF;

IF not exists (select * from information_schema.COLUMNS where table_name = 'jos_joomlistings' and column_name = 'postal_code') THEN
ALTER TABLE `jos_joomlistings` ADD `postal_code` VARCHAR( 10 ) NULL ;

END IF;

IF not exists (select * from information_schema.COLUMNS where table_name = 'jos_joomlistings' and column_name = 'address') THEN
ALTER TABLE `jos_joomlistings` ADD `address` text NULL ;
END IF;

IF not exists (select * from information_schema.COLUMNS where table_name = 'jos_jlsections' and column_name = 'image_of_section') THEN
ALTER TABLE `jos_jlsections` ADD `image_of_section` VARCHAR( 255 ) NULL ;
END IF;

END;

//

delimiter ;

CALL AddColumns();

DROP PROCEDURE AddColumns;

DROP PROCEDURE IF EXISTS JLUpdateSettingTable;

delimiter //

CREATE PROCEDURE JLUpdateSettingTable() BEGIN

UPDATE `jos_jlsettings` SET `settings_group` = '3<sup>rd</sup> Party Component Integration' WHERE `settings_group` = 'JomSocial';

END;

//

delimiter ;

CALL JLUpdateSettingTable();
DROP PROCEDURE JLUpdateSettingTable;


DROP PROCEDURE IF EXISTS JLInserts;

delimiter //

CREATE PROCEDURE JLInserts() BEGIN

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='enable_colorbox_default_style') THEN
INSERT INTO `jos_jlsettings` VALUES (null, 'enable_colorbox_default_style', '1', 'Enable colorbox default popup style', 'boolean', 'Base Fields', 0);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='show_listings_ratings') THEN
INSERT INTO `jos_jlsettings` VALUES (null, 'show_listings_ratings', '1', 'Show Listings Ratings', 'boolean', 'Base Fields', 10);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='show_hit_counter') THEN
INSERT INTO `jos_jlsettings` VALUES (null, 'show_hit_counter', '1', 'Show Hit Counter', 'boolean', 'Base Fields', 15);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='can_guest_vote') THEN
INSERT INTO `jos_jlsettings` VALUES (null, 'can_guest_vote', '1', 'Enable Guest to post Rating', 'boolean', 'Base Fields', 11);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='bold_payable') THEN
INSERT INTO `jos_jlsettings` VALUES (null, 'bold_payable', '1', 'Bold Listing Payable', 'boolean', 'Pay per post', 12);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='price_for_bold') THEN
INSERT INTO `jos_jlsettings` VALUES (null, 'price_for_bold', '0', 'Price for Bold Listings', '', 'Pay per post', 13);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='upload_extension_allow') THEN
INSERT INTO `jos_jlsettings` VALUES (null, 'upload_extension_allow', 'txt|mkv|flv|zip|bmp|jpg|png', 'Allowable Extension for Upload (|) seperated', '', 'Package', 9);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='cb_integration') THEN
INSERT INTO `jos_jlsettings` VALUES (null, 'cb_integration', '0', 'Integrate with CB', 'boolean', '3<sup>rd</sup> Party Component Integration', 10);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='cb_profile') THEN
INSERT INTO `jos_jlsettings` VALUES (null, 'cb_profile', '0', 'Use profile of CB', 'boolean', '3<sup>rd</sup> Party Component Integration', 11);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='cb_info_order') THEN
INSERT INTO `jos_jlsettings` VALUES (null, 'cb_info_order', 'NAME|CB_GENDER|CB_BIRTHDAY|FIELD_COUNTRY|FIELD_WEBSITE ', 'CB Profile - Contact info order', '', '3<sup>rd</sup> Party Component Integration', 12);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='cb_show_users') THEN
INSERT INTO `jos_jlsettings` VALUES (null, 'cb_show_users', '1', 'CB Profile - Show Users Listings', 'boolean', '3<sup>rd</sup> Party Component Integration', 13);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='cb_show_last') THEN
INSERT INTO `jos_jlsettings` VALUES (null, 'cb_show_last', '1', 'CB Profile - Show Last 20 Listings', 'boolean', '3<sup>rd</sup> Party Component Integration', 14);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='cb_use messaging') THEN
INSERT INTO `jos_jlsettings` VALUES (null, 'cb_use messaging', '1', 'Use Messaging System of CB', 'boolean', '3<sup>rd</sup> Party Component Integration', 15);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='enable_neighbor') THEN
INSERT INTO `jos_jlsettings` VALUES (null, 'enable_neighbor', '1', 'Enable Neighbor', 'boolean', 'Base Fields', 4);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='bgcolor_bold') THEN
INSERT INTO `jos_jlsettings` VALUES (null, 'bgcolor_bold', '#d9d9d9', 'Background color for Bold Listing', '', 'Colors', 10);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='fgcolor_bold') THEN
INSERT INTO `jos_jlsettings` VALUES (null, 'fgcolor_bold', '#f5f5f5', 'Foreground color for Bold Listing', '', 'Colors', 11);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='border_bold') THEN
INSERT INTO `jos_jlsettings` VALUES (null, 'border_bold', '#333333', 'Border color for Bold Listing', '', 'Colors', 12);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='twitter_consumer_key') THEN
INSERT INTO `jos_jlsettings` VALUES (null, 'twitter_consumer_key', '9G20QqaXlcnTwedjB88G1w', 'Twitter Consumer Key', '', '3<sup>rd</sup> Party Component Integration', 100);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='twitter_consumer_secret') THEN
INSERT INTO `jos_jlsettings` VALUES (null, 'twitter_consumer_secret', 'eLclAQ910eHbILFJ7qSJxJDDSq4OoaWocMQH0B9gmIY', 'Twitter Consumer Secret', '', '3<sup>rd</sup> Party Component Integration', 101);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='twitter_oauth_token') THEN
INSERT INTO `jos_jlsettings` VALUES (null, 'twitter_oauth_token', '50242548-A9vJLCQnlqdvEoGQNhlqHJ9yn4MzMUhFRXP6yFaFf', 'Twitter Oauth Token', '', '3<sup>rd</sup> Party Component Integration', 102);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='twitter_oauth_token_secret') THEN
INSERT INTO `jos_jlsettings` VALUES (null, 'twitter_oauth_token_secret', 'wTEBoKC1S8rQ1OnDwbrCtPzP7rvEGoZx0bVAsPAk', 'Twitter Oauth Token Secret', '', '3<sup>rd</sup> Party Component Integration', 103);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='form_twitter_status') THEN
INSERT INTO `jos_jlsettings` VALUES (null, 'form_twitter_status', 'link-text', 'Format of tweet', 'twitter', '3<sup>rd</sup> Party Component Integration', 106);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='twitter_base_url') THEN
INSERT INTO `jos_jlsettings` VALUES (null, 'twitter_base_url', 'http://desibigboys.com/', 'Base url to show on twitter', '', '3<sup>rd</sup> Party Component Integration', 105);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='show_privacy') THEN
INSERT INTO `jos_jlsettings` VALUES (null, 'show_privacy', '1', 'Show Privacy or Disclaimer', 'boolean', 'Base Fields', 20);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='show_listing_posted_date') THEN
INSERT INTO `jos_jlsettings` VALUES (null, 'show_listing_posted_date', '1', 'Show Listings Posted Date', 'boolean', 'Base Fields', 21);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='show_listing_expiry_date') THEN
INSERT INTO `jos_jlsettings` VALUES (null, 'show_listing_expiry_date', '1', 'Show Listings Expiry Date', 'boolean', 'Base Fields', 22);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='show_image_of_sections') THEN
INSERT INTO `jos_jlsettings` VALUES ('', 'show_image_of_sections', '1', 'Enable Section Images', 'boolean', 'General', 0);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='show_unique_id') THEN
INSERT INTO `jos_jlsettings` VALUES ('', 'show_unique_id', '1', 'show unique id', 'boolean', 'Base Fields', 0);
END IF;


IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='show_contact_friend') THEN
INSERT INTO `jos_jlsettings` VALUES ('', 'show_contact_friend', '1', 'show contact friend', 'boolean', 'Base Fields', 0);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='show_address') THEN
INSERT INTO `jos_jlsettings` VALUES ('', 'show_address', '1', 'show address', 'boolean', 'Base Fields', 0);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='show_zipcode') THEN
INSERT INTO `jos_jlsettings` VALUES ('', 'show_zipcode', '1', 'show zip code', 'boolean', 'Base Fields', 0);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='show_wishlist') THEN
INSERT INTO `jos_jlsettings` VALUES ('', 'show_wishlist', '1', 'show add to wishlist link', 'boolean', 'Base Fields', 0);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='enable_anti_spam') THEN
INSERT INTO `jos_jlsettings` VALUES ('', 'enable_anti_spam', '0', 'Enable anti spam services', 'boolean', 'Anti Spam Services', 0);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='captcha_public_key') THEN
INSERT INTO `jos_jlsettings` VALUES ('', 'captcha_public_key', '', 'reCaptcha Public Key', 'text', 'Anti Spam Services', 0);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='captcha_private_key') THEN
INSERT INTO `jos_jlsettings` VALUES ('', 'captcha_private_key', '', 'reCaptcha Private Key', 'text', 'Anti Spam Services', 0);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='show_posted_user') THEN
INSERT INTO `jos_jlsettings` VALUES ('', 'show_posted_user', '1', 'Show posted user', 'boolean', 'Base Fields', 0);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='collapse_front_end') THEN
INSERT INTO `jos_jlsettings` VALUES ('', 'collapse_front_end', '1', 'Collapse Front End Template', 'boolean', 'General', 0);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='integrate_googlemap') THEN
INSERT INTO `jos_jlsettings` VALUES ('', 'integrate_googlemap', '1', 'Google Map Integration', 'boolean', 'Google Maps Integration', 0);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='integrate_googlemap_latlong') THEN
INSERT INTO `jos_jlsettings` VALUES ('', 'integrate_googlemap_latlong', '57.627366;-101.601563', 'Google Map Innitial LatLong', 'text', 'Google Maps Integration', 0);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='integrate_googlemap_key') THEN
INSERT INTO `jos_jlsettings` VALUES ('', 'integrate_googlemap_key', 'ABQIAAAAMWek7Ve5QFfvLs7pELti6BTpffECC9dAxeBPWm6uQ3nZbx0YJBRHwiShcaV-4Tp6xkVOqD4D0XnADw', 'Google Map Key', 'text', 'Google Maps Integration', 0);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='slider_speed') THEN
INSERT INTO `jos_jlsettings` VALUES ('', 'slider_speed', '1000', 'Image Slider Speed', 'text', 'Base Fields', 0);
END IF;

IF not exists (SELECT * FROM jos_jlsettings WHERE `configkey`='enable_colorbox_default_style') THEN
INSERT INTO `jos_jlsettings` VALUES ('', 'enable_colorbox_default_style', '1', 'Enable colorbox default popup style', 'boolean', 'Base Fields', 0);
END IF;

END;

//

delimiter ;

CALL JLInserts();
DROP PROCEDURE JLInserts;

DROP PROCEDURE IF EXISTS JLChanges;

delimiter //

CREATE PROCEDURE JLChanges() BEGIN

IF exists (select * from information_schema.COLUMNS where table_name = 'jos_joomlistings' and column_name = 'glat') THEN
ALTER TABLE `jos_joomlistings` CHANGE `glat` `glat` DOUBLE NOT NULL DEFAULT 0;
END IF;

IF exists (select * from information_schema.COLUMNS where table_name = 'jos_joomlistings' and column_name = 'glng') THEN
ALTER TABLE `jos_joomlistings` CHANGE `glng` `glng` DOUBLE NOT NULL DEFAULT 0;
END IF;

END;

//

delimiter ;

CALL JLChanges();
DROP PROCEDURE JLChanges;


DROP PROCEDURE IF EXISTS JLDrop;

delimiter //

CREATE PROCEDURE JLDrop() BEGIN

IF exists (select * from information_schema.COLUMNS where table_name = 'jos_jlusers_packages' and column_name = 'title') THEN
ALTER TABLE `jos_jlusers_packages` DROP `title`;
END IF;

IF exists (select * from information_schema.COLUMNS where table_name = 'jos_jlusers_packages' and column_name = 'price') THEN
ALTER TABLE `jos_jlusers_packages` DROP `price`;
END IF;

IF exists (select * from information_schema.COLUMNS where table_name = 'jos_jlusers_packages' and column_name = 'currency') THEN
ALTER TABLE `jos_jlusers_packages` DROP `currency`;
END IF;

IF exists (select * from information_schema.COLUMNS where table_name = 'jos_jlusers_packages' and column_name = 'validdays') THEN
ALTER TABLE `jos_jlusers_packages` DROP `validdays`;
END IF;

IF exists (select * from information_schema.COLUMNS where table_name = 'jos_jlusers_packages' and column_name = 'priceforfeatured') THEN
ALTER TABLE `jos_jlusers_packages` DROP `priceforfeatured`;
END IF;

IF exists (select * from information_schema.COLUMNS where table_name = 'jos_jlusers_packages' and column_name = 'imagesnumber') THEN
ALTER TABLE `jos_jlusers_packages` DROP `imagesnumber`;
END IF;

IF exists (select * from information_schema.COLUMNS where table_name = 'jos_jlusers_packages' and column_name = 'isfree') THEN
ALTER TABLE `jos_jlusers_packages` DROP `isfree`;
END IF;

IF exists (select * from information_schema.COLUMNS where table_name = 'jos_jlusers_packages' and column_name = 'pricefororange') THEN
ALTER TABLE `jos_jlusers_packages` DROP `pricefororange`;
END IF;

IF exists (select * from information_schema.COLUMNS where table_name = 'jos_jlusers_packages' and column_name = 'priceforred') THEN
ALTER TABLE `jos_jlusers_packages` DROP `priceforred`;
END IF;

IF exists (select * from information_schema.COLUMNS where table_name = 'jos_jlusers_packages' and column_name = 'enable_video') THEN
ALTER TABLE `jos_jlusers_packages` DROP `enable_video`;
END IF;

END;

//

delimiter ;

CALL JLDrop();
DROP PROCEDURE JLDrop;

DROP TABLE IF EXISTS `jos_jlversion`;
CREATE TABLE IF NOT EXISTS `jos_jlversion` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL,
  `version` varchar(25) NOT NULL,
  `dlastModified` datetime default NULL,
  `szLastModifiedBy` varchar(30) default NULL,
  `dCreatedOn` datetime NOT NULL,
  `szCreatedBy` varchar(30) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

INSERT INTO `jos_jlversion` VALUES( null, 'JoomListings', '2.1.8', curdate( ) , 'JoomClan', curdate( ) , 'JoomClan');

DROP TABLE IF EXISTS `jos_jlstars`;
CREATE TABLE IF NOT EXISTS `jos_jlstars` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `value` int(11) NOT NULL,
  `title` varchar(50) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

INSERT INTO `jos_jlstars` (`id`, `value`, `title`) VALUES
(1, 1, 'Poor'),
(2, 2, 'Not that bad'),
(3, 3, 'Average'),
(4, 4, 'Good'),
(5, 5, 'Perfect');